<<<<<<<<<; 3D rotating bobs (old version)
;								TAS / feb1992

DEMOSTARTUP = 0


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  matrix tabel			$40000	$50000
*  screens			$50000	$5c000

 INCLUDE chipmap.inc
 ORG $30700
 LOAD $30700
sintabel = $27800
>EXTERN "DF0:sin1024.data",sintabel


width = 42

ytabel	= $6e000
vectab	= $6f000
xtabel	= $61000
;xypos	= $6e800

size = 272*width*2
screen1 = $62000
screen2 = screen1+size

antal = 90

txtscreen = $5b000

BLTW:	MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	 IFEQ DEMOSTARTUP
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)
	move.w	#$0200,$100(a6)

	lea	ytabel,a0 
	moveq	#0,d0
	move.w	#269,d7
.ytab	move.w	d0,(a0)+
	addi.w	#width*2,d0
	dbf	d7,.ytab

	lea	xtabel,a0
	moveq	#0,d0
	move.w	#335,d7
.xtab	move.w	d0,d1
	lsr.w	#4,d1
	lsl.w	#1,d1
	move.w	d1,(a0)+
	move.w	d0,d1
	andi.w	#$f,d1
	ror.w	#4,d1
	ori.w	#$0dfc,d1
	move.w	d1,(a0)+
	addq.w	#1,d0
	dbf	d7,.xtab

	lea	txtscreen,a0
	move.l	#40*256,d0
	bsr.W	clear

	lea	screen1,a0
	move.l	#size*2,d0
	bsr.W	clear

	lea	vectab,a0
	moveq	#-128,d0
	moveq	#7,d3
.tab1	moveq	#-128,d1
.tab2	move.w	d1,d2
	muls	d0,d2
	asr.w	d3,d2
	move.b	d2,(a0)+
	addq.w	#1,d1
	cmpi.w	#128,d1
	bne.S	.tab2
	addq.w	#1,d0
	cmpi.w	#128,d0
	bne.S	.tab1

	 REM
	lea	xypos,a0
	move.w	#[antal*3]-1,d7
	moveq	#0,d0
.rnd1	move.w	$6(a6),d0
	mulu	d1,d0
	addi.w	#$1249,d0
	move.b	d0,(a0)+
	clr.b	(a0)+
	move.w	d0,d1
	dbf	d7,.rnd1
	 ENDREM


	move.w	#$120,d0
	bsr.W	RC
	lea	cp(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83f0,$96(a6)

*-----------------------*
*	MAIN LOOP	*

ML
	move.w	#$128,d0
	bsr.W	RC

	bsr.B	T1
	lea	DMA,a6
	bsr.W	controlroom
	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	.exit
	 ENDC
	tst.w	quit
	beq.B	ML

.exit	BLTW
	moveq	#0,d0
	rts

quit:	dc.w 0


*----------------------------
* TASK 1 - 3D rotating stars

T1:	lea	display(pc),a0
	movem.l	(a0),a1/a2
	exg	a1,a2
	movem.l	a1/a2,(a0)
	lea	CPptrs(pc),a0
	move.l	a2,d0
	swap	d0
	move.w	d0,10(a0)
	move.w	a2,14(a0)
	adda.w	#width,a2
	move.l	a2,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a2,6(a0)

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.w	#2,BLTDMOD(a6)
	move.l	display(pc),a0
	move.l	a0,BLTDPT(a6)
	move.w	#300<<6+20,BLTSIZE(a6)
	move.l	a7,stack
	lea	512*42(a0),a7
	movem.l	clrregs(pc),d0-d7
	movem.l	clrregs(pc),a0-a6
	 QREPT [212*42]/60
	movem.l	d0-a6,-(a7)
	 ENDQR
	movem.l	d0-a6,-(a7)
	lea	DMA,a6
	move.l	stack(pc),a7

	bsr.W	matrix_calc

	lea	xypos,a0
	lea	vectab+$8080,a5
	move.l	display(pc),a2
	suba.w	#[26*width]+2,a2
	lea	ytabel,a3
	lea	xtabel,a4
	moveq	#8,d6
	move.w	#antal-1,d7
	move.l	sp,stack
	BLTW
	move.l	#$FFFF0000,BLTAFWM(a6)
	clr.w	BLTAMOD(a6)
	move.w	#width-4,BLTBMOD(a6)
	move.w	#width-4,BLTDMOD(a6)
	clr.w	BLTCON1(a6)
	adda.w	#BLTBPT,a6
starloop:
	subq.b	#5,4(a0)
	movem.w	(a0)+,d3-d5
matrix	move.b	$00(a5,d3.W),d0
	move.b	$00(a5,d4.W),d1
	ext.w	d0
	ext.w	d1
	add.w	d1,d0
	move.b	$00(a5,d5.W),d1
	ext.w	d1
	add.w	d1,d0

	move.b	$00(a5,d3.W),d1
	move.b	$00(a5,d4.W),d2
	ext.w	d1
	ext.w	d2
	add.w	d2,d1
	move.b	$00(a5,d5.W),d2
	ext.w	d2
	add.w	d2,d1

	move.b	$00(a5,d3.W),d2
	move.b	$00(a5,d4.W),d3
	ext.w	d2
	ext.w	d3
	add.w	d3,d2
	move.b	$00(a5,d5.W),d3
	ext.w	d3
	add.w	d3,d2

	ext.l	d0
	ext.l	d1
	asl.l	d6,d0
	asl.l	d6,d1
	addi.w	#256,d2
;	bmi.B	.next
	divs	d2,d0
	divs	d2,d1

	addi.w	#168,d0
	addi.w	#134,d1
	cmpi.w	#336,d0
	bhs.B	.next
	cmpi.w	#269,d1
	bhs.B	.next

	add.w	d0,d0
	add.w	d0,d0
	add.w	d1,d1
	move.w	(a3,d1.W),d1
	add.w	(a4,d0.W),d1
	move.w	2(a4,d0.W),d0
	lea	(a2,d1.W),a1
	move.l	a6,a7

	cmpi.w	#400,d2
	ble.B	.star2
	lea	13*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star1+4,(a7)+
	move.l	a1,(a7)+
	move.w	#1<<6+2,(a7)
.next	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.star2	cmpi.w	#350,d2
	ble.B	.star3
	lea	10*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star2,(a7)+
	move.l	a1,(a7)+
	move.w	#6<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.star3	cmpi.w	#300,d2
	ble.B	.star4
	lea	8*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star3,(a7)+
	move.l	a1,(a7)+
	move.w	#10<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.star4	cmpi.w	#250,d2
	ble.B	.star5
	lea	6*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star4,(a7)+
	move.l	a1,(a7)+
	move.w	#14<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.star5	cmpi.w	#200,d2
	ble.B	.star6
	lea	4*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star5,(a7)+
	move.l	a1,(a7)+
	move.w	#18<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.star6	cmpi.w	#150,d2
	ble.B	.star7
	lea	2*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star6,(a7)+
	move.l	a1,(a7)+
	move.w	#22<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.star7	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star7,(a7)+
	move.l	a1,(a7)+
	move.w	#26<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts


* TASK 1 data
stack:		dc.l 0
display:	dc.l screen1,screen2
vectorxy:	dc.w 0,0,0, 0,0,0



*-------------
* MATRIX CALC

matrix_calc
	lea	vectorxy(pc),a4
	movem.w	6(a4),d0-d2
	add.w	d0,(a4)
	add.w	d1,2(a4)
	add.w	d2,4(a4)

	lea	sintabel,a1
	lea	256(a1),a2
	movem.w	(a4),d0-d2
	move.w	#$3fe,d3
	andi.w	d3,d0
	andi.w	d3,d1
	andi.w	d3,d2
	move.w	(a1,d0.W),.calc4+2
	move.w	(a1,d0.W),.calc4+6
	move.w	(a2,d0.W),.calc4+10
	move.w	(a2,d0.W),.calc4+14
	move.w	(a1,d1.W),.calc5+2
	move.w	(a1,d1.W),.calc5+6
	move.w	(a2,d1.W),.calc5+10
	move.w	(a2,d1.W),.calc5+14
	move.w	(a1,d2.W),.calc3+2
	move.w	(a1,d2.W),.calc3+6
	move.w	(a2,d2.W),.calc3+10
	move.w	(a2,d2.W),.calc3+14

	lea	.matrixpos+4(pc),a0
	lea	matrix_vectors(pc),a1
	moveq	#2,d7
.matrixloop
	movem.w	(a0),d0-d2
	move.w	d1,d4
	move.w	d0,d3
.calc3	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d1
	sub.l	d4,d0
	add.l	d3,d1
	add.l	d0,d0
	swap	d0
	add.l	d1,d1
	swap	d1
	move.w	d2,d4
	move.w	d1,d3
.calc4	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d1
	muls	#$0000,d2
	sub.l	d4,d1
	add.l	d3,d2
	add.l	d1,d1
	swap	d1
	add.l	d2,d2
	swap	d2
	move.w	d2,d4
	move.w	d0,d3
.calc5	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d2
	sub.l	d4,d0
	add.l	d3,d2
	add.l	d0,d0
	swap	d0
	add.l	d2,d2
	swap	d2
	move.w	d2,12(a1)
	move.w	d1,6(a1)
	move.w	d0,(a1)+
	subq.l	#2,a0
	dbf	d7,.matrixloop

	lea	matrix_vectors(pc),a1
	lea	matrix(pc),a0
	moveq	#7,d3
	moveq	#2,d7
.ins	movem.w	(a1)+,d0-d2
	asr.w	d3,d0
	asr.w	d3,d1
	asr.w	d3,d2
	move.b	d0,3(a0)
	move.b	d1,7(a0)
	move.b	d2,17(a0)
	adda.w	#22,a0
	dbf	d7,.ins
	rts

* MATRIX data
.matrixpos	dc.w 0,0,$3FFF,0,0
matrix_vectors	ds.w 9


*--------------*
* CONTROL ROOM *

controlroom:
	lea	counter(pc),a0
	move.w	(a0),d0
	addq.w	#1,(a0)

	cmp.w	#31,d0
	bhs.B	.fadein
	move.w	d0,-(sp)
	move.w	d0,d3
	lsr.w	#1,d3
	lea	CPcolors(pc),a0
	move.w	#$47e,d0
	bsr.W	fade
	move.w	d0,2(a0)
	move.w	#$FFF,d0
	bsr.W	fade
	move.w	d0,6(a0)
	move.w	#$149,d0
	bsr.W	fade
	move.w	d0,10(a0)
	move.w	(sp)+,d0
.fadein

	lea	starloop(pc),a0
	lea	vectorxy+6(pc),a1
	cmp.w	#134,d0
	bne.B	.stage1a
	move.l	#$59280004,(a0)	; SUBQ.B #4,4(a0)
.stage1a
	cmp.w	#138,d0
	bne.B	.stage1b
	move.l	#$57280004,(a0)	; SUBQ.B #3,4(a0)
.stage1b
	cmp.w	#1482,d0
	bne.B	.stage1c
	move.l	#$55280004,(a0)	; SUBQ.B #2,4(a0)
.stage1c
	cmp.w	#146,d0
	bne.B	.stage1d
	move.l	#$53280004,(a0)	; SUBQ.B #1,4(a0)
.stage1d
	cmp.w	#150,d0
	bne.B	.stage2
	move.l	#$4e714e71,(a0)	; NOP
	move.w	#6,(a1)
	move.w	#4,2(a1)
	move.w	#2,4(a1)
.stage2
	cmp.w	#750,d0
	bne.B	.stage3
	move.l	#$57280004,(a0)	; SUBQ.B #3,4(a0)
.stage3

	cmp.w	#1600,d0
	blo.B	.fadedown
	move.w	d0,-(sp)
	move.w	d0,d3
	sub.w	#1600,d3
	not.w	d3
	and.w	#$1f,d3
	lsr.w	#1,d3
	lea	CPcolors(pc),a0
	move.w	#$47e,d0
	bsr.W	fade
	move.w	d0,2(a0)
	move.w	#$FFF,d0
	bsr.W	fade
	move.w	d0,6(a0)
	move.w	#$149,d0
	bsr.W	fade
	move.w	d0,10(a0)
	move.w	#$FFF,d0
	bsr.W	fade
	move.w	d0,14(a0)
	move.w	(sp)+,d0
.fadedown
	cmp.w	#1631,d0
	beq.B	.quit
	rts
.quit:	move.w	#-1,quit
	rts

* CONTROL data
counter:	dc.w 0


*--------*
*  DATA  *
*--------*
intregs		ds.w 2
clrregs		blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e2881,$009028c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.l $01080002+width,$010a0000
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
CPcolors:
 dc.l $0182047E,$01840FFF,$01860149
 dc.l $01920fff
CPptrs:
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.w $00e8,screen1/$10000,$00ea,screen1&$ffff
 dc.w $00e4,txtscreen/$10000,$00e6,txtscreen&$ffff
 dc.l $2801fffe,$01003600
; dc.l $ffe1fffe
; dc.l $2801fffe,$01000200
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

fade:	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f,d0
	andi.w	#$f0,d1
	andi.w	#$f00,d2
	mulu	d3,d0
	mulu	d3,d1
	mulu	d3,d2
	andi.w	#$f0,d0
	andi.w	#$f00,d1
	andi.w	#$f000,d2
	or.w	d1,d0
	or.w	d2,d0
	lsr.w	#4,d0
	rts


*----------*
* STJERNER *

star1:	dc.w	%0000000000000000,0,%0000000100000000,0

star2:	dc.w	%0000000100000000,0,%0000000100000000,0
	dc.w	%0000001010000000,0,%0000001110000000,0
	dc.w	%0000000100000000,0,%0000000100000000,0

star3:	dc.w	%0000001110000000,0,%0000001110000000,0
	dc.w	%0000010111000000,0,%0000011111000000,0
	dc.w	%0000011101000000,0,%0000011111000000,0
	dc.w	%0000011001000000,0,%0000011111000000,0
	dc.w	%0000001110000000,0,%0000001110000000,0

star4:	dc.w	%0000001110000000,0,%0000001110000000,0
	dc.w	%0000010111000000,0,%0000011111000000,0
	dc.w	%0000101011100000,0,%0000110111100000,0
	dc.w	%0000110110100000,0,%0000111111100000,0
	dc.w	%0000111100100000,0,%0000111111100000,0
	dc.w	%0000011001000000,0,%0000011111000000,0
	dc.w	%0000001110000000,0,%0000001110000000,0

star5:	dc.w	%0000001110000000,0,%0000001110000000,0
	dc.w	%0000101111100000,0,%0000111111100000,0
	dc.w	%0000010111100000,0,%0000101111100000,0
	dc.w	%0001101111010000,0,%0001111111110000,0
	dc.w	%0001111111010000,0,%0001111111110000,0
	dc.w	%0001111110010000,0,%0001111111110000,0
	dc.w	%0000111100000000,0,%0000111111100000,0
	dc.w	%0000110000100000,0,%0000111111100000,0
	dc.w	%0000001110000000,0,%0000001110000000,0

star6:	dc.w	%0000011111000000,0,%0000011111000000,0
	dc.w	%0000011111100000,0,%0000111111100000,0
	dc.w	%0000101111110000,0,%0001011111110000,0
	dc.w	%0011011111111000,0,%0011111111111000,0
	dc.w	%0011111111101000,0,%0011111111111000,0
	dc.w	%0011111111101000,0,%0011111111111000,0
	dc.w	%0011111111001000,0,%0011111111111000,0
	dc.w	%0011111111001000,0,%0011111111111000,0
	dc.w	%0001111100010000,0,%0001111111110000,0
	dc.w	%0000110000100000,0,%0000111111100000,0
	dc.w	%0000011111000000,0,%0000011111000000,0

star7:	dc.w	%0000011111000000,0,%0000011111000000,0
	dc.w	%0001111111110000,0,%0001111111110000,0
	dc.w	%0010101111111000,0,%0011011111111000,0
	dc.w	%0011111111111000,0,%0010001111111000,0
	dc.w	%0110101111110100,0,%0111011111111100,0
	dc.w	%0111111111110100,0,%0111111111111100,0
	dc.w	%0111111111110100,0,%0111111111111100,0
	dc.w	%0111111111100100,0,%0111111111111100,0
	dc.w	%0111111111100100,0,%0111111111111100,0
	dc.w	%0011111111000000,0,%0011111111111000,0
	dc.w	%0011111100001000,0,%0011111111111000,0
	dc.w	%0001100000010000,0,%0001111111110000,0
	dc.w	%0000011111000000,0,%0000011111000000,0


xypos:
	DC.W	$C900,$3500,$CF00,$D900,$2A00,$4400,$E600,$5F00
	DC.W	$C200,$7400,$F100,$DB00,$8900,$D400,$6400,$C000
	DC.W	$8900,$3F00,$6500,$FB00,$AE00,$D100,$0800,$6C00
	DC.W	$1D00,$AB00,$1A00,$B000,$9900,$E800,$2800,$F100
	DC.W	$3500,$F900,$4000,$C400,$1800,$5100,$5300,$2900
	DC.W	$5100,$7E00,$3900,$AD00,$F600,$FE00,$BB00,$7F00
	DC.W	$A500,$1600,$AE00,$CB00,$E200,$E600,$DB00,$8800
	DC.W	$6400,$4A00,$B700,$9B00,$2900,$7000,$2400,$8A00
	DC.W	$C100,$C500,$A500,$8F00,$E200,$6A00,$7F00,$FE00
	DC.W	$C600,$BB00,$EB00,$8900,$5D00,$4C00,$D800,$5100
	DC.W	$7D00,$FF00,$7B00,$0100,$8900,$F400,$F000,$2B00
	DC.W	$0F00,$2D00,$3300,$AC00,$F800,$D500,$0D00,$B900
	DC.W	$C900,$DC00,$3C00,$9200,$C900,$5800,$F400,$E100
	DC.W	$3600,$B700,$CE00,$7E00,$D300,$B500,$2600,$0E00
	DC.W	$3300,$CC00,$3700,$D300,$B200,$3000,$5900,$0400
	DC.W	$0F00,$AE00,$9600,$1600,$3B00,$3F00,$E500,$2500
	DC.W	$EE00,$A500,$E500,$4900,$CB00,$2D00,$D800,$3B00
	DC.W	$7400,$F000,$4A00,$1100,$8C00,$0300,$3600,$5200
	DC.W	$7F00,$BA00,$9400,$FB00,$AC00,$5800,$B700,$A400
	DC.W	$F000,$1200,$8100,$B400,$1400,$6500,$0500,$3100
	DC.W	$3000,$2400,$7300,$6D00,$E500,$0B00,$0F00,$6D00
	DC.W	$D700,$4C00,$F000,$AA00,$FB00,$ED00,$4900,$D300
	DC.W	$C100,$AD00,$4F00,$1400,$3F00,$2F00,$D200,$8500
	DC.W	$9000,$4400,$E400,$E100,$F100,$2B00,$B200,$B200
	DC.W	$E500,$E400,$5C00,$7400,$4900,$EA00,$DD00,$0300
	DC.W	$FB00,$4900,$3200,$1000,$A600,$F100,$E300,$7100
	DC.W	$C300,$3400,$5800,$F100,$3600,$1C00,$4900,$E100
	DC.W	$5F00,$0900,$6A00,$9000,$B900,$AD00,$4B00,$2900
	DC.W	$B300,$5100,$A900,$F800,$F100,$6900,$5C00,$D900
	DC.W	$1F00,$6A00,$6800,$2100,$8000,$1400,$9900,$FC00
	DC.W	$F800,$5100,$6700,$9500,$3F00,$3100,$B900,$3700
	DC.W	$A200,$C100,$E700,$2900,$4300,$8900,$E600,$6100
	DC.W	$6800,$FC00,$4C00,$B900,$9700,$9D00,$FB00,$5900
	DC.W	$1B00,$F300,$A700,$D100,$9400,$8400,$0000,$0000


 END

