<?7<?7<?7<?7<?7<?7<?7<?7<?7; 3D rotating bobs V2.0
;								TAS / feb1992

DEMOSTARTUP = 0


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  matrix tabel			$40000	$50000
*  screens			$50000	$5c000

 INCLUDE chipmap.inc
 ORG $33200
 LOAD $33200
sintabel = $27800
>EXTERN "DF0:sin1024.data",sintabel


width = 42

ytabel	= $61000
ztabel  = $61800
xtabel	= $62000

vectab	= $6f000

size = 270*width*2
screen1 = $63000
screen2 = screen1+size
antal = 115

txtscreen = $50000


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	move.w	#$130,d0
	bsr.W	RC
	 IFEQ DEMOSTARTUP
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$05b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)
	move.w	#$0200,$100(a6)

	lea	txtscreen,a0
	move.l	#80*768,d0
	bsr.W	clear
	lea	screen1,a0
	move.l	#size*2,d0
	bsr.W	clear

	bsr.W	calc_tabeller
	bsr.W	print_text

	move.w	#$120,d0
	bsr.W	RC
	lea	cp(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83f0,$96(a6)

*-----------------------*
*	MAIN LOOP	*

ML:	move.w	#$128,d0
	bsr.W	RC

	bsr.B	T1
	lea	DMA,a6
	bsr.W	controlroom
	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	.exit
	 ENDC
	bsr.W	textdriver
	tst.w	quit
	beq.B	ML

.exit	BLTW
	moveq	#0,d0
	rts

quit:	dc.w 0


*----------------------------
* TASK 1 - 3D rotating stars

T1:	lea	display(pc),a0
	movem.l	(a0),a1/a2
	exg	a1,a2
	movem.l	a1/a2,(a0)
	lea	CPptrs(pc),a0
	move.l	a2,d0
	swap	d0
	move.w	d0,10(a0)
	move.w	a2,14(a0)
	adda.w	#width,a2
	move.l	a2,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a2,6(a0)

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.w	#2,BLTDMOD(a6)
	move.l	display(pc),a0
	addq.l	#2,a0
	move.l	a0,BLTDPT(a6)
	move.w	#300<<6+20,BLTSIZE(a6)
	move.l	a7,stack
	lea	512*42(a0),a7
	movem.l	clrregs(pc),d0-d7
	movem.l	clrregs(pc),a0-a6
	 QREPT [212*42]/60
	movem.l	d0-a6,-(a7)
	 ENDQR
	movem.l	d0-a6,-(a7)
	lea	DMA,a6
	move.l	stack(pc),a7

	bsr.W	matrix_calc

	lea	xypos,a0
	lea	vectab+$8080,a5
	move.l	display(pc),a2
	suba.w	#[13*width*2],a2
	lea	ytabel,a3
	lea	xtabel,a4
	moveq	#6,d6
	move.w	#antal-1,d7
	move.l	sp,stack
	BLTW
	move.l	#$FFFF0000,BLTAFWM(a6)
	clr.w	BLTAMOD(a6)
	move.w	#width-4,BLTBMOD(a6)
	move.w	#width-4,BLTDMOD(a6)
	clr.w	BLTCON1(a6)
	lea	ztabel+[256*2],a6
starloop:
	subq.b	#5,4(a0)
	movem.w	(a0)+,d3-d5
matrix	move.b	$00(a5,d3.W),d0
	move.b	$00(a5,d4.W),d1
	ext.w	d0
	ext.w	d1
	add.w	d1,d0
	move.b	$00(a5,d5.W),d1
	ext.w	d1
	add.w	d1,d0

	move.b	$00(a5,d3.W),d1
	move.b	$00(a5,d4.W),d2
	ext.w	d1
	ext.w	d2
	add.w	d2,d1
	move.b	$00(a5,d5.W),d2
	ext.w	d2
	add.w	d2,d1

	move.b	$00(a5,d3.W),d2
	move.b	$00(a5,d4.W),d3
	ext.w	d2
	ext.w	d3
	add.w	d3,d2
	move.b	$00(a5,d5.W),d3
	ext.w	d3
	add.w	d3,d2

	add.w	d2,d2
	move.w	(a6,d2.W),d2
	muls	d2,d1
	asr.l	d6,d1
	addi.w	#128+13,d1
	cmpi.w	#256+13,d1
	bhs.B	next
	muls	d2,d0
	asr.l	d6,d0
	addi.w	#160+16,d0
	cmpi.w	#320+16,d0
	bhs.B	next

	add.w	d0,d0
	add.w	d0,d0
	add.w	d1,d1
	move.w	(a3,d1.W),d1
	add.w	(a4,d0.W),d1
	move.w	2(a4,d0.W),d0
	lea	(a2,d1.W),a1
	lea	DMA+BLTBPT,a7

stars1	cmpi.w	#0,d2
	bgt.B	stars2
	lea	13*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star1+4,(a7)+
	move.l	a1,(a7)+
	move.w	#1<<6+2,(a7)
next	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
stars2	cmpi.w	#0,d2
	bgt.B	stars3
	lea	10*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star2,(a7)+
	move.l	a1,(a7)+
	move.w	#6<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
stars3	cmpi.w	#0,d2
	bgt.B	stars4
	lea	8*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star3,(a7)+
	move.l	a1,(a7)+
	move.w	#10<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
stars4	cmpi.w	#0,d2
	bgt.B	stars5
	lea	6*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star4,(a7)+
	move.l	a1,(a7)+
	move.w	#14<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
stars5	cmpi.w	#0,d2
	bgt.B	stars6
	lea	4*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star5,(a7)+
	move.l	a1,(a7)+
	move.w	#18<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
stars6	cmpi.w	#0,d2
	bgt.B	.stars7
	lea	2*width(a1),a1
	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star6,(a7)+
	move.l	a1,(a7)+
	move.w	#22<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts
.stars7	move.w	d0,-$c(a7)
	move.l	a1,(a7)+
	move.l	#star7,(a7)+
	move.l	a1,(a7)+
	move.w	#26<<6+2,(a7)
	dbf	d7,starloop
	move.l	stack(pc),sp
	rts


* TASK 1 data
stack:		dc.l 0
display:	dc.l screen1,screen2
vectorxy:	dc.w 0,0,0, 0,0,0



*-------------
* MATRIX CALC

matrix_calc
	lea	vectorxy(pc),a4
	movem.w	6(a4),d0-d2
	add.w	d0,(a4)
	add.w	d1,2(a4)
	add.w	d2,4(a4)

	lea	sintabel,a1
	lea	256(a1),a2
	movem.w	(a4),d0-d2
	move.w	#$3fe,d3
	andi.w	d3,d0
	andi.w	d3,d1
	andi.w	d3,d2
	move.w	(a1,d0.W),.calc4+2
	move.w	(a1,d0.W),.calc4+6
	move.w	(a2,d0.W),.calc4+10
	move.w	(a2,d0.W),.calc4+14
	move.w	(a1,d1.W),.calc5+2
	move.w	(a1,d1.W),.calc5+6
	move.w	(a2,d1.W),.calc5+10
	move.w	(a2,d1.W),.calc5+14
	move.w	(a1,d2.W),.calc3+2
	move.w	(a1,d2.W),.calc3+6
	move.w	(a2,d2.W),.calc3+10
	move.w	(a2,d2.W),.calc3+14

	lea	.matrixpos+4(pc),a0
	lea	matrix_vectors(pc),a1
	moveq	#2,d7
.matrixloop
	movem.w	(a0),d0-d2
	move.w	d1,d4
	move.w	d0,d3
.calc3	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d1
	sub.l	d4,d0
	add.l	d3,d1
	add.l	d0,d0
	swap	d0
	add.l	d1,d1
	swap	d1
	move.w	d2,d4
	move.w	d1,d3
.calc4	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d1
	muls	#$0000,d2
	sub.l	d4,d1
	add.l	d3,d2
	add.l	d1,d1
	swap	d1
	add.l	d2,d2
	swap	d2
	move.w	d2,d4
	move.w	d0,d3
.calc5	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d2
	sub.l	d4,d0
	add.l	d3,d2
	add.l	d0,d0
	swap	d0
	add.l	d2,d2
	swap	d2
	move.w	d2,12(a1)
	move.w	d1,6(a1)
	move.w	d0,(a1)+
	subq.l	#2,a0
	dbf	d7,.matrixloop

	lea	matrix_vectors(pc),a1
	lea	matrix(pc),a0
	moveq	#7,d3
	moveq	#2,d7
.ins	movem.w	(a1)+,d0-d2
	asr.w	d3,d0
	asr.w	d3,d1
	asr.w	d3,d2
	move.b	d0,3(a0)
	move.b	d1,7(a0)
	move.b	d2,17(a0)
	adda.w	#22,a0
	dbf	d7,.ins
	rts

* MATRIX data
.matrixpos	dc.w 0,0,$3FFF,0,0
matrix_vectors	ds.w 9


*--------------*
* CONTROL ROOM *

controlroom:
	lea	counter(pc),a0
	move.w	(a0),d0
	addq.w	#1,(a0)

	cmp.w	#31,d0
	bhs.B	.fadein
	move.w	d0,-(sp)
	move.w	d0,d3
	lsr.w	#1,d3
	lea	CPcolors(pc),a0
	move.w	#$47E,d0
	bsr.W	fade
	move.w	d0,2(a0)
	move.w	#$FFF,d0
	bsr.W	fade
	move.w	d0,6(a0)
	move.w	#$149,d0
	bsr.W	fade
	move.w	d0,10(a0)
	move.w	(sp)+,d0
.fadein

	lea	starloop(pc),a0
	lea	vectorxy+6(pc),a1
	cmp.w	#134,d0
	bne.B	.stage1a
	move.l	#$59280004,(a0)	; SUBQ.B #4,4(a0)
.stage1a
	cmp.w	#138,d0
	bne.B	.stage1b
	move.l	#$57280004,(a0)	; SUBQ.B #3,4(a0)
.stage1b
	cmp.w	#142,d0
	bne.B	.stage1c
	move.l	#$55280004,(a0)	; SUBQ.B #2,4(a0)
.stage1c
	cmp.w	#146,d0
	bne.B	.stage1d
	move.l	#$53280004,(a0)	; SUBQ.B #1,4(a0)
.stage1d
	cmp.w	#150,d0
	bne.B	.stage2a
	move.l	#$4e714e71,(a0)	; NOP
	move.w	#4,(a1)
	move.w	#2,2(a1)
	move.w	#1,4(a1)
.stage2a
	cmp.w	#154,d0
	bne.B	.stage2b
	move.w	#6,(a1)
	move.w	#4,2(a1)
	move.w	#2,4(a1)
.stage2b
	cmp.w	#472,d0
	bne.B	.stage3a
	move.l	#$53280004,(a0)	; SUBQ.B #1,4(a0)
.stage3a
	cmp.w	#476,d0
	bne.B	.stage3b
	move.l	#$55280004,(a0)	; SUBQ.B #2,4(a0)
.stage3b
	cmp.w	#480,d0
	bne.B	.stage3c
	move.l	#$57280004,(a0)	; SUBQ.B #3,4(a0)
.stage3c

	cmp.w	#1200,d0
	blo.B	.fadedown
	move.w	d0,-(sp)
	move.w	d0,d3
	sub.w	#1200,d3
	not.w	d3
	and.w	#$1f,d3
	lsr.w	#1,d3
	lea	CPcolors(pc),a0
	move.w	#$47e,d0
	bsr.W	fade
	move.w	d0,2(a0)
	move.w	#$FFF,d0
	bsr.W	fade
	move.w	d0,6(a0)
	move.w	d0,14(a0)		;ogs teksten (samme farve)
	move.w	#$149,d0
	bsr.W	fade
	move.w	d0,10(a0)
	move.w	(sp)+,d0
.fadedown
	cmp.w	#1231,d0
	beq.B	.quit
	rts
.quit:	move.w	#-1,quit
	rts

* CONTROL data
counter:	dc.w 0

*-------------
* TEXT DRIVER

textdriver:
	move.w	counter(pc),d0
	cmp.w	#204,d0
	blo.B	.ok
	rts
.ok	
	lea	vpos(pc),a0
	move.w	counter(pc),d0
	and.w	#3,d0
	cmp.w	#3,d0
	bne.B	.nosub
	subq.w	#1,2(a0)
.nosub
	move.w	(a0),d3
	move.w	2(a0),d0
	add.w	d0,(a0)
	and.w	#$3fe,(a0)
	add.w	#5,divfaktor

	lea	sintabel,a0
	lea	256(a0),a1
	move.w	(a1,d3.W),d0
	move.w	(a0,d3.W),d1
	ext.l	d0
	ext.l	d1
	divs	divfaktor(pc),d0
	divs	divfaktor(pc),d1
	ext.l	d0
	ext.l	d1
	cmp.w	#320,d0
	ble.B	.chk1
	move.w	#320,d0
.chk1	cmp.w	#-320,d0
	bge.B	.chk2
	move.w	#-320,d0
.chk2	cmp.w	#256,d1
	ble.B	.chk3
	move.w	#256,d1
.chk3	cmp.w	#-256,d1
	bge.B	.chk4
	move.w	#-256,d1
.chk4
	muls	#80,d1
	move.w	d0,d2
	asr.w	#4,d0
	add.w	d0,d0
	lea	txtscreen+[80*256],a0
	adda.l	d0,a0
	adda.l	d1,a0
	move.l	a0,d0
	swap	d0
	lea	CPptrs(pc),a1
	move.w	d0,18(a1)
	move.w	a0,22(a1)
	not.w	d2
	and.w	#$f,d2
	lsl.w	#4,d2
	move.w	d2,CPcon1+2
	rts

* TEXT DRIVER data
divfaktor:	dc.w 50
vpos:		dc.w -$19a&$3fe,48


*-----------------*
* OPSTIL TABELLER *
*-----------------*

calc_tabeller:
	lea	ytabel,a0 
	moveq	#0,d0
	move.w	#256+13,d7
.ytab	move.w	d0,(a0)+
	addi.w	#width*2,d0
	dbf	d7,.ytab

	lea	xtabel,a0
	moveq	#0,d0
	move.w	#320+16-1,d7
.xtab	move.w	d0,d1
	lsr.w	#4,d1
	lsl.w	#1,d1
	move.w	d1,(a0)+
	move.w	d0,d1
	andi.w	#$f,d1
	ror.w	#4,d1
	ori.w	#$0dfc,d1
	move.w	d1,(a0)+
	addq.w	#1,d0
	dbf	d7,.xtab

	 REM
	lea	xypos,a0
	move.w	#[antal*3]-1,d7
	moveq	#0,d0
	moveq	#0,d1
.rnd1	add.w	$6(a6),d0
	mulu	d1,d0
	addi.w	#$1249,d0
	move.b	d0,(a0)+
	clr.b	(a0)+
	add.w	$bfd800,d1
	dbf	d7,.rnd1
	 ENDREM

	lea	ztabel,a0
	move.w	#0,d0
	move.w	#640-1,d7
	move.w	#15,d2
	move.w	d2,d1
.ztab	move.l	#250000,d0
	divu	d1,d0
	move.w	d0,(a0)+
	add.w	d2,d1		;15
	dbf	d7,.ztab
	lea	ztabel,a0
	move.w	(a0),d0
	moveq	#127,d7
.zajust	move.w	d0,-(a0)
	dbf	d7,.zajust
	lea	ztabel,a0
	move.w	150*2(a0),stars6+2
	move.w	200*2(a0),stars5+2
	move.w	250*2(a0),stars4+2
	move.w	300*2(a0),stars3+2
	move.w	350*2(a0),stars2+2
	move.w	400*2(a0),stars1+2

	lea	vectab,a0
	moveq	#-128,d0
	moveq	#7,d3
.tab1	moveq	#-128,d1
.tab2	move.w	d1,d2
	muls	d0,d2
	asr.w	d3,d2
	move.b	d2,(a0)+
	addq.w	#1,d1
	cmpi.w	#128,d1
	bne.S	.tab2
	addq.w	#1,d0
	cmpi.w	#128,d0
	bne.S	.tab1
	rts

*--------------------*
* UDSKRIV TEKSTSKRM *
*--------------------*
print_text:
	lea	text(pc),a0
	lea	txtscreen,a2
	adda.w	#[80*256]+3,a2
	clr.w	d1
.loop	moveq	#0,d0
	move.b	(a0)+,d0
	bpl.B	.ok
	rts
.ok	cmp.b	#10,d0
	bne.B	.noret
	adda.w	#9*80,a2
	clr.w	d1
	bra.B	.loop
.noret	cmp.b	#11,d0
	bne.B	.nox
	move.b	(a0)+,d1
	bra.B	.loop
.nox	sub.b	#' ',d0
	lsl.w	#3,d0
	lea	font(pc),a3
	adda.w	d0,a3
	lea	(a2,d1.W),a1
	moveq	#7,d0
.print	move.b	(a3)+,(a1)
	adda.w	#80,a1
	dbf	d0,.print
	addq.w	#1,d1
	bra.B	.loop
* TEXT data
text:
	dc.b 10,10,10,10,10,10,10,10,10,10
	dc.b 11,6, "IF U WANNA SWAP WITH PARASITE",10
	dc.b 11,14,"THEN WRITE TO",10,10,10
	dc.b 11,12,"SPEEDY / PARASITE",10
	dc.b 11,12,"STEFFEN RABENBORG",10
	dc.b 11,14,"ALBANIGADE 49",10
	dc.b 11,14,"5000 ODENSE C",10
	dc.b 11,16," DENMARK",10
	dc.b $FF
 even

*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e2881,$009028c1,$00920030,$009400d0
 dc.l $01000200
CPcon1:
 dc.l $01020000,$01040064
 dc.w $0108,width,$010a,38
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
CPcolors:
 dc.l $01820000,$01840000,$01860000
 dc.l $01920FFF
CPptrs:
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.w $00e8,screen1/$10000,$00ea,screen1&$ffff
 dc.w $00e4,txtscreen/$10000,$00e6,txtscreen&$ffff
 dc.l $2801fffe,$01003600
; dc.l $ffe1fffe
; dc.l $2801fffe,$01000200
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

fade:	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f,d0
	andi.w	#$f0,d1
	andi.w	#$f00,d2
	mulu	d3,d0
	mulu	d3,d1
	mulu	d3,d2
	andi.w	#$f0,d0
	andi.w	#$f00,d1
	andi.w	#$f000,d2
	or.w	d1,d0
	or.w	d2,d0
	lsr.w	#4,d0
	rts


*----------*
* STJERNER *

star1:	dc.w	%0000000000000000,0,%0000000100000000,0

star2:	dc.w	%0000000100000000,0,%0000000100000000,0
	dc.w	%0000001010000000,0,%0000001110000000,0
	dc.w	%0000000100000000,0,%0000000100000000,0

star3:	dc.w	%0000001110000000,0,%0000001110000000,0
	dc.w	%0000010111000000,0,%0000011111000000,0
	dc.w	%0000011101000000,0,%0000011111000000,0
	dc.w	%0000011001000000,0,%0000011111000000,0
	dc.w	%0000001110000000,0,%0000001110000000,0

star4:	dc.w	%0000001110000000,0,%0000001110000000,0
	dc.w	%0000010111000000,0,%0000011111000000,0
	dc.w	%0000101011100000,0,%0000110111100000,0
	dc.w	%0000110110100000,0,%0000111111100000,0
	dc.w	%0000111100100000,0,%0000111111100000,0
	dc.w	%0000011001000000,0,%0000011111000000,0
	dc.w	%0000001110000000,0,%0000001110000000,0

star5:	dc.w	%0000001110000000,0,%0000001110000000,0
	dc.w	%0000101111100000,0,%0000111111100000,0
	dc.w	%0000010111100000,0,%0000101111100000,0
	dc.w	%0001101111010000,0,%0001111111110000,0
	dc.w	%0001111111010000,0,%0001111111110000,0
	dc.w	%0001111110010000,0,%0001111111110000,0
	dc.w	%0000111100000000,0,%0000111111100000,0
	dc.w	%0000110000100000,0,%0000111111100000,0
	dc.w	%0000001110000000,0,%0000001110000000,0

star6:	dc.w	%0000011111000000,0,%0000011111000000,0
	dc.w	%0000011111100000,0,%0000111111100000,0
	dc.w	%0000101111110000,0,%0001011111110000,0
	dc.w	%0011011111111000,0,%0011111111111000,0
	dc.w	%0011111111101000,0,%0011111111111000,0
	dc.w	%0011111111101000,0,%0011111111111000,0
	dc.w	%0011111111001000,0,%0011111111111000,0
	dc.w	%0011111111001000,0,%0011111111111000,0
	dc.w	%0001111100010000,0,%0001111111110000,0
	dc.w	%0000110000100000,0,%0000111111100000,0
	dc.w	%0000011111000000,0,%0000011111000000,0

star7:	dc.w	%0000011111000000,0,%0000011111000000,0
	dc.w	%0001111111110000,0,%0001111111110000,0
	dc.w	%0010101111111000,0,%0011011111111000,0
	dc.w	%0011111111111000,0,%0010001111111000,0
	dc.w	%0110101111110100,0,%0111011111111100,0
	dc.w	%0111111111110100,0,%0111111111111100,0
	dc.w	%0111111111110100,0,%0111111111111100,0
	dc.w	%0111111111100100,0,%0111111111111100,0
	dc.w	%0111111111100100,0,%0111111111111100,0
	dc.w	%0011111111000000,0,%0011111111111000,0
	dc.w	%0011111100001000,0,%0011111111111000,0
	dc.w	%0001100000010000,0,%0001111111110000,0
	dc.w	%0000011111000000,0,%0000011111000000,0

font:
 dc.b	$00,$00,$00,$00,$00,$00,$00,$00	;" "
 dc.b	$EE,$EE,$EE,$EE,$EE,$00,$EE,$00	;"!"
 dc.b	$66,$EE,$EE,$CC,$00,$00,$00,$00	;"""
 dc.b	$6C,$FE,$FE,$6C,$FE,$FE,$6C,$00	;"#"
 dc.b	$18,$7E,$F0,$7C,$1E,$FC,$30,$00	;"$"
 dc.b	$E6,$EE,$DC,$38,$76,$EE,$CE,$00	;"%"
 dc.b	$7C,$EE,$EE,$7C,$EE,$EE,$76,$00	;"&"
 dc.b	$38,$38,$30,$00,$00,$00,$00,$00	;"'"
 dc.b	$1C,$38,$70,$70,$70,$38,$1C,$00	;"("
 dc.b	$70,$38,$1C,$1C,$1C,$38,$70,$00	;")"
 dc.b	$18,$5A,$3C,$FF,$3C,$5A,$18,$00	;"*"
 dc.b	$00,$18,$18,$7E,$7E,$18,$18,$00	;"+"
 dc.b	$00,$00,$00,$00,$18,$38,$38,$30	;","
 dc.b	$00,$00,$00,$7E,$7E,$00,$00,$00	;"-"
 dc.b	$00,$00,$00,$00,$38,$38,$38,$00	;"."
 dc.b	$03,$07,$0E,$1C,$38,$70,$E0,$C0	;"/"
 dc.b	$7C,$EE,$EE,$FE,$EE,$EE,$7C,$00	;"0"
 dc.b	$38,$38,$38,$78,$38,$38,$FE,$00	;"1"
 dc.b	$FC,$EE,$0E,$7C,$E0,$FE,$FE,$00	;"2"
 dc.b	$FC,$EE,$0E,$1C,$0E,$EE,$FC,$00	;"3"
 dc.b	$EE,$EE,$EE,$7E,$0E,$0E,$0E,$00	;"4"
 dc.b	$FE,$EE,$E0,$FC,$0E,$EE,$FC,$00	;"5"
 dc.b	$7E,$EE,$E0,$FC,$EE,$EE,$7C,$00	;"6"
 dc.b	$FE,$EE,$0E,$3C,$38,$38,$38,$00	;"7"
 dc.b	$7C,$EE,$EE,$7C,$EE,$EE,$7C,$00	;"8"
 dc.b	$7C,$EE,$EE,$7E,$0E,$EE,$FC,$00	;"9"
 dc.b	$38,$38,$38,$00,$38,$38,$38,$00	;":"
 dc.b	$38,$38,$38,$00,$18,$38,$38,$30	;";"
 dc.b	$1C,$38,$70,$E0,$70,$38,$1C,$00	;"<"
 dc.b	$00,$7E,$7E,$00,$7E,$7E,$00,$00	;"="
 dc.b	$70,$38,$1C,$0E,$1C,$38,$70,$00	;">"
 dc.b	$FC,$EE,$0E,$3C,$38,$00,$38,$00	;"?"
 dc.b	$7C,$EE,$EE,$EE,$EE,$E0,$7E,$00	;"@"
 dc.b	$7C,$EE,$EE,$FE,$EE,$EE,$EE,$00	;"A"
 dc.b	$FC,$EE,$EE,$FC,$EE,$EE,$FC,$00	;"B"
 dc.b	$7C,$EE,$EE,$E0,$EE,$EE,$7C,$00	;"C"
 dc.b	$FC,$EE,$EE,$EE,$EE,$EE,$FC,$00	;"D"
 dc.b	$7E,$EE,$E0,$F0,$E0,$EE,$7E,$00	;"E"
 dc.b	$7E,$EE,$E0,$F0,$E0,$E0,$E0,$00	;"F"
 dc.b	$7C,$EE,$E0,$EE,$EE,$EE,$7E,$00	;"G"
 dc.b	$EE,$EE,$EE,$FE,$EE,$EE,$EE,$00	;"H"
 dc.b	$FE,$38,$38,$38,$38,$38,$FE,$00	;"I"
 dc.b	$FE,$EE,$0E,$3E,$0E,$EE,$7C,$00	;"J"
 dc.b	$EE,$EE,$EE,$FC,$EE,$EE,$EE,$00	;"K"
 dc.b	$E0,$E0,$E0,$E0,$E0,$EE,$7E,$00	;"L"
 dc.b	$C6,$EE,$FE,$EE,$EE,$EE,$EE,$00	;"M"
 dc.b	$CE,$EE,$FE,$EE,$EE,$EE,$EE,$00	;"N"
 dc.b	$7C,$EE,$EE,$EE,$EE,$EE,$7C,$00	;"O"
 dc.b	$FC,$EE,$EE,$FC,$E0,$E0,$E0,$00	;"P"
 dc.b	$7C,$EE,$EE,$EE,$EE,$EE,$7E,$00	;"Q"
 dc.b	$FC,$EE,$EE,$FC,$EE,$EE,$EE,$00	;"R"
 dc.b	$7E,$EE,$E0,$7C,$0E,$EE,$FC,$00	;"S"
 dc.b	$FE,$38,$38,$38,$38,$38,$7C,$00	;"T"
 dc.b	$EE,$EE,$EE,$EE,$EE,$EE,$7E,$00	;"U"
 dc.b	$EE,$EE,$EE,$EE,$EC,$F8,$70,$00	;"V"
 dc.b	$EE,$EE,$EE,$EE,$FE,$EE,$C6,$00	;"W"
 dc.b	$EE,$EE,$EE,$7C,$EE,$EE,$EE,$00	;"X"
 dc.b	$EE,$EE,$EE,$7C,$38,$38,$7C,$00	;"Y"
 dc.b	$FE,$EE,$0E,$7C,$E0,$EE,$FE,$00	;"Z"

; END

xypos:
	DC.W	$4900,$E500,$2E00,$3C00,$5900,$D800,$7100,$B500
	DC.W	$7200,$DB00,$2F00,$3100,$2D00,$8A00,$0C00,$DC00
	DC.W	$4900,$DC00,$6D00,$0600,$9E00,$C400,$3900,$9800
	DC.W	$1100,$1C00,$E000,$5200,$D500,$5800,$0300,$C300
	DC.W	$1A00,$6400,$1D00,$5000,$8900,$1200,$DC00,$B200
	DC.W	$A900,$BB00,$6300,$9200,$DE00,$2C00,$A500,$9200
	DC.W	$4900,$F100,$B200,$4A00,$BD00,$CA00,$EB00,$E900
	DC.W	$A200,$FC00,$8F00,$E300,$E100,$2B00,$5C00,$9800
	DC.W	$0900,$4B00,$9D00,$1400,$3E00,$AC00,$6700,$1900
	DC.W	$4100,$3E00,$CE00,$9F00,$3D00,$D100,$0100,$2700
	DC.W	$EA00,$D400,$F700,$FB00,$5100,$6300,$B600,$0D00
	DC.W	$D900,$6B00,$BD00,$1400,$F600,$3400,$B500,$F200
	DC.W	$6900,$3B00,$3E00,$0600,$3D00,$3A00,$FB00,$5C00
	DC.W	$3200,$2900,$AF00,$A300,$5500,$5700,$AA00,$C400
	DC.W	$8900,$5000,$F700,$6400,$F600,$4600,$1500,$9D00
	DC.W	$E100,$2500,$0200,$4100,$AD00,$DD00,$2500,$5100
	DC.W	$FA00,$7000,$AD00,$3600,$A100,$B500,$4400,$C100
	DC.W	$2900,$3500,$8F00,$D200,$7200,$2C00,$5900,$7000
	DC.W	$A900,$6400,$4800,$7300,$B900,$3300,$DD00,$BA00
	DC.W	$5200,$B200,$BB00,$1B00,$1D00,$C300,$0E00,$A900
	DC.W	$4900,$3400,$8700,$B800,$D200,$9500,$F300,$F200
	DC.W	$A900,$C400,$9200,$1300,$B100,$ED00,$3300,$9B00
	DC.W	$5A00,$2400,$3700,$5500,$8500,$8600,$B600,$FF00
	DC.W	$1100,$8100,$0D00,$ED00,$4E00,$6300,$F300,$7B00
	DC.W	$8900,$9800,$3800,$B600,$1100,$8800,$C300,$1700
	DC.W	$FA00,$9E00,$8100,$BC00,$8D00,$C100,$0400,$3600
	DC.W	$7900,$4500,$5300,$1000,$2600,$D600,$2500,$F300
	DC.W	$A100,$AD00,$4E00,$F400,$9900,$E800,$3B00,$A700
	DC.W	$7A00,$4300,$FD00,$6000,$E500,$C100,$5C00,$AB00
	DC.W	$9100,$D000,$4D00,$3200,$3200,$2C00,$3D00,$1600
	DC.W	$4900,$2900,$C400,$1F00,$4D00,$D000,$3B00,$0B00
	DC.W	$1200,$6700,$7F00,$5400,$ED00,$5500,$3400,$6500
	DC.W	$4900,$7E00,$FD00,$EE00,$0E00,$9200,$8300,$3A00
	DC.W	$E900,$4400,$3E00,$7900,$AD00,$0700,$4B00,$F800
	DC.W	$FA00,$A200,$D700,$E400,$B900,$7100,$A400,$5D00
	DC.W	$A900,$5600,$CF00,$6500,$FA00,$4800,$9300,$B300
	DC.W	$C900,$2D00,$6E00,$AE00,$FD00,$2300,$1700,$0A00
	DC.W	$F200,$D700,$4F00,$1400,$D500,$CE00,$0C00,$C800
	DC.W	$C900,$D300,$9D00,$D400,$8600,$1A00,$1500,$E900
	DC.W	$6100,$4C00,$2000,$5300,$7900,$0300,$5D00,$EA00
	DC.W	$BA00,$5A00,$6D00,$3400,$6500,$3300,$4C00,$EF00
	DC.W	$B100,$E700,$3F00,$1000,$3E00,$8100,$5300,$AA00
	DC.W	$0900,$4400,$4E00,$C300,$1500,$CE00,$D900,$CD00
	DC.W	$6200,$5B00,$CB00,$6600,$8500,$2B00,$7C00,$CB00
	DC.W	$2900,$AB00,$DD00,$5C00,$0A00,$5E00,$AB00,$AA00

 END

