; filled vector bobs 02
;								TAS / jun1991

DEMOSTARTUP = 0

 INCLUDE chipmap.inc
sintabel = $27800
>EXTERN "df0:sin1024.data",sintabel
 ORG $2A000
 LOAD $2A000

width = 40

size = 256*width
screen1 = $60000
screen2 = screen1+size
finalscreen = screen2+size

ytabel1 = $7f400
ytabel2 = $7f600
vectorbuffer = $7fa00

animdata = $68000
anims = 128
zadd  = 7

col1 = $00c


BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.S	.\@
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	 IFEQ DEMOSTARTUP
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	move.w	#$000,$180(a6)
	move.w	#$0200,$100(a6)

	lea	screen1,a0
	move.l	#size*3,d0
	bsr.W	clear

	lea	ytabel1,a0
	moveq	#0,d0
	move.w	#255,d7
.ytabel1 move.w	d0,(a0)+
	addi.w	#width*2,d0
	dbf	d7,.ytabel1
	lea	ytabel2,a0
	moveq	#0,d0
	move.w	#255,d7
.ytabel2 move.w	d0,(a0)+
	addi.w	#width,d0
	dbf	d7,.ytabel2

	move.l	#animdata,animptr
	moveq	#anims-1,d0
.draw	move.w	d0,-(sp)
	bsr.W	drawbox
	move.w	(sp)+,d0
	dbf	d0,.draw

	lea	fontptr(pc),a1
	moveq	#58,d7
.ajust1	move.l	(a1)+,a0
	adda.l	#font,a0
	moveq	#0,d6
	move.b	(a0)+,d6
	beq.B	.nxt
	addq.w	#1,d6
.ajust2	cmp.b	#$80,(a0)
	bne.B	.ok
	addq.l	#1,a0
	addq.w	#1,d6
	bra.B	.ajust2
.ok	moveq	#0,d0
	moveq	#0,d1
	move.b	(a0),d0
	move.b	1(a0),d1
	subi.w	#12,d0
	subq.w	#5,d1
	asl.w	#1,d0
	asl.w	#2,d1
	neg.w	d1
	asl.w	#3,d0
	asl.w	#3,d1
	ext.l	d0
	ext.l	d1
	divs	#7,d0
	divs	#7,d1
	move.b	d0,(a0)+
	move.b	d1,(a0)+
	subq.w	#1,d6
	bne.B	.ajust2
.nxt	dbf	d7,.ajust1

	lea	screen1,a0
	move.l	#size*2,d0
	bsr.W	clear

	move.w	#$100,d0
	bsr.W	RC
	lea	CP1(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83f0,DMACON(a6)

*---------------------*
*      MAIN LOOP      *

	clr.w	counter
ML:	move.w	#$110,d0
	bsr.W	RC
	bsr.B	drawthem

	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	.exit
	 ENDC
	addq.w	#1,counter
	cmp.w	#2100,counter
	bne.B	ML

.exit:	lea	DMA,a6
	BLTW
	moveq	#0,d0
	rts
counter:	dc.w 0


*------------------------------*
* DRAW VECTOR LETTER AND BOXES *

drawthem:
	lea	display(pc),a2
	movem.l	(a2),d0-d3
	exg	d0,d2
	exg	d1,d3
	movem.l	d0-d3,(a2)
	lea	copptrs(pc),a1
	move.w	d2,6(a1)
	swap	d2
	move.w	d2,2(a1)

	move.w	sprite1data+2(pc),d0
	move.w	sprite2data+2(pc),d1
	move.w	sprite3data+2(pc),d2
	cmp.w	d0,d1
	bhi.B	.noswap1
	exg	d0,d1
	lea	COPYsprptr(pc),a0
	lea	16(a0),a1
	lea	COPYsprcol(pc),a2
	lea	12(a2),a3
	bsr.W	swapsprite
.noswap1
	cmp.w	d1,d2
	bhi.B	.noswap2
	exg	d1,d2
	lea	COPYsprptr+16(pc),a0
	lea	16(a0),a1
	lea	COPYsprcol+12(pc),a2
	lea	12(a2),a3
	bsr.W	swapsprite
.noswap2
	cmp.w	d0,d1
	bhi.B	.noswap3
	exg	d0,d1
	lea	COPYsprptr(pc),a0
	lea	16(a0),a1
	lea	COPYsprcol(pc),a2
	lea	12(a2),a3
	bsr.W	swapsprite
.noswap3
	lea	COPYsprptr(pc),a0
	lea	CPsprptr(pc),a1
	moveq	#[COPYx-COPYsprptr]/4-1,d7
.copy	move.l	(a0)+,(a1)+
	dbf	d7,.copy


	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	clr.w	BLTDMOD(a6)
	move.l	display(pc),a0
	move.l	a0,BLTDPT(a6)
	move.w	#128<<6+20,BLTSIZE(a6)
	move.l	a7,stack
	lea	256*width(a0),a7
	movem.l	clrbuffer(pc),d0-d7
	movem.l	clrbuffer(pc),a0-a6
	 REPT [128*width]/60
	movem.l	d0-a6,-(a7)
	 ENDR
	movem.l	d0-a6,-(a7)
	lea	DMA,a6
	move.l	stack(pc),a7

	lea	sprite1data(pc),a4
	bsr.W	letterhandle
	lea	sprite2data(pc),a4
	bsr.W	letterhandle
	lea	sprite3data(pc),a4
	bsr.W	letterhandle

	move.l	display(pc),a0
	adda.w	#width*210,a0
	move.l	a0,a1
	BLTW
	move.l	#$09f00012,BLTCON0(a6)
	moveq	#-1,d1
	move.l	d1,BLTAFWM(a6)
	movem.l	a0/a1,BLTAPT(a6)
	clr.l	BLTAMOD(a6)
	move.w	#210<<6+20,BLTSIZE(a6)
	rts


letterhandle:
	move.w	2(a4),d0
	addq.w	#1,d0
	bpl.B	.show
	move.w	d0,2(a4)
	rts
.show
	cmp.w	#128+32,d0
	bne.B	.nores
	clr.w	d0
.nores
	tst.w	d0
	bne.B	.nextchar
	addq.w	#3,4(a4)
	move.w	4(a4),d0
	lea	txt1(pc),a0	;Last txt
	tst.b	(a0,d0.W)
	bpl.B	.txtok
	move.w	#$8000,2(a4)	;No more text!
	rts
.txtok	move.w	4(a4),d3
	lsl.w	#2,d3
	lea	txtpos(pc),a0
	move.w	(a0,d3.W),d0	;Get X
	move.w	2(a0,d3.W),d3	;Get Y
	move.w	d3,8(a4)
	move.w	d3,10(a4)
	subi.w	#210,d3		;calc sin.divisor
	neg.w	d3
	move.l	#$7fff,d2
	divu	d3,d2
	move.w	d2,12(a4)
	move.w	#160,d1		;calc X
	ext.l	d1
	swap	d1
	move.l	d1,14(a4)
	sub.w	#160,d0
	ext.l	d0
	moveq	#9,d1
	asl.l	d1,d0
	move.l	d0,18(a4)
	clr.w	d0		;Reset Count
.nextchar
	move.w	d0,2(a4)
	cmpi.w	#128,d0
	blo.B	gogo

	move.w	2(a4),d3
	sub.w	#128,d3
	lsr.w	#1,d3
	eori.w	#$f,d3
	move.w	#col1,d0
	bsr.W	fade
	move.w	(a4),d1
	mulu	#12,d1
	lea	COPYsprcol(pc),a0
	move.w	d0,2(a0,d1.W)

	move.l	a4,-(SP)
	bsr.W	preparedraw
	bsr.W	drawletter
	move.l	(SP)+,a4

	lea	animdata,a0
	move.w	#127,d0
	mulu	#32*8,d0
	adda.l	d0,a0
	move.w	xpos(pc),d0
	move.w	ypos(pc),d1
	move.w	(a4),d2
	bsr.W	insertsprite

	move.w	2(a4),d0
	cmp.w	#129,d0
	beq.W	printmaske
	rts

gogo:	move.w	(a4),d0
	mulu	#12,d0
	lea	COPYsprcol(pc),a0
	move.w	#col1,2(a0,d0.W)

	move.l	a4,-(SP)
	bsr.W	preparedraw
	bsr.W	drawletter
	move.l	(SP)+,a4

	lea	animdata,a0
	move.w	2(a4),d0
	mulu	#32*8,d0
	adda.l	d0,a0
	move.w	xpos(pc),d0
	move.w	ypos(pc),d1
	move.w	(a4),d2
	bsr.W	insertsprite
	rts



preparedraw:
	move.w	2(a4),d5
	cmp.w	#128,d5
	blo.B	.nooo
	move.w	#128,d5
.nooo	move.w	d5,-(sp)

	move.w	d5,d0
	add.w	d0,d0
	lea	sintabel,a0
	move.w	(a0,d0.W),d0
	ext.l	d0
	divu	12(a4),d0
	add.w	10(a4),d0
	sub.w	#210,d0
	sub.w	8(a4),d0
	neg.w	d0
	move.w	d0,ypos

	move.l	14(a4),d0
	swap	d0
	move.w	d0,xpos
	cmp.w	#128,2(a4)
	bhs.B	.foundx
	move.l	18(a4),d0
	add.l	d0,14(a4)
.foundx
	move.w	4(a4),d0
	lea	txt1(pc),a0
	adda.w	d0,a0
	move.b	(a0),d0
	andi.w	#$ff,d0
	move.w	(sp)+,d1
	rts


swapsprite:
	move.w	2(a0),d4
	move.w	2(a1),2(a0)
	move.w	d4,2(a1)
	move.w	6(a0),d4
	move.w	6(a1),6(a0)
	move.w	d4,6(a1)
	move.w	10(a0),d4
	move.w	10(a1),10(a0)
	move.w	d4,10(a1)
	move.w	14(a0),d4
	move.w	14(a1),14(a0)
	move.w	d4,14(a1)
	adda.w	#CPsprcon-CPsprptr,a0
	adda.w	#CPsprcon-CPsprptr,a1
	move.w	2(a0),d4
	move.w	2(a1),2(a0)
	move.w	d4,2(a1)
	move.w	6(a0),d4
	move.w	6(a1),6(a0)
	move.w	d4,6(a1)
	move.w	10(a0),d4
	move.w	10(a1),10(a0)
	move.w	d4,10(a1)
	move.w	14(a0),d4
	move.w	14(a1),14(a0)
	move.w	d4,14(a1)

	move.w	2(a2),d4
	move.w	2(a3),2(a2)
	move.w	d4,2(a3)
	rts

printmaske:
	move.w	xpos(pc),d0
	move.w	ypos(pc),d1
	sub.w	#16,d0
	sub.w	#16,d1
	move.w	d0,d2
	mulu	#width,d1
	lea	finalscreen,a0
	move.l	display+8(pc),a1
	lsr.w	#4,d2
	add.w	d2,d2
	add.w	d2,d1
	adda.w	d1,a0
	adda.w	d1,a1
	lea	maske(pc),a2

	and.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0FEA,d0
	BLTW
	move.w	d0,BLTCON0(a6)
	clr.w	BLTCON1(a6)
	move.l	#$ffffffff,BLTAFWM(a6)
	move.w	#0,BLTAMOD(a6)
	move.w	#width-6,BLTBMOD(a6)
	move.w	#width-6,BLTCMOD(a6)
	move.w	#width-6,BLTDMOD(a6)
	move.l	a2,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a0,BLTCPT(a6)
	move.l	a0,BLTDPT(a6)
	move.w	#24<<6+3,BLTSIZE(a6)
	rts


*------------*
* PRINT DATA *
*------------*
animpos		dc.w 0
stack		dc.l 0
xpos		dc.w 0
ypos		dc.w 0

sprite1data:
	dc.w 0		;00: sprite#1
	dc.w -1		;02: count
	dc.w -3		;04: txtpos
	dc.w 140,100	;06: x,y-pos
	dc.w 0,0	;10: org.y-pos and sin.divisor
	dc.l 0,0	;14: x-rel add
sprite2data:
	dc.w 1		;sprite#2
	dc.w -53	;count
	dc.w -2		;txtpos
	dc.w 160,100	;x,y-pos
	dc.w 0,0	;org.y-pos and sin.divisor
	dc.l 0,0	;x-rel add
sprite3data:
	dc.w 2		;sprite#3
	dc.w -106	;count
	dc.w -1		;txtpos
	dc.w 180,100	;x,y-pos
	dc.w 0,0	;org.y-pos and sin.divisor
	dc.l 0,0	;x-rel add

txt1:
 DC.B "PARASITE!WEPRESENTYOU..."
 DC.B "-ZYCLONIUM-"
 DC.B $FF,$FF,$FF
 even

txtpos:
;PARASITE!
 dc.w 80,30, 100,30, 120,30, 140,30
 dc.w 160,30, 180,30, 200,30, 220,30, 235,30
;WE PRESENT
 dc.w 70,62, 90,62
 dc.w 130,62, 150,62, 170,62, 190,62, 210,62, 230,62, 250,62
;YOU...
 dc.w 110,80, 130,80, 150,80, 170,80, 180,80, 190,80
;THE REAL THING
 dc.w 60,105, 80,105, 100,105, 120,105
 dc.w 140,105, 160,105, 180,105, 200,105, 220,105, 240,105, 260,105

maske:
 REPT 24
  dc.w $FFFF,$FFE0,0
 ENDR

*----------------*
* SCREEN PROCESS *

drawletter:
	move.w	d0,-(sp)
	move.w	d1,d3
	sub.w	#128,d3
	neg.w	d3
	mulu	#zadd,d3
	add.w	#800,d3
	lsl.w	#3,d1
	move.w	d1,d0
	move.w	d1,d2
	bsr.W	SinCos
	
	move.w	(sp)+,d0
	and.w	#$ff,d0
	subi.b	#' ',d0
	bmi.W	vnext
	lsl.w	#2,d0
	lea	fontptr(pc),a0
	move.l	(a0,d0.W),a0
	adda.l	#font,a0

	lea	vectorbuffer,a1
	moveq	#0,d0
	move.b	(a0)+,d0
	beq.W	vnext
	move.w	d0,-(sp)
	addq.w	#1,d0
	move.w	d0,d7

vloop1	move.b	(a0)+,d0
	cmp.b	#$80,d0
	bne.B	.ok
	move.w	#$8000,(a1)+
	addq.w	#1,d7
	bra.B	vloop1
.ok	move.b	(a0)+,d1
	ext.w	d0
	ext.w	d1
	moveq	#-box,d2
	bsr.W	vectorcalc
	addi.w	xpos(pc),d0
	addi.w	ypos(pc),d1
	move.w	d0,(a1)+
	move.w	d1,(a1)+
	subq.w	#1,d7
	bne.B	vloop1

	lea	vectorbuffer,a1
	lea	ytabel2,a4
	move.w	(sp)+,d7
	move.b	#1,color
	BLTW
	clr.w	$42(a6)
	move.w	#$ffff,$44(a6)
	move.l	#$ffff8000,$72(a6)
	move.w	#width,$60(a6)
	move.w	#width,$66(a6)
.draw	move.w	(a1)+,d0
	move.w	(a1)+,d1
	move.w	(a1),d2
	cmpi.w	#$8000,d2
	bne.B	.drawok
	addq.l	#2,a1
	bra.B	.draw
.drawok	move.w	2(a1),d3
	bsr.W	drawvector
	subq.w	#1,d7
	bne.B	.draw
vnext	rts

insertsprite:
	movem.l	a1/a2,-(sp)
	lsl.w	#4,d2
	lea	COPYsprptr(pc),a1
	lea	COPYsprcon(pc),a2
	adda.w	d2,a1
	adda.w	d2,a2

	moveq	#0,d2
	lsr.w	d0
	bcc.B	.1shift
	moveq	#1,d2
.1shift	addi.b	#$38,d0
	addi.b	#$19,d1
	move.b	d1,2(a2)
	move.b	d1,10(a2)
	move.b	d0,3(a2)
	addq.b	#8,d0
	move.b	d0,11(a2)
	addi.w	#31,d1
	cmpi.w	#$ff,d1
	blo.B	.high
	move.b	#$ff,d1
.high	move.b	d1,6(a2)
	move.b	d1,14(a2)
	move.b	d2,7(a2)
	move.b	d2,15(a2)

	move.l	a0,d0
	swap	d0
	move.w	d0,2(a1)
	move.w	a0,6(a1)
	adda.w	#32*4,a0
	move.l	a0,d0
	swap	d0
	move.w	d0,10(a1)
	move.w	a0,14(a1)
	movem.l	(sp)+,a1/a2
	rts



*--------------------*
* make animtion bobs *

drawbox:
	lea	display(pc),a2
	movem.l	(a2),d0-d3
	movem.l	d2/d3,(a2)
	movem.l	d0/d1,8(a2)

	move.l	4(a2),a0
	tst.l	(a0)
	beq.B	.noclrmem
	BLTW
	move.l	#$01000002,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	(a0)+,BLTDPT(a6)
	move.w	(a0)+,BLTDMOD(a6)
	move.w	(a0)+,BLTSIZE(a6)
.noclrmem

	lea	vectorxy(pc),a4
	move.l	strukturptr(pc),a5
	movem.w	20(a5),d0-d2
	add.w	d0,(a4)
	add.w	d1,2(a4)
	add.w	d2,4(a4)
	movem.w	(a4)+,d0-d2
	move.w	18(a5),d3
	cmpi.w	#800,d3
	beq.B	.nope
	subq.w	#zadd,18(a5)
.nope	bsr.W	SinCos

	move.l	strukturptr(pc),a5
	lea	vectorbuffer,a3
	move.l	4(a5),a0
.vecloop1
	movem.w	(a0)+,d0-d2
	bsr.W	vectorcalc
	addi.w	#16,d0
	addi.w	#18,d1
	move.w	d0,(a3)+
	move.w	d1,(a3)+
	cmp.w	#$8000,(a0)
	bne.B	.vecloop1

	bsr.W	polykill

	move.l	(a5),a0
	lea	vectorbuffer,a1
	lea	ytabel1,a4
	BLTW
	clr.w	$42(a6)
	move.w	#$ffff,$44(a6)
	move.l	#$ffff8000,$72(a6)
	move.w	#width*2,$60(a6)
	move.w	#width*2,$66(a6)
.vecloop2
	moveq	#0,d7
	tst.b	(a0)+
	beq.B	.vecloop2a
	bmi.B	.vecdrawend
	move.b	(a0)+,d7
	lea	2(a0,d7.W),a0
	bra.B	.vecloop2
.vecloop2a
	move.b	(a0)+,d7
	subq.w	#1,d7
	move.b	(a0)+,color
.vecloop2b
	moveq	#0,d5
	moveq	#0,d6
	move.b	(a0)+,d5
	move.b	(a0),d6
	lsl.w	#2,d5
	lsl.w	#2,d6
	movem.w	(a1,d5.W),d0/d1
	movem.w	(a1,d6.W),d2/d3
	bsr.W	drawvector
	dbf	d7,.vecloop2b
	addq.l	#1,a0
	bra.B	.vecloop2
.vecdrawend

	move.l	display(pc),a0
	adda.w	#34*width*2+2,a0
	clr.l	d0
	move.w	#34<<7+20,d3
	move.l	a0,a1
	BLTW
	move.l	#$09f00012,BLTCON0(a6)
	moveq	#-1,d1
	move.l	d1,BLTAFWM(a6)
	movem.l	a0/a1,BLTAPT(a6)
	move.l	d0,BLTAMOD(a6)
	move.w	d3,BLTSIZE(a6)
	move.l	display+4(pc),a2
	move.l	a0,(a2)
	movem.w	d0/d3,4(a2)

	move.l	display(pc),a0
	adda.w	#[2*width*2],a0

	move.l	animptr(pc),a1
	BLTW
	move.l	#$09f00000,BLTCON0(a6)
	move.w	#width*2-2,BLTAMOD(a6)
	move.w	#2,BLTDMOD(a6)
	movem.l	a0/a1,BLTAPT(a6)
	move.w	#32<<6+1,BLTSIZE(a6)
	BLTW
	adda.w	#width,a0
	addq.l	#2,a1
	movem.l	a0/a1,BLTAPT(a6)
	move.w	#32<<6+1,BLTSIZE(a6)
	BLTW
	suba.w	#width-2,a0
	adda.w	#32*4-2,a1
	movem.l	a0/a1,BLTAPT(a6)
	move.w	#32<<6+1,BLTSIZE(a6)
	BLTW
	adda.w	#width,a0
	addq.l	#2,a1
	movem.l	a0/a1,BLTAPT(a6)
	move.w	#32<<6+1,BLTSIZE(a6)
	BLTW
	adda.l	#32*4*2,animptr
.nofill	rts


polykill:
	lea	vectorbuffer,a0
	move.l	(a5),a1
.loop	clr.b	(a1)
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	move.b	3(a1),d0
	move.b	4(a1),d1
	move.b	5(a1),d2
	lsl.w	#2,d0
	lsl.w	#2,d1
	lsl.w	#2,d2
	movem.w	(a0,d1.W),d3/d4
	movem.w	(a0,d2.W),d5/d6
	movem.w	(a0,d0.W),d0/d1
	sub.w	d3,d0
	sub.w	d4,d1
	sub.w	d3,d5
	sub.w	d4,d6
	muls	d1,d5
	muls	d0,d6
	sub.l	d6,d5
	bpl.B	.polykillA
	move.b	#1,(a1)
.polykillA
	moveq	#0,d0
	move.b	1(a1),d0
	lea	4(a1,d0.W),a1
	tst.b	(a1)
	bpl.B	.loop
	rts

* TASK 1 data
display:
 dc.l screen1,edges+8
 dc.l screen2,edges+16
color:		dc.b 0
 even
animptr:	dc.l 0
vectorxy:	dc.w 0,0,0
edges:		dc.w 336,0,200,0
		dc.l 0,0, 0,0, 0,0



*----------------*
* VECTOR RUTINES *

SinCos:
	lea	sintabel,a1
	lea	256(a1),a2
	andi.w	#$3fe,d0
	andi.w	#$3fe,d1
	andi.w	#$3fe,d2
	move.w	(a1,d0.W),calc4+2
	move.w	(a1,d0.W),calc4+6
	move.w	(a2,d0.W),calc4+10
	move.w	(a2,d0.W),calc4+14
	move.w	(a1,d1.W),calc5+2
	move.w	(a1,d1.W),calc5+6
	move.w	(a2,d1.W),calc5+10
	move.w	(a2,d1.W),calc5+14
	move.w	(a1,d2.W),calc3+2
	move.w	(a1,d2.W),calc3+6
	move.w	(a2,d2.W),calc3+10
	move.w	(a2,d2.W),calc3+14
	move.w	d3,calc2+2
	rts

vectorcalc:
	move.w	d1,d4
	move.w	d0,d3
calc3	muls	#0,d4
	muls	#0,d3
	muls	#0,d0
	muls	#0,d1
	sub.l	d4,d0
	add.l	d3,d1
	add.l	d0,d0
	swap	d0
	add.l	d1,d1
	swap	d1
	move.w	d2,d4
	move.w	d1,d3
calc4	muls	#0,d4
	muls	#0,d3
	muls	#0,d1
	muls	#0,d2
	sub.l	d4,d1
	add.l	d3,d2
	add.l	d1,d1
	swap	d1
	add.l	d2,d2
	swap	d2
	move.w	d2,d4
	move.w	d0,d3
calc5	muls	#0,d4
	muls	#0,d3
	muls	#0,d0
	muls	#0,d2
	sub.l	d4,d0
	add.l	d3,d2
	add.l	d0,d0
	swap	d0
	add.l	d2,d2
	swap	d2
	ext.l	d0
	ext.l	d1
calc2:	addi.w	#800,d2
	lsl.l	#8,d0
	lsl.l	#8,d1
	divs	d2,d0
	divs	d2,d1
	rts	

drawvector:
	cmp.w	d1,d3
	bgt.B	.vecexg
	exg	d0,d2
	exg	d1,d3
	beq.W	.noline
.vecexg
	moveq	#0,d4
	moveq	#0,d5
	move.w	d1,d4
	add.w	d4,d4
	move.w	(a4,d4.W),d4
	move.w	d0,d5
	add.l	display(pc),d4
	asr.w	#3,d5
	add.l	d5,d4
	moveq	#0,d5
	sub.w	d1,d3
	sub.w	d0,d2
	bpl.B	.draw58
	moveq	#1,d5
	neg.w	d2
.draw58	move.w	d3,d1
	add.w	d1,d1
	cmp.w	d2,d1
	dbhi	d3,.draw62
.draw62	move.w	d3,d1
	sub.w	d2,d1
	bpl.B	.draw6a
	exg	d2,d3
.draw6a	addx.w	d5,d5
	add.w	d2,d2
	move.w	d2,d1
	sub.w	d3,d2
	addx.w	d5,d5
	andi.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0a4a,d0
	move.w	d2,d6
	sub.w	d3,d2
	lsl.w	#6,d3
	addq.w	#2,d3
	BLTW
	move.b	.oktant(pc,d5.w),$43(a6)
	movem.w	d1/d2,$62(a6)
.drawa4	btst	#0,color
	beq.B	.color2
	move.w	d0,$40(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
.color2	btst	#1,color
	beq.B	.noline
	addi.l	#width,d4
	BLTW
	move.w	d0,$40(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
.noline	rts	
.oktant		DC.B	$03,$43,$13,$53,$0B,$4B,$17,$57


*------------------*
* VECTOR FONT DATA *

fontptr:
	DC.L	$00000000,$00000001,$00000000,$00000000
	DC.L	$00000000,$00000000,$00000000,$00000000
	DC.L	$00000000,$00000000,$00000000,$00000000
	DC.L	$00000000,$00000052,$00000047,$00000000
	DC.L	$00000000,$00000000,$00000000,$00000000
	DC.L	$00000000,$00000000,$00000000,$00000000
	DC.L	$00000000,$00000000,$00000031,$00000000
	DC.L	$00000000,$00000000,$00000000,$00000017
	DC.L	$00000000,$0000005D,$0000007B,$00000099
	DC.L	$000000AC,$000000C2,$000000DD,$000000F4
	DC.L	$0000010F,$0000012A,$00000145,$00000158
	DC.L	$00000171,$00000180,$0000019B,$000001B2
	DC.L	$000001C8,$000001E2,$000001FC,$0000021C
	DC.L	$00000237,$0000024A,$0000025D,$0000026C
	DC.L	$00000287,$000002A2,$000002B7

font:
 DC.B $00,$08,$08,$00,$08,$02,$10,$02
 DC.B $10,$00,$08,$00,$80,$08,$04,$08
 DC.B $0A,$10,$0A,$10,$04,$08,$04,$00
 DC.B $00,$00,$00,$00,$00,$00,$00,$00
 DC.B $00,$00,$00,$00,$00,$00,$00,$00
 DC.B $00,$00,$0A,$18,$0A,$10,$04,$08
 DC.B $04,$08,$08,$02,$08,$04,$10,$04
 DC.B $10,$02,$08,$02,$80,$08,$06,$08
 DC.B $08,$10,$08,$10,$06,$08,$06,$04
 DC.B $08,$00,$08,$03,$10,$03,$10,$00
 DC.B $08,$00,$04,$00,$03,$00,$07,$18
 DC.B $07,$18,$03,$00,$03
 DC.B $0C,$00,$00				;A
 DC.B $00,$0A,$18,$0A,$18,$00,$10,$00
 DC.B $10,$03,$08,$03,$08,$00,$00,$00
 DC.B $80,$08,$05,$08,$07,$10,$07,$10
 DC.B $05,$08,$05
 DC.B $0C,$00,$00,$18,$00			;B
 DC.B $18,$03,$12,$05,$18,$08,$18,$0A
 DC.B $00,$0A,$00,$00,$80,$08,$08,$08
 DC.B $03,$10,$03,$0b,$06,$10,$08,$08,$08
 DC.B $08,$00,$00,$18,$00,$18,$03		;C
 DC.B $08,$03,$08,$08,$18,$08,$18,$0A
 DC.B $00,$0A,$00,$00
 DC.B $08,$00,$00,$18				;D
 DC.B $00,$18,$08,$00,$0A,$00,$00,$80
 DC.B $08,$03,$10,$03,$10,$07,$08,$08
 DC.B $08,$03
 DC.B $0C,$00,$00,$18,$00,$18			;E
 DC.B $03,$08,$03,$08,$04,$10,$04,$10
 DC.B $06,$08,$06,$08,$08,$18,$08,$18
 DC.B $0A,$00,$0A,$00,$00,$0A,$00,$00
 DC.B $00,$0A,$18,$0A,$18,$08,$08,$07
 DC.B $08,$06,$10,$06,$10,$04,$08,$04
 DC.B $08,$00,$00,$00
 DC.B $0C,$00,$00,$00				;G
 DC.B $0A,$18,$0A,$18,$07,$08,$07,$08
 DC.B $02,$10,$02,$10,$03,$0C,$03,$0C
 DC.B $05,$18,$05,$18,$00,$00,$00
 DC.B $0C,$00,$00,$00,$0A,$08,$0A,$08,$06	;H
 DC.B $10,$06,$10,$0A,$18,$0A,$18,$00
 DC.B $10,$00,$10,$04,$08,$04,$08,$00,$00,$00
 DC.B $0C,$00,$00,$18,$00,$18			;I
 DC.B $03,$10,$03,$10,$08,$18,$08,$18
 DC.B $0A,$00,$0A,$00,$08,$08,$08,$08
 DC.B $03,$00,$03,$00,$00
 DC.B $08,$00,$00				;J
 DC.B $00,$04,$09,$04,$08,$02,$10,$02
 DC.B $10,$0A,$18,$0A,$18,$00,$00,$00
 DC.B $0B,$00,$00,$00,$0A,$08,$0A,$08		;K
 DC.B $06,$10,$0A,$18,$0A,$0C,$05,$18
 DC.B $00,$10,$00,$08,$04,$08,$00,$00
 DC.B $00
 DC.B $06,$00,$0A,$08,$0A,$08,$03		;L
 DC.B $18,$03,$18,$00,$00,$00,$00,$0A
 DC.B $0C,$00,$00,$00,$0A,$08,$0A,$0C		;M
 DC.B $06,$10,$0A,$18,$0A,$18,$00,$10
 DC.B $00,$10,$07,$0C,$03,$08,$07,$08
 DC.B $00,$00,$00,$0A,$00,$00,$00,$0A
 DC.B $08,$0A,$10,$03,$10,$0A,$18,$0A
 DC.B $18,$00,$10,$00,$08,$07,$08,$00
 DC.B $00,$00,$08,$00,$0A,$00,$00,$18
 DC.B $00,$18,$0A,$00,$0A,$80,$08,$08
 DC.B $08,$03,$10,$03,$10,$08,$08,$08
 DC.B $0A,$00,$0A,$18,$0A,$18,$04,$08
 DC.B $03,$08,$00,$00,$00,$00,$0A,$80
 DC.B $08,$07,$10,$07,$10,$05,$08,$05
 DC.B $08,$07,$0A,$00,$00,$00,$0A,$18
 DC.B $0A,$18,$00,$00,$00,$80,$08,$02
 DC.B $08,$07,$10,$07,$10,$03,$0C,$04
 DC.B $0C,$02,$08,$02,$0D,$00,$0A,$18
 DC.B $0A,$18,$04,$10,$03,$18,$00,$0E
 DC.B $00,$08,$03,$08,$00,$00,$00,$00
 DC.B $0A,$80,$08,$07,$10,$07,$10,$05
 DC.B $08,$05,$08,$07,$0C,$00,$0A,$18
 DC.B $0A,$18,$08,$08,$07,$08,$05,$18
 DC.B $05,$18,$00,$00,$00,$00,$02,$10
 DC.B $02,$10,$03,$00,$04,$00,$0A,$08
 DC.B $08,$00,$08,$06,$00,$06,$00,$0A
 DC.B $18,$0A,$18,$06,$10,$06,$10,$00
 DC.B $08,$00,$08,$00,$0A,$08,$0A,$08
 DC.B $03,$10,$03,$10,$0A,$18,$0A,$18
 DC.B $00,$00,$00,$00,$0A,$06,$0C,$00
 DC.B $00,$0A,$08,$0A,$0C,$04,$10,$0A
 DC.B $18,$0A,$0C,$00,$0C,$00,$00,$00
 DC.B $0A,$08,$0A,$08,$03,$0C,$05,$10
 DC.B $03,$10,$0A,$18,$0A,$18,$00,$10
 DC.B $00,$0C,$02,$08,$00,$00,$00,$0C
 DC.B $00,$0A,$00,$07,$08,$05,$00,$00
 DC.B $08,$00,$0C,$03,$10,$00,$18,$00
 DC.B $10,$05,$18,$07,$18,$0A,$0C,$07
 DC.B $00,$0A,$09,$10,$00,$08,$00,$08
 DC.B $04,$00,$0A,$08,$0A,$0C,$07,$10
 DC.B $0A,$18,$0A,$10,$04,$10,$00,$0A
 DC.B $00,$0A,$18,$0A,$18,$07,$0C,$02
 DC.B $18,$02,$18,$00,$00,$00,$00,$02
 DC.B $10,$07,$00,$07,$00,$0A


*----------------------*
* VECTOR STRUKTUR DATA *

box = 32

strukturptr: dc.l strk1
strk1:
 dc.l .vecdat1,.vecpos1,0
 dc.w 0,0,0,800+[anims*zadd]
 dc.w 8,8,8
.vecdat1:
 dc.b 0,4,1, 2,1,0,3,2,		0,4,3, 1,4,5,0,1
 dc.b 0,4,3, 6,2,3,7,6,		0,4,2, 6,4,1,2,6
 dc.b 0,4,2, 3,0,5,7,3,		0,4,1, 4,6,7,5,4
 dc.b -1
 even
.vecpos1:
 dc.w box,box,-box,	box,-box,-box,	-box,-box,-box,	-box,box,-box
 dc.w box,-box,box,	box,box,box,	-box,-box,box,	-box,box,box
 dc.w $8000,$8000,$8000


*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrbuffer:	blk.l 8,0
 even

*---------------------*
*     COPPER-LIST     *
*---------------------*
CP1:
 dc.l $01800000
 dc.l $008e2881,$009038c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040000
 dc.w $0108,0,$010a,0

CPsprptr:
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
CPsprcol:
 dc.l $01a20000,$01a4000e,$01a6000a,$01aa0000,$01ac000e,$01ae000a
 dc.l $01b20000,$01b4000e,$01b6000a,$01ba0000,$01bc000e,$01be000a
 dc.l $2701fffe
CPsprcon:
 dc.l $01400000,$01420000,$01480000,$014a0000
 dc.l $01500000,$01520000,$01580000,$015a0000
 dc.l $01600000,$01620000,$01680000,$016a0000
 dc.l $01700000,$01720000,$01780000,$017a0000

 dc.l $01820FFF,$01840FFF,$01860FFF
 dc.l $2801fffe
 dc.l $01002200
copptrs
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.w $00e4,finalscreen/$10000,$00e6,finalscreen&$ffff
 dc.l $f801fffe

 dc.l $ffe1fffe
 dc.l $2801fffe,$01000200
 dc.l $fffffffe


*---------------------*
* COPY OF SPRITE DATA *
*---------------------*
COPYsprptr:
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
COPYsprcol:
 dc.l $01a20000,$01a4000e,$01a6000a,$01aa0000,$01ac000e,$01ae000a
 dc.l $01b20000,$01b4000e,$01b6000a,$01ba0000,$01bc000e,$01be000a
 dc.l $2701fffe
COPYsprcon:
 dc.l $01400000,$01420000,$01480000,$014a0000
 dc.l $01500000,$01520000,$01580000,$015a0000
 dc.l $01600000,$01620000,$01680000,$016a0000
 dc.l $01700000,$01720000,$01780000,$017a0000
COPYx:


*-------------*
* SUBROUTINES *
*-------------*

RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

fade:	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f,d0
	andi.w	#$f0,d1
	andi.w	#$f00,d2
	mulu	d3,d0
	mulu	d3,d1
	mulu	d3,d2
	andi.w	#$f0,d0
	andi.w	#$f00,d1
	andi.w	#$f000,d2
	or.w	d1,d0
	or.w	d2,d0
	lsr.w	#4,d0
	rts

 END

