; hidden part
;								TAS / jul1991

DEMOSTARTUP = 0

*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$26000
*  screen			$30000	$38000

>extern "df0:sin1024.data",$27800
 include chipmap.inc
 org $26800
 load $26800

width = 40
xtabel = $51000
ytabel = $51600

codeloop = $52000
screen = $58000
colortabel = $60000

*------------------*
* START UP PROGRAM *

s:
	 IFEQ DEMOSTARTUP
	lea	start(pc),a0
	move.l	a0,$80.W
	trap	#0
	rts
	 ENDC

start:	lea	DMA,a6
	clr.w	counter
	move.w	#$01b0,$96(a6)
	clr.w	$180(a6)

	lea	xtabel,a0
	move.w	#319,d7
	move.l	#-320,d0
.xloop	move.w	d0,d1
	muls	d1,d1
	move.l	d1,(a0)+
	addq.w	#2,d0
	dbf	d7,.xloop
	lea	ytabel,a0
	move.w	#199,d7
	move.l	#-200,d0
.yloop	move.w	d0,d1
	muls	d1,d1
	move.l	d1,(a0)+
	addq.w	#2,d0
	dbf	d7,.yloop

	lea	screen,a1
	lea	copptr1(pc),a0
	moveq	#40,d2
	moveq	#4,d7
	bsr.W	copins

	lea	screen,a0
	move.l	#$7d00,d0
	bsr.W	fill

	lea	colors(pc),a0
	moveq	#15,d7
	move.w	#$0180,d0
	moveq	#0,d1
.copcols1
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	addq.w	#2,d0
	addq.w	#1,d1
	dbf	d7,.copcols1

	lea	codeloop,a0
	moveq	#7,d0
	moveq	#0,d1
	move.w	#319,d7
.cloop1	lea	codestart,a1
	move.l	#codeend-codestart-1,d6
	move.l	a0,a2
.cloop2	move.b	(a1)+,(a0)+
	dbf	d6,.cloop2
	move.b	d0,1(a2)
	move.w	d1,d2
	lsr.w	#3,d2
	lea	codeset-codestart(a2),a2
	move.w	d2,2(a2)
	add.w	#40,d2
	move.w	d2,10(a2)
	add.w	#40,d2
	move.w	d2,18(a2)
	add.w	#40,d2
	move.w	d2,26(a2)
	subq.w	#1,d0
	and.w	#7,d0
	addq.w	#1,d1
	dbf	d7,.cloop1
	move.w	#$4e75,(a0)+

	lea	colortabel,a0
	move.w	#$7ff,d0
.coltab	move.l	#$00010203,(a0)+
	move.l	#$04050607,(a0)+
	move.l	#$08090a0b,(a0)+
	move.l	#$0c0d0e0f,(a0)+
	move.l	#$0f0e0d0c,(a0)+
	move.l	#$0b0a0908,(a0)+
	move.l	#$07060504,(a0)+
	move.l	#$03020100,(a0)+
	dbf	d0,.coltab

	clr.w	copcon1+2
	move.l	#CP,$80(a6)
	move.w	#$83f0,DMACON(a6)
	 IFNE DEMOSTARTUP
	move.w	#$c020,INTENA(a6)
	 ENDC

	moveq	#1,d7
	bsr.W	fraktaltegner

	lea	text1(pc),a0
	lea	txtcolors1(pc),a1
	bsr.W	print
.rmb1	btst	#2,$dff016
	bne.B	.rmb1
	lea	text3(pc),a0
	lea	txtcolors1(pc),a1
	bsr.W	print
.rmb2	btst	#2,$dff016
	bne.B	.rmb2
	lea	text2(pc),a0
	lea	txtcolors2(pc),a1
	bsr.W	print
.rmb3	btst	#2,$dff016
	bne.B	.rmb3
	lea	text4(pc),a0
	lea	txtcolors2(pc),a1
	bsr.W	print

	 IFNE DEMOSTARTUP
deadend: bra.W	deadend
	 ELSE
.mouse	btst	#6,$bfe001
	bne.B	.mouse
	rte
	 ENDC


*----------------
* fraktal tegner

fraktaltegner:
	bsr.W	BLTW
	move.l	#$01000000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	clr.w	BLTDMOD(a6)
	lea	screen,a0
	move.l	a0,BLTDPT(a6)

	move.w	#4*64+20,a1
	lea	codeloop,a2
	lea	ytabel,a4
	lea	colortabel+$8000,a5
	lea	BLTSIZE(a6),a6
	move.w	a1,(a6)
.bltw1	btst	#14,$dff002
	bne.B	.bltw1
	moveq	#4,d2
	moveq	#0,d3
	moveq	#1,d4
	moveq	#2,d5
	moveq	#3,d6
	subq.l	#2,a7
	move.w	#200,(a7)
.drawloop
	move.w	a1,(a6)
	lea	xtabel,a3
	jsr	(a2)
	adda.w	#40*4,a0
	addq.l	#4,a4
.bltw2	btst	#14,-$56(a6)	;= $dff002
	bne.B	.bltw2
	subq.w	#1,(a7)
	bne.B	.drawloop
	addq.l	#2,a7
	lea	DMA,a6

	addq.w	#1,d7
	cmpi.w	#19,d7
	beq.B	.end
	bra.W	fraktaltegner
.end	lea	DMA,a6
	rts

codestart = *
	moveq	#0,d1
	move.l	(a3)+,d0
	add.l	(a4),d0
	lsr.l	d7,d0
	move.b	(a5,d0.W),d0
;	beq.B	codeend
	btst	d3,d0
	beq.B	*+6
codeset	bset	d1,0(a0)
	btst	d4,d0
	beq.B	*+6
	bset	d1,40(a0)
	btst	d5,d0
	beq.B	*+6
	bset	d1,80(a0)
	btst	d6,d0
	beq.B	*+6
	bset	d1,120(a0)
codeend = *

counter:	dc.w 0

*-------------------*
* PRINT HIDDEN TEXT *

print:	move.l	a0,txtptr
	move.l	a1,colorptr

	lea	screen,a0
	move.l	#$7d00,d0
	bsr.W	fill

	lea	screen,a0
	lea	copptr1(pc),a1
	move.l	a0,d0
	move.w	d0,6(a1)
	move.w	d0,14(a1)
	swap	d0
	move.w	d0,2(a1)
	move.w	d0,10(a1)
	move.w	#$0001,copcon1+2

	move.l	colorptr(pc),a0
	lea	colors(pc),a1
	moveq	#15,d7
.ins	move.w	(a0)+,2(a1)
	addq.l	#4,a1
	dbf	d7,.ins

	move.l	txtptr(pc),a0
	lea	screen,a4
	moveq	#0,d4		;xpos
	moveq	#0,d5		;ypos
	moveq	#0,d6		;color
.loop	move.w	#$ff,d0
	bsr.W	RC
	moveq	#0,d0
	move.b	(a0)+,d0
	bmi.B	.end
	cmp.b	#10,d0
	bne.B	.noret
	clr.w	d4
	addq.w	#1,d5
	bra.B	.loop
.noret	cmp.b	#11,d0
	bne.B	.nocol
	move.b	(a0)+,d6
	bra.B	.loop
.nocol
	sub.b	#' ',d0
	lea	font(pc),a1
	adda.w	d0,a1
	lea	(a4,d4.W),a2
	move.w	d5,d0
	mulu	#width*4*9,d0
	adda.l	d0,a2
	move.l	a2,a3

	moveq	#4,d7
.print	move.b	(a1),d0
	and.w	#$fe,d0
	move.b	d0,(a2)
	adda.w	#60,a1
	adda.w	#4*40,a2
	dbf	d7,.print

	lea	colorpattern(pc),a1
	move.w	d6,d0
	mulu	#3,d0
	adda.w	d0,a1
	move.b	(a1),d0
	move.b	1(a1),d1
	move.b	2(a1),d2
	moveq	#4,d7
.color	move.b	d0,40(a3)
	move.b	d1,80(a3)
	move.b	d2,120(a3)
	adda.w	#4*40,a3
	dbf	d7,.color

	addq.w	#1,d4
	bra.W	.loop
.end	rts

* PRINT data
txtptr:		dc.l 0
colorptr:	dc.l 0
text1:
 DC.B 10
 DC.B 11,1
 DC.B `    SO YOU DID FIND THE HIDDEN PART`,10
 DC.B `            IN THIS DEMO, EH?`,10,10
 DC.B 11,0
 DC.B `  I JUST WANT TO SAY THAT IT IS GREAT`,10
 DC.B `   THAT I FINALLY FINISHED THIS SHIT`,10,10,10
 DC.B 11,3
 DC.B `      TAS SENDS SECRET HELLOS TO:`,10,10
 DC.B 11,2
 DC.B `         TO PETER VESTERGAARD`,10
 DC.B `           AND TO PETER IB!`,10
 DC.B `      ALL MY NEW FRIENDS AT LUC,`,10
 DC.B ` TO NIKOLAJ, KIM, THOMAS AND THE REST.`,10
 DC.B `     AND I MUSTN'T FORGET NIBBLES!`,10
 DC.B `         HELLO TO LANGE S0REN`,10
 DC.B `   AND TO DENNIS AND CLAUS (PALACE)`,10
 DC.B `  AND FINALLY TO ALL PARASITE MEMBERS`,10
 DC.B `     ESPECIALLY TO DION J0RGENSEN -`,10
 DC.B ` AND ALL OTHER LAMERS IN THE WORLD!!!!`,10
 DC.B 10
 DC.B 11,0
 DC.B `                     PRESS THE RIGHT ONE`,10
 DC.B $FF
text2:
 DC.B 11,0
 DC.B 10
 DC.B ` DENNE BONUS TING ER BARE MEGA-PUNISHER`,10
 DC.B `  GRIM - SAA JEG VIL KUN SNAKKE DIG EN`,10
 DC.B `      LILLE SMULE IHJEL DENNE GANG.`,10,10
 DC.B `            MEN BARE VENT...`,10,10
 DC.B 11,1
 DC.B `    DRAEBER-TOMATERNE VENDER TILBAGE`,10,10
 DC.B 11,2
 DC.B ` SAA GAA IKKE GLIP AF DET NAESTE AFSNIT`,10
 DC.B `   AF "PARASITTERNE FRA DET YDRE RUM"`,10
 DC.B 10,10
 DC.B 11,0
 DC.B ` MEN AK, VERDEN ER NU EN GANG FOR LILLE`,10
 DC.B `   TIL AT DU KAN SLIPPE FOR EN OMGANG`,10
 DC.B `      MED VENTE-VENTE OG SOVE-SOVE`,10
 DC.B `  DA JEG NU MAA TY TIL ANDRE VERDSLIGE`,10
 DC.B `      SYSLER (LAES: SKOLE! AARGH!)`,10,10,10
 DC.B 11,3
 DC.B `                      SLAM THE RIGHT ONE`,10
 DC.B $FF
text3:
 DC.B 10
 DC.B 11,1
 DC.B `   WELL, HERE IS ANOTHER ADRESS U CAN`,10
 DC.B `           USE YOUR PEN ON..`,10
 DC.B `    BUT ONLY WRITE IF U WANNA SWAP`,10,10
 DC.B 11,3
 DC.B `      EXTREMELY DIRTY PORNO-MOVIES`,10
 DC.B `    (THOSE WITH HORSES ARE THE BEST)`,10
 DC.B `         OLD ISSUES OF PLAYBOY`,10
 DC.B `        PRIVATE SEX-RECORDINGS`,10
 DC.B `    OR NUDEPICTURES OF YOUR MOTHER`,10,10
 DC.B 11,2
 DC.B `               * DINO *`,10
 DC.B `         DION RENE J0RGENSEN`,10
 DC.B `            N0RREBRED 110`,10
 DC.B `          2625 VALLENSBAEK`,10
 DC.B `               DENMARK`,10,10
 DC.B 11,1
 DC.B `  IF U JUST WANNA SWAP DEMOS AND GAMES`,10
 DC.B ` U SHOULD ALSO TRY WRITING TO HIM......`,10,10
 DC.B `                      JUMP THE RIGHT ONE`,10
 DC.B $FF
text4:
 DC.B 10,10
 DC.B 11,1
 DC.B `     SAA ER DER ALTSAA IKKE MERE...`,10
 DC.B `   MEN JEG VENDER FRYGTELIGT TILBAGE`,10
 DC.B `     SENERE HVOR DER ER BRUG FOR..`,10,10
 DC.B 11,3
 DC.B `                  TAS!`,10
 DC.B `       (THE AMAZING SPEGEP0LSE??)`,10,10
 DC.B 11,1
 DC.B `   NAA, MEN DU MAA ALTSAA HYGGE DIG`,10
 DC.B ` OG NU IKKE NOGET MED AT SLETTE FLERE`,10
 DC.B `                HARDDISKE.`,10,10,10
 DC.B 11,2
 DC.B `             HEIL NIBBLES!`,10
 DC.B `    NU MAA JEG OVER OG NAKKE J0RN,`,10
 DC.B ` DER ER FORKLAEDT SOM JAKE, THE SNAKE!`,10,10,10
 DC.B 11,1
 DC.B `                 SEE YOU ALL LATER, TAS!`,10
 DC.B $FF
 even

txtcolors1:
	DC.W 0,0,$A88,$766
	DC.W 0,0,$DDD,$ABB
	DC.W 0,0,$A44,$722
	DC.W 0,0,$FB0,$D80
txtcolors2:
	DC.W 0,0,$A88,$766
	DC.W 0,0,$DDD,$ABB
	DC.W 0,0,$A44,$722
	DC.W 0,0,$EDE,$CBE
colorpattern:
	dc.b 0,0,0
	dc.b -1,-1,0
	dc.b 0,0,-1
	dc.b -1,-1,-1
 even


*--------*
*  DATA  *
*--------*
intregs		ds.w 2
clrregs		blk.l 8,0
even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e3081,$009028c1
 dc.l $00920038,$009400d0
 dc.l $01000200
copcon1:
 dc.l $01020000
 dc.l $01040024
 dc.l $01080078,$010a0078
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
colors ds.l 16
 dc.l $4001fffe,$01004200
copptr1
 dc.l $00e00005,$00e28000
 dc.l $00e40005,$00e68000
 dc.l $00e80005,$00ea8000
 dc.l $00ec0005,$00ee8000
 dc.l $ffe1fffe
 dc.l $0801fffe,$01000200
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*

RC:	cmp.b	$6(a6),d0
	bne.B	RC
	rts

bltw:	btst	#14,$2(a6)
	bne.B	bltw
	rts

fill:	clr.l	(a0)+
	clr.l	(a0)+
	subq.l	#8,d0
	bpl.B	fill
	rts

copins	move.w	a1,6(a0)
	move.l	a1,d1
	swap	d1
	move.w	d1,2(a0)
	adda.w	d2,a1
	addq.l	#8,a0
	subq.w	#1,d7
	bne.B	copins
	rts

font:	DC.W	$0060,$9000,$0000,$000C,$6060,$6060,$0000,$0008
	DC.W	$7C18,$7C7C,$C6FE,$3EFE,$7C7C,$0000,$3000,$60F0
	DC.W	$007C,$FC7E,$FCFE,$FE7C,$C6FC,$3CC6,$C0C6,$C67C
	DC.W	$FC7C,$FC7E,$FCCC,$C6C6,$C6C6,$FE00,$0060,$D800
	DC.W	$0000,$0018,$C030,$F0F0,$00F8,$0010,$E638,$C6C6
	DC.W	$C6C0,$600C,$C6C6,$6060,$6070,$3198,$00C6,$C6C0
	DC.W	$C6C0,$C0C0,$C630,$18CC,$C0EE,$E6C6,$C6C6,$C6C0
	DC.W	$30CC,$C6D6,$6C6C,$0C00,$0060,$4800,$0000,$0000
	DC.W	$C030,$F0F0,$00F8,$0020,$D618,$0C0C,$FEFC,$CC18
	DC.W	$7C7E,$0000,$C000,$1870,$00FE,$FCC0,$C6F8,$F8CE
	DC.W	$FE30,$18F8,$C0FE,$F6C6,$FCD6,$FC7C,$30CC,$6CFE
	DC.W	$3838,$3800,$0000,$0000,$0000,$0000,$C030,$6060
	DC.W	$6000,$0040,$CE18,$38C6,$0606,$C630,$C606,$6060
	DC.W	$6070,$3000,$00C6,$C6C0,$C6C0,$C0C6,$C631,$98CC
	DC.W	$C0D6,$DEC6,$C0CA,$C606,$30CC,$7CEE,$6C18,$6000
	DC.W	$0060,$0000,$0000,$0000,$6060,$0000,$C000,$C080
	DC.W	$7C18,$FE7C,$06FC,$7C60,$7C06,$00C0,$3000,$6060
	DC.W	$00C6,$FC7E,$FCFE,$C07C,$C6FC,$F0C6,$FEC6,$CE7C
	DC.W	$C074,$C6FC,$3078,$38C6,$C618,$FE00


 END

