<<<<<<<<<; new screen#1 ... sphere
;								TAS / jul1992


 INCLUDE chipmap.inc
 ORG $39800
 LOAD $39800

DEMOSTARTUP = 0

width = 46

sphereptrs	= $50000
spherecoods	= $50700

ysize = 256+32
size = [260+32]*width
screen1 = $70000
screen2 = screen1+size
screen3 = screen2+size
screen4 = screen3+size

ytabel = $6fb00


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.S	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	clr.l	$0.W
	move.w	#$130,d0
	bsr.W	RC
	 IFEQ DEMOSTARTUP
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	move.w	#$000,$180(a6)
	move.w	#$0200,$100(a6)

	lea	$50000,a0
	moveq	#5,d7
	move.w	#$8400,$96(a6)
.clear	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	a0,BLTDPT(a6)
	clr.w	BLTDMOD(a6)
	move.w	#512<<6+32,BLTSIZE(a6)
	adda.l	#$8000,a0
	dbf	d7,.clear
	move.w	#$0400,$96(a6)

	lea	ytabel,a0
	moveq	#0,d0
	move.w	#ysize-1,d1
.yloop	move.w	d0,(a0)+
	addi.w	#width,d0
	dbf	d1,.yloop

	bsr.W	calcsphere

	lea	CP1(pc),a0
	move.l	a0,$80(a6)
	move.w	#$81b0,DMACON(a6)

*---------------------*
*      MAIN LOOP      *

ML:	move.w	#$120,d0
	bsr.W	RC

	bsr.B	sphere
	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	exit
	 ENDC
	cmp.w	#226,z
	blo.B	ml

exit:	BLTW
	moveq	#0,d0

	lea	CP2(pc),a0
	move.l	a0,$80(a6)
	rts


*-----------------
* TASK 1 - sphere

sphere:	lea	display(pc),a0
	movem.l	(a0),d0-d3
	movem.l	d1-d3,(a0)
	move.l	d0,12(a0)

	move.l	display+12(pc),a0
	lea	CPptr(pc),a1
	move.l	a0,d0
	swap	d0
	move.w	d0,2(a1)
	move.w	a0,6(a1)

	move.l	display+8(pc),a0
	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	a0,BLTDPT(a6)
	clr.w	BLTDMOD(a6)
	move.w	#ysize<<6+[width/2],BLTSIZE(a6)

	addq.w	#3,z
	bsr.W	drawsphere
.ok
	rts

* SPHERE data
display:	dc.l screen1,screen2,screen3,screen4
z:		dc.w 3


drawsphere:
	move.w	#176,d0
	move.w	#ysize/2,d1
	move.w	z(pc),d2

	move.w	d2,d3
	lsl.w	#3,d3
	lea	sphereptrs,a0
	move.w	4(a0,d3.W),d7
	subq.w	#1,d7
	move.l	(a0,d3.W),a0
	move.l	display+4(pc),a1
	lea	ytabel,a2
	move.w	#350,a3
	move.w	#ysize,a4

	move.l	display(pc),a5
	adda.w	#[ysize*width]-2,a5
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0400,$96(a6)
	move.l	#$09f00012,BLTCON0(a6)
	move.l	#-1,BLTAFWM(a6)
	clr.l	BLTAMOD(a6)
	move.l	a5,BLTAPT(a6)
	move.l	a5,BLTDPT(a6)
	move.w	#ysize<<6+[width/2],BLTSIZE(a6)
.drawloop
	movem.w	(a0)+,d2-d4
	tst.w	d2
	beq.S	.nodot

	move.w	d1,d6
	add.w	d4,d6
	cmp.w	a4,d6
	bhi.S	.no2
	move.w	d0,d5
	add.w	d3,d5
	bmi.S	.no1
	cmp.w	a3,d5
	ble.S	.new1
	move.w	a3,d5
.new1	move.w	d5,d2
	lsr.w	#3,d2
	add.w	d6,d6
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no1	move.w	d0,d5
	sub.w	d3,d5
	cmp.w	a3,d5
	bhi.S	.no1
	move.w	d5,d2
	lsr.w	#3,d2
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no2
	move.w	d1,d6
	sub.w	d4,d6
	cmp.w	a4,d6
	bhi.S	.nodot
	move.w	d0,d5
	add.w	d3,d5
	bmi.S	.no3
	cmp.w	a3,d5
	ble.S	.new2
	move.w	a3,d5
.new2	move.w	d5,d2
	lsr.w	#3,d2
	add.w	d6,d6
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no3	move.w	d0,d5
	sub.w	d3,d5
	cmp.w	a3,d5
	bhi.S	.nodot
	move.w	d5,d2
	lsr.w	#3,d2
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.nodot	
	move.w	d1,d6
	add.w	d3,d6
	cmp.w	a4,d6
	bhi.S	.no5
	move.w	d0,d5
	add.w	d4,d5
	bmi.S	.no4
	cmp.w	a3,d5
	ble.S	.new3
	move.w	a3,d5
.new3	move.w	d5,d2
	lsr.w	#3,d2
	add.w	d6,d6
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no4	move.w	d0,d5
	sub.w	d4,d5
	cmp.w	a3,d5
	bhi.S	.no5
	move.w	d5,d2
	lsr.w	#3,d2
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no5
	move.w	d1,d6
	sub.w	d3,d6
	cmp.w	a4,d6
	bhi.S	.no7
	move.w	d0,d5
	add.w	d4,d5
	bmi.S	.no6
	cmp.w	a3,d5
	ble.S	.new4
	move.w	a3,d5
.new4	move.w	d5,d2
	lsr.w	#3,d2
	add.w	d6,d6
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no6	move.w	d0,d5
	sub.w	d4,d5
	cmp.w	a3,d5
	bhi.S	.no7
	move.w	d5,d2
	lsr.w	#3,d2
	add.w	(a2,d6.W),d2
	not.b	d5
	bset	d5,(a1,d2.W)
.no7	dbf	d7,.drawloop
.out	rts



*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP1:
 dc.l $01800000
 dc.l $008e1861,$00903cd1,$00920030,$009400d8
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,2,$010a,2
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
 dc.l $1801fffe
 dc.l $01001200
CPptr:
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.l $01820253
 dc.l $ffe1fffe
 dc.l $3c01fffe
 dc.l $01000200
 dc.l $fffffffe

CP2:
 dc.l $01800253
 dc.l $008e2881,$009030c1,$00920030,$009400d8
 dc.l $01000200,$01020000,$01040024
 dc.l $fffffffe


calcsphere:
	lea	spherecoods,a0
	lea	sphereptrs,a1
	move.w	#230,d0
	moveq	#1,d1
.loop1
	move.l	a0,(a1)+
	clr.w	(a1)
	move.w	d1,d2
	move.w	d2,d4
	mulu	d2,d2
	moveq	#-1,d3
.loop2	move.w	d3,d5
	addq.w	#1,d5
	mulu	d5,d5
	sub.w	d4,d5
	move.w	d4,d6
	mulu	d6,d6
	add.w	d6,d5
	sub.w	d2,d5
	add.w	d5,d5
	addq.w	#1,d3
	clr.w	(a0)
	addq.w	#1,d5
	ble.S	.onepix
	subq.w	#1,d4
	move.w	#-1,(a0)
.onepix
	addq.w	#2,a0
	move.w	d3,(a0)+
	move.w	d4,(a0)+
	move.w	d3,d5
	addq.w	#1,d5
	addq.w	#1,(a1)
	cmp.w	d5,d4
	bgt.S	.loop2
	addq.l	#2,a1
	clr.w	(a1)+
	addq.w	#1,d1
	dbf	d0,.loop1
	rts	


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

 END

