; the pink circle
;								TAS / jun1992

DEMOSTARTUP = 0


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  screens			$40000	$50000
*  matrix area			$50000	$60000

 include chipmap.inc
 org $30000
 load $30000
sintabel = $27800
>extern 'df0:sin1024.data',sintabel


width = 40
scrsize = 128*40*3
screen1		= $5a000
screen2 	= screen1+scrsize
screen3 	= screen2+scrsize
screen4 	= screen3+scrsize
matrixarea	= $6b000



BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.B	.\@
	 ENDM

*------------------*
* START UP PROGRAM *

s	lea	DMA,a6
	 IFEQ DEMOSTARTUP
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC

	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)

	lea	sintabel,a0
	lea	matrixarea,a1
	move.w	#255,d7
.mloop1	moveq	#-128,d1
	move.w	(a0),d2
	move.w	#255,d6
.mloop2	move.w	d1,d0
	muls	d2,d0
	add.l	d0,d0
	swap	d0
	move.b	d0,(a1)+
	addq.w	#1,d1
	dbf	d6,.mloop2
	addq.l	#4,a0
	dbf	d7,.mloop1

	lea	screen1,a0
	move.w	#scrsize,d0
.clr	clr.l	(a0)+
	dbf	d0,.clr


*----------------------------
* PREPARE COPPER, DMA ECT

	lea	CP(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83d0,DMACON(a6)


*-----------------------*
*	MAIN LOOP	*

ML:
;	move.w	#$f00,$180(a6)
	move.l	$4(a6),d0
	lsr.l	#1,d0
	lsr.w	#7,d0
	cmpi.w	#$130,d0
	bne.B	ML
;	clr.w	$180(a6)

	bsr.B	T1
	bsr.W	T2
	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	exit
	 ENDC
	cmp.l	#$73b,counter
	bne.B	ML

exit:	BLTW
	moveq	#0,d0
	rts

*--------------------------
* TASK 1 - the pink circle

T1:	lea	display(pc),a0
	movem.l	(a0),d0-d3
	movem.l	d1-d3,(a0)
	move.l	d0,12(a0)

	move.l	d0,a1
	lea	CPptr1(pc),a0
	moveq	#width,d0
	moveq	#3,d7
	bsr.W	copins

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	display+8(pc),a0
	addq.l	#2,a0
	move.l	a0,BLTDPT(a6)
	move.w	#6,BLTDMOD(a6)
	move.w	#[128*3]<<6+17,BLTSIZE(a6)

	lea	xsinpos(pc),a3
	moveq	#width*3,d3
	moveq	#3,d5

	lea	vinkel(pc),a0
	addq.b	#1,1(a0)
	move.w	(a0),d4
	addi.b	#32,d4
	andi.w	#$7f,d4
	cmp.b	#$40,d4
	bhs.B	.side
	pea	dotty3(pc)
	pea	dotty2(pc)
	lea	dotty1(pc),a5
	bra.B	.ok
.side	pea	dotty6(pc)
	pea	dotty5(pc)
	lea	dotty4(pc),a5
.ok
	move.w	d4,d0
	move.w	d0,d1
	ext.w	d0
	asl.w	#8,d0
	lea	matrixarea+$8000,a0
	lea	(a0,d0.W),a1
	add.w	d1,d1
	move.w	(a3,d1.W),d6
	move.l	display+4(pc),a4
	adda.w	#width,a4
	lea	xpos1(pc),a0
	moveq	#127,d7
	jsr	(a5)

	move.l	display+4(pc),a4
	adda.w	#[width*2],a4
	adda.w	#64*width*3,a4
	lea	xpos2(pc),a0
	moveq	#63,d7
	jsr	(a5)

	move.l	display(pc),a0
	adda.w	#scrsize-6,a0
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0400,$96(a6)
	move.l	#$09f00012,BLTCON0(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a0,BLTDPT(a6)
	move.l	#$00060006,BLTAMOD(a6)
	move.w	#[128*3]<<6+17,BLTSIZE(a6)

	move.w	d4,d0
	subi.b	#$80,d0
	move.w	d0,d1
	ext.w	d0
	asl.w	#8,d0
	lea	matrixarea+$8000,a0
	lea	(a0,d0.W),a1
	add.w	d1,d1
	move.w	(a3,d1.W),d6
	move.l	display+4(pc),a4
	lea	xpos1(pc),a0
	move.l	(sp)+,a5
	moveq	#127,d7
	jsr	(a5)

	move.l	display+4(pc),a4
	adda.w	#64*width*3,a4
	lea	xpos2(pc),a0
	move.l	(sp)+,a5
	moveq	#63,d7
	jsr	(a5)
	rts


dotty1:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	neg.w	d0
	add.w	d6,d0
	move.w	d0,d1			;extra big line
	lsr.w	d5,d0
	not.b	d1
	bset	d1,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty1
	rts
dotty2: move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2

	move.w	d0,d1				;venstre big line ()
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	move.w	d2,d0				;skygge big line
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	bchg	d2,width(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty2
	rts
dotty3:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2

	move.w	d0,d1				;hjer hul line ()
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	move.w	d2,d0				;venstre hul line
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	bchg	d2,width*2(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty3
	rts

dotty4:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	add.w	d6,d0
	move.w	d0,d1
	lsr.w	d5,d0
	not.b	d1
	bset	d1,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty4
	rts
dotty5:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2
	move.w	d0,d1
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	bchg	d1,width(a4,d0.W)
	move.w	d2,d0
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty5
	rts
dotty6: move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2
	move.w	d0,d1
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	bchg	d1,width*2(a4,d0.W)
	move.w	d2,d0
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty6
	rts

* TASK 1 data
display:	dc.l screen1,screen2,screen3,screen4
vinkel:		dc.w 0


xpos1:
 DC.W $80,$8B,$93,$99,$9D,$A1,$A5,$A8
 DC.W $AB,$AD,$B0,$B2,$B5,$B7,$B9,$BB
 DC.W $BD,$BE,$C0,$C2,$C3,$C5,$C7,$C8
 DC.W $C9,$CB,$CC,$CD,$CF,$D0,$D1,$D2
 DC.W $D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB
 DC.W $DC,$DD,$DE,$DF,$E0,$E0,$E1,$E2
 DC.W $E3,$E4,$E4,$E5,$E6,$E7,$E7,$E8
 DC.W $E9,$EA,$EA,$EB,$EB,$EC,$ED,$ED
 DC.W $EE,$EE,$EF,$F0,$F0,$F1,$F1,$F2
 DC.W $F2,$F3,$F3,$F4,$F4,$F4,$F5,$F5
 DC.W $F6,$F6,$F6,$F7,$F7,$F8,$F8,$F8
 DC.W $F9,$F9,$F9,$FA,$FA,$FA,$FA,$FB
 DC.W $FB,$FB,$FB,$FC,$FC,$FC,$FC,$FD
 DC.W $FD,$FD,$FD,$FD,$FD,$FE,$FE,$FE
 DC.W $FE,$FE,$FE,$FE,$FE,$FF,$FF,$FF
 DC.W $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

dat1_circle:
 DC.W $80,$8B,$93,$99,$9D,$A1,$A5,$A8
 DC.W $AB,$AD,$B0,$B2,$B5,$B7,$B9,$BB
 DC.W $BD,$BE,$C0,$C2,$C3,$C5,$C7,$C8
 DC.W $C9,$CB,$CC,$CD,$CF,$D0,$D1,$D2
 DC.W $D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB
 DC.W $DC,$DD,$DE,$DF,$E0,$E0,$E1,$E2
 DC.W $E3,$E4,$E4,$E5,$E6,$E7,$E7,$E8
 DC.W $E9,$EA,$EA,$EB,$EB,$EC,$ED,$ED
 DC.W $EE,$EE,$EF,$F0,$F0,$F1,$F1,$F2
 DC.W $F2,$F3,$F3,$F4,$F4,$F4,$F5,$F5
 DC.W $F6,$F6,$F6,$F7,$F7,$F8,$F8,$F8
 DC.W $F9,$F9,$F9,$FA,$FA,$FA,$FA,$FB
 DC.W $FB,$FB,$FB,$FC,$FC,$FC,$FC,$FD
 DC.W $FD,$FD,$FD,$FD,$FD,$FE,$FE,$FE
 DC.W $FE,$FE,$FE,$FE,$FE,$FF,$FF,$FF
 DC.W $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

dat1_egg:
 DC.W $C0,$C7,$CD,$D1,$D4,$D7,$D9,$DC
 DC.W $DE,$DF,$E1,$E3,$E4,$E5,$E7,$E8
 DC.W $E9,$EA,$EB,$ED,$ED,$EE,$EF,$F0
 DC.W $F1,$F2,$F2,$F3,$F4,$F5,$F5,$F6
 DC.W $F6,$F7,$F8,$F8,$F9,$F9,$F9,$FA
 DC.W $FA,$FB,$FB,$FB,$FC,$FC,$FC,$FD
 DC.W $FD,$FD,$FD,$FE,$FE,$FE,$FE,$FE
 DC.W $FE,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 BLK.W 64,$FF

dat1_pyramid:
 DC.W $80,$81,$82,$83,$84,$85,$86,$87
 DC.W $88,$89,$8A,$8B,$8C,$8D,$8E,$8F
 DC.W $90,$91,$92,$93,$94,$95,$96,$97
 DC.W $98,$99,$9A,$9B,$9C,$9D,$9E,$9F
 DC.W $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7
 DC.W $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF
 DC.W $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7
 DC.W $B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
 DC.W $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7
 DC.W $C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF
 DC.W $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7
 DC.W $D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF
 DC.W $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7
 DC.W $E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
 DC.W $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7
 DC.W $F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF


xpos2:
 DC.W $80,$79,$73,$6F,$6C,$69,$67,$64
 DC.W $62,$61,$5F,$5D,$5C,$5B,$59,$58
 DC.W $57,$56,$55,$53,$53,$52,$51,$50
 DC.W $4F,$4E,$4E,$4D,$4C,$4B,$4B,$4A
 DC.W $4A,$49,$48,$48,$47,$47,$47,$46
 DC.W $46,$45,$45,$45,$44,$44,$44,$43
 DC.W $43,$43,$43,$42,$42,$42,$42,$42
 DC.W $42,$41,$41,$41,$41,$41,$41,$41

dat2_circle:
 DC.W $80,$79,$73,$6F,$6C,$69,$67,$64
 DC.W $62,$61,$5F,$5D,$5C,$5B,$59,$58
 DC.W $57,$56,$55,$53,$53,$52,$51,$50
 DC.W $4F,$4E,$4E,$4D,$4C,$4B,$4B,$4A
 DC.W $4A,$49,$48,$48,$47,$47,$47,$46
 DC.W $46,$45,$45,$45,$44,$44,$44,$43
 DC.W $43,$43,$43,$42,$42,$42,$42,$42
 DC.W $42,$41,$41,$41,$41,$41,$41,$41

dat2_egg:
 dc.w $6E,$6D,$6C,$6B,$6A,$68,$67,$66,$65,$64,$62
 DC.W $61,$60,$5F,$5E,$5D,$5B,$5A,$59,$58,$57,$56,$55,$54,$53,$52,$51
 DC.W $50,$4F,$4E,$4D,$4C,$4B,$4A,$49,$49,$48,$47,$46,$46,$45,$44,$44
 DC.W $43,$42,$42,$41,$41,$40,$40,$3F,$3F,$3F,$3E,$3E,$3E,$3D,$3D,$3D
 DC.W $3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D

dat2_pyramid:
 DC.W $80,$7F,$7E
 DC.W $7D,$7C,$7B,$7A,$79,$78,$77,$76
 DC.W $75,$74,$73,$72,$71,$70,$6F,$6E
 DC.W $6D,$6C,$6B,$6A,$69,$68,$67,$66
 DC.W $65,$64,$63,$62,$61,$60,$5F,$5E
 DC.W $5D,$5C,$5B,$5A,$59,$58,$57,$56
 DC.W $55,$54,$53,$52,$51,$50,$4F,$4E
 DC.W $4D,$4C,$4B,$4A,$49,$48,$47,$46
 DC.W $45,$44,$43,$42,$41,$40,$3F,$3E
 DC.W $3D,$3C,$3B,$3A,$39,$38,$37,$36

dat2_nothing: BLK.W 64,$80


*------------------
* TASK 2 - handler

T2:
	bsr.W	fader
	bsr.W	transform
	lea	counter(pc),a0
	lea	struktur(pc),a1
	addq.l	#1,(a0)
	cmp.l	#$100,(a0)
	bne.B	.no1
	move.l	#dat1_egg,(a1)
.no1	cmp.l	#$1f0,(a0)
	bne.B	.no2
	move.l	#dat2_egg,4(a1)
.no2	cmp.l	#$240,(a0)
	bne.B	.no3
	move.l	#dat1_pyramid,(a1)
.no3	cmp.l	#$360,(a0)
	bne.B	.no4
	move.l	#dat2_pyramid,4(a1)
.no4
	cmp.l	#$4f0,(a0)
	bne.B	.no6
	move.l	#dat2_circle,4(a1)
.no6	cmp.l	#$550,(a0)
	bne.B	.no7
	move.l	#dat1_circle,(a1)
.no7	cmp.l	#$5f0,(a0)
	bne.B	.no8
	move.l	#dat2_nothing,4(a1)
.no8	rts


transform:
	lea	xpos1(pc),a0
	move.l	struktur(pc),a1
	moveq	#127,d7
.comp1	move.w	(a1)+,d0
	cmp.w	(a0),d0
	beq.B	.Bame1
	blo.B	.lower1
	addq.w	#1,(a0)
	bra.B	.Bame1
.lower1	subq.w	#1,(a0)
.Bame1	addq.l	#2,a0
	dbf	d7,.comp1

	lea	xpos2(pc),a0
	move.l	struktur+4(pc),a1
	moveq	#63,d7
.comp2	move.w	(a1)+,d0
	cmp.w	(a0),d0
	beq.B	.same2
	blo.B	.lower2
	addq.w	#1,(a0)
	bra.B	.same2
.lower2	subq.w	#1,(a0)
.same2	addq.l	#2,a0
	dbf	d7,.comp2
	rts


fader:	lea	fadecount(pc),a0
	addq.w	#1,(a0)
	andi.w	#$ff,(a0)
	tst.w	(a0)
	bne.B	.no0
	addq.w	#1,2(a0)
.no0	move.w	(a0),d6

	lea	colors(pc),a1
	move.w	2(a0),d1
	mulu	#6,d1
	adda.w	d1,a1
	lea	colorhide(pc),a0
	moveq	#2,d7
.fadeloop
	move.w	(a0),d0
	move.w	(a1)+,d1
	bsr.W	fade
	andi.w	#$fff,d0
	move.w	d0,(a0)+
	dbf	d7,.fadeloop
	lea	CPcolors(pc),a0
	lea	colorhide(pc),a1
	move.w	(a1),6(a0)
	move.w	2(a1),10(a0)
	move.w	(a1),14(a0)
	move.w	4(a1),18(a0)
	move.w	(a1),22(a0)
	move.w	2(a1),26(a0)
	move.w	(a1),30(a0)
.nofade:
	rts

* TASK 2 data
struktur:	dc.l xpos1,xpos2
counter:	dc.l 0
fadecount:	dc.w 0,0
colorhide:	dc.w 0,0,0
colors:	dc.w $F0F,$A0A,$808
	dc.w $FFF,$AAA,$888
	dc.w $FF0,$AA0,$880
	dc.w $F80,$A60,$840
	dc.w $8F0,$5A0,$280
	dc.w $0F8,$0A6,$084
	dc.w $F0F,$A0A,$808
	dc.w $000,$000,$000


*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800203
 dc.l $008e2881,$009027c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.l $01200000,$01220000,$01400000,$01420000
 dc.l $01080000+[width*2],$010a0000+[width*2]
CPptr1:
 dc.l $00e00000,$00e20000
 dc.l $00e40000,$00e60000
 dc.l $00e80000,$00ea0000
CPcolors:
 dc.l $01800203,$01820000,$01840000,$01860000
 dc.l $01880000,$018a0000,$018c0000,$018e0000
 dc.l $2801fffe,$01003200
 dc.l $a701fffe
 dc.l $01080000+[-width*4]&$FFFF,$010a0000+[-width*4]&$FFFF
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	cmp.b	$6(a6),d0
	bne.B	RC
;	clr.w	$180(a6)
	rts


copins:	move.l	a1,d1
	swap	d1
	move.w	d1,2(a0)
	move.w	a1,6(a0)
	adda.w	d0,a1
	addq.l	#8,a0
	subq.w	#1,d7
	bne.B	copins
	rts

fade:	move.w	d1,d3
	move.w	d0,d1
	move.w	d0,d2
	move.w	d3,d4
	move.w	d3,d5
	andi.w	#$00f,d0
	andi.w	#$0f0,d1
	andi.w	#$f00,d2
	andi.w	#$00f,d3
	andi.w	#$0f0,d4
	andi.w	#$f00,d5
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5
	muls	d6,d3
	muls	d6,d4
	muls	d6,d5
	asr.l	#8,d3
	asr.l	#8,d4
	asr.l	#8,d5
	andi.w	#$fff0,d4
	andi.w	#$ff00,d5
	add.w	d3,d0
	add.w	d4,d1
	add.w	d5,d2
	or.w	d2,d0
	or.w	d1,d0
	rts


xsinpos:
 DC.W $B4,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B2,$B2,$B2,$B2
 DC.W $B2,$B1,$B1,$B1,$B1,$B0,$B0,$B0,$AF,$AF,$AF,$AE,$AE,$AE,$AD,$AD
 DC.W $AC,$AC,$AC,$AB,$AB,$AA,$AA,$A9,$A9,$A8,$A8,$A7,$A7,$A6,$A6,$A5
 DC.W $A5,$A4,$A4,$A3,$A2,$A2,$A1,$A1,$A0,$A0,$9F,$9E,$9E,$9D,$9D,$9C
 DC.W $9B,$9B,$9A,$9A,$99,$99,$98,$97,$97,$96,$96,$95,$95,$94,$93,$93
 DC.W $92,$92,$91,$91,$90,$90,$8F,$8F,$8E,$8E,$8D,$8D,$8C,$8C,$8B,$8B
 DC.W $8B,$8A,$8A,$89,$89,$89,$88,$88,$88,$87,$87,$87,$86,$86,$86,$86
 DC.W $85,$85,$85,$85,$85,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84
 DC.W $84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$85,$85,$85,$85
 DC.W $85,$86,$86,$86,$86,$87,$87,$87,$88,$88,$88,$89,$89,$89,$8A,$8A
 DC.W $8B,$8B,$8B,$8C,$8C,$8D,$8D,$8E,$8E,$8F,$8F,$90,$90,$91,$91,$92
 DC.W $92,$93,$93,$94,$95,$95,$96,$96,$97,$97,$98,$99,$99,$9A,$9A,$9B
 DC.W $9C,$9C,$9D,$9D,$9E,$9E,$9F,$A0,$A0,$A1,$A1,$A2,$A2,$A3,$A4,$A4
 DC.W $A5,$A5,$A6,$A6,$A7,$A7,$A8,$A8,$A9,$A9,$AA,$AA,$AB,$AB,$AC,$AC
 DC.W $AC,$AD,$AD,$AE,$AE,$AE,$AF,$AF,$AF,$B0,$B0,$B0,$B1,$B1,$B1,$B1
 DC.W $B2,$B2,$B2,$B2,$B2,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3

 END

