; MegaPunisherSelector #1
;								TAS / aug1992


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$50000	$52000
*  GFX				$52000	$59000
*  screens			$59000	$60000
*  tables			$60000	$68000
*  MUSIC			$68000	$7f000

; auto js\
 include df0:chipmap.inc
>extern 'df0:logo1.bpl',logo
>extern 'df0:sinfont',sinfont
>extern 'df0:smallfont',font2
>extern 'df0:sin1024.data',sintabel
>extern 'df0:menustreg',streg
>extern 'df0:music68100.CODE',mt_init
>extern 'df0:mod.cosmos',music

width = 40
vec_width = 16

animarea = $3f000
music	 = $6a000
mt_init	= $68100
mt_end	= $68214
mt_play	= $68246


scry = 128
size = [scry+2]*40
screen1 = $5d000
screen2 = screen1+size
textscreen = $59000
animscreen = $59800
filescreen = $5c000

logo 	= $52000
sinfont	= $53d30
font2	= $55770
sintabel = $56680
streg	= $56b80

ytabel	= $58000
ybuffer	= $58400

scroll_len = 240
deltabuffer	= $60000
scrolldata	= $64100
sinfont.coords	= $65000

vectorbuffer = $5f000


BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.B	.\@
	 ENDM


s:	move.l	#struktur,$7ff00
	jsr	j
	rts

struktur:
	dc.w 8
	dc.l file.text
	dc.l title.text
	dc.l scroll.text

file.text:
 dc.b 'x------------------------------'
 dc.b '0TAS SELECTOR         -PARASITE'
 dc.b '1TAS SELECTOR         -PARASITE'
 dc.b '2TAS SELECTOR         -PARASITE'
 dc.b '3TAS SELECTOR         -PARASITE'
 dc.b '4TAS SELECTOR         -PARASITE'
 dc.b '5TAS SELECTOR         -PARASITE'
 dc.b 'x------------------------------'
scroll.text:
 dc.b 'Dette er en lille bitte test...           '
 dc.b 0
title.text:
 dc.b 50
 dc.b 'TAS presents Funky Pack #01',0
 even

 org $50000
 load $50000

*------------------*
* START UP PROGRAM *

j:	lea	DMA,a6
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	move.w	#$01bf,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$36(a6)
	clr.w	$180(a6)
	lea	$bfd100,a0
	bset	#7,(a0)
	and.b	#$87,(a0)
	ori.b	#$78,(a0)

*-------
* SETUP
	lea	$58000,a0
	move.l	#$10000,d0
	bsr.W	clear

	move.l	$7ff00,a0
	move.w	(a0),d0
	cmpi.w	#8,d0
	bls.B	.only8
	moveq	#8,d0
.only8	move.w	d0,antal
	move.l	10(a0),scrolltextptr

	lea	ytabel(pc),a0
	moveq	#0,d0
	moveq	#127,d7
.ytab	move.w	d0,(a0)+
	addi.w	#40,d0
	dbf	d7,.ytab

	lea	scrolldata,a0
	move.w	#scroll_len,d7
	moveq	#-1,d0
.font	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	dbf	d7,.font

	jsr	mt_init
	bsr.W	buildtabels
	bsr.W	makesinfont
	bsr.W	printfiles

	lea	farver(pc),a0
	moveq	#49,d0
.box	movem.l	d0/a0,-(sp)
	divu	#5,d0
	swap	d0
	tst.w	d0
	bne.B	.mod
	addq.w	#1,vectorxy
.mod	bsr.W	filled_vector
	movem.l	(sp)+,d0/a0
	move.w	vectorxy(pc),(a0)+
	dbf	d0,.box

	lea	screen1-40,a0
	move.l	#size*2,d0
	bsr.W	clear

	move.l	$7ff00,a0
	move.l	6(a0),a0
	moveq	#0,d0
	move.b	(a0)+,d0
	move.w	d0,titlepos
	move.l	a0,titlepointer
	clr.w	dont

*----------------------------
* PREPARE COPPER, DMA ECT

	move.w	#$120,d0
	bsr.W	RC
	lea	CP(pc),a0
	move.l	a0,$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)
;	move.w	#$c020,INTENA(a6)

	bsr.W	fade_in

*-----------------------*
*	MAIN LOOP	*

ML:	move.w	#$120,d0
	bsr.W	RC

	bsr.W	box
	bsr.W	select
	bsr.W	scroller
	bsr.W	scroll_handler
	bsr.W	printtitle
	jsr	mt_play
	btst	#6,$bfe001
	bne.B	ML

	move.w	pos(pc),d0
	ext.l	d0
	divu	#9,d0
	lea	filedata(pc),a0
	move.b	(a0,d0.W),d0
	andi.w	#$ff,d0
	cmpi.b	#'x',d0
	beq.B	ML
	move.b	d0,$7ff00
	clr.b	$7ff01

*------*
* EXIT *
	jsr	mt_play
	BLTW
	move.l	#$7fff7fff,INTENA(a6)
	move.l	intregs(pc),d0
	ori.l	#$80008000,d0
	move.l	d0,INTENA(a6)

	move.l	$4.W,a0
	move.l	$9c(a0),a0
	move.l	$26(a0),$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)
	moveq	#0,d0
	rts



*--------------------------
* Vertical filled scroller

scroller:
	lea	display(pc),a0
	movem.l	(a0),d0/d1
	exg	d0,d1
	movem.l	d0/d1,(a0)
	move.l	d1,a0
	swap	d1
	lea	CPbplptr(pc),a1
	move.w	d1,2(a1)
	move.w	a0,6(a1)
	move.w	d1,18(a1)
	move.w	a0,22(a1)

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	d0,BLTDPT(A6)
	clr.w	BLTDMOD(a6)
	move.w	#scry<<6+20,BLTSIZE(a6)

	bsr.W	calcypos

	move.l	display(pc),a1
	lea	ybuffer,a3
	lea	scrolldata,a4
	adda.w	sc_data(pc),a4
	BLTW
	lea	deltabuffer+$2000,a6
	moveq	#0,d0
	moveq	#[scroll_len/8]-1,d7
.loop1	moveq	#7,d6
.loop2
	move.b	(a4)+,d0
	bmi.B	.oops1
	movem.w	(a3)+,d1/d2
	lea	(a1,d1.W),a0
	lea	(a6,d2.W),a5
	move.w	(a5,d0.W),d1
	bchg	d6,(a0,d1.W)
	move.b	(a4)+,d0
	move.w	(a5,d0.W),d1
	bchg	d6,(a0,d1.W)

	move.b	(a4)+,d0
	bmi.B	.oops2
	move.w	(a5,d0.W),d1
	bchg	d6,(a0,d1.W)
	move.b	(a4)+,d0
	move.w	(a5,d0.W),d1
	bchg	d6,(a0,d1.W)

	move.b	(a4)+,d0
	bmi.B	.oops3
	move.w	(a5,d0.W),d1
	bchg	d6,(a0,d1.W)
	move.b	(a4)+,d0
	move.w	(a5,d0.W),d1
	bchg	d6,(a0,d1.W)

	dbf	d6,.loop2
	addq.w	#1,a1
	dbf	d7,.loop1
	bra.B	over
.oops1:	addq.w	#4,a3
	addq.w	#5,a4
	dbf	d6,.loop2
	addq.w	#1,a1
	dbf	d7,.loop1
	bra.B	over
.oops2:	addq.w	#3,a4
	dbf	d6,.loop2
	addq.w	#1,a1
	dbf	d7,.loop1
	bra.B	over
.oops3:	addq.w	#1,a4
	dbf	d6,.loop2
	addq.l	#1,a1
	dbf	d7,.loop1
over:
	lea	DMA,a6
	BLTW
	move.l	display(pc),a0
	lea	-width(a0),a1
	move.l	#$0d3c0000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a0,BLTDPT(a6)
	clr.w	BLTBMOD(a6)
	clr.l	BLTAMOD(a6)
	move.w	#scry<<6+20,BLTSIZE(a6)
	rts

calcypos:
	lea	sindata(pc),a0
	lea	ybuffer,a1
	lea	sinpos(pc),a2
	lea	ytabel,a3
	movem.w	(a2),d0-d3
	move.w	#$1ff,d6
	move.w	#scroll_len-1,d7
.loop1	and.w	d6,d0
	and.w	d6,d1
	and.w	d6,d2
	and.w	d6,d3
	moveq	#0,d4
	moveq	#0,d5
	move.b	(a0,d0.W),d4
	move.b	(a0,d1.W),d5
	add.w	d4,d5
	lsr.w	#2,d5
	move.w	d5,(a1)
	move.b	(a0,d2.W),d4
	move.b	(a0,d3.W),d5
	add.w	d4,d5
	lsr.w	#2,d5

	move.w	(a1),d4
	sub.w	d4,d5
	add.w	d4,d4
	move.w	(a3,d4.W),d4
	asl.w	#6,d5
	move.w	d4,(a1)+
	move.w	d5,(a1)+

	addq.w	#2,d0
	subq.w	#1,d1
	subq.w	#2,d2
	addq.w	#2,d3
	dbf	d7,.loop1
	addq.w	#1,(a2)+
	addq.w	#3,(a2)+
	addq.w	#2,(a2)+
	addq.w	#3,(a2)
	rts


* TASK 1 data
sinpos:		dc.w 0,0,0,0
display:	dc.l screen1,screen2

*
* SINUSDATA "df0:SIN256.512"
*
sindata:
 DC.B $80,$81,$83,$84,$86,$87,$89,$8A,$8C,$8E,$8F,$91,$92,$94,$95
 DC.B $97,$98,$9A,$9C,$9D,$9F,$A0,$A2,$A3,$A5,$A6,$A8,$A9,$AB,$AC
 DC.B $AE,$AF,$B0,$B2,$B3,$B5,$B6,$B8,$B9,$BA,$BC,$BD,$BF,$C0,$C1
 DC.B $C3,$C4,$C5,$C7,$C8,$C9,$CA,$CC,$CD,$CE,$CF,$D1,$D2,$D3,$D4
 DC.B $D5,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,$E0,$E1,$E2,$E3,$E4
 DC.B $E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$EC,$ED,$EE,$EF,$F0,$F0,$F1
 DC.B $F2,$F3,$F3,$F4,$F5,$F5,$F6,$F6,$F7,$F7,$F8,$F9,$F9,$FA,$FA
 DC.B $FA,$FB,$FB,$FC,$FC,$FC,$FD,$FD,$FD,$FE,$FE,$FE,$FE,$FF,$FF
 DC.B $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 DC.B $FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE,$FD,$FD,$FD,$FC,$FC,$FC,$FB
 DC.B $FB,$FA,$FA,$FA,$F9,$F9,$F8,$F7,$F7,$F6,$F6,$F5,$F5,$F4,$F3
 DC.B $F3,$F2,$F1,$F0,$F0,$EF,$EE,$ED,$EC,$EC,$EB,$EA,$E9,$E8,$E7
 DC.B $E6,$E5,$E4,$E3,$E2,$E1,$E0,$DF,$DE,$DD,$DC,$DB,$DA,$D9,$D8
 DC.B $D7,$D5,$D4,$D3,$D2,$D1,$CF,$CE,$CD,$CC,$CA,$C9,$C8,$C7,$C5
 DC.B $C4,$C3,$C1,$C0,$BF,$BD,$BC,$BA,$B9,$B8,$B6,$B5,$B3,$B2,$B0
 DC.B $AF,$AE,$AC,$AB,$A9,$A8,$A6,$A5,$A3,$A2,$A0,$9F,$9D,$9C,$9A
 DC.B $98,$97,$95,$94,$92,$91,$8F,$8E,$8C,$8A,$89,$87,$86,$84,$83
 DC.B $81,$7F,$7E,$7C,$7B,$79,$78,$76,$75,$73,$71,$70,$6E,$6D,$6B
 DC.B $6A,$68,$67,$65,$63,$62,$60,$5F,$5D,$5C,$5A,$59,$57,$56,$54
 DC.B $53,$51,$50,$4F,$4D,$4C,$4A,$49,$47,$46,$45,$43,$42,$40,$3F
 DC.B $3E,$3C,$3B,$3A,$38,$37,$36,$35,$33,$32,$31,$30,$2E,$2D,$2C
 DC.B $2B,$2A,$28,$27,$26,$25,$24,$23,$22,$21,$20,$1F,$1E,$1D,$1C
 DC.B $1B,$1A,$19,$18,$17,$16,$15,$14,$13,$13,$12,$11,$10,$0F,$0F
 DC.B $0E,$0D,$0C,$0C,$0B,$0A,$0A,$09,$09,$08,$08,$07,$06,$06,$05
 DC.B $05,$05,$04,$04,$03,$03,$03,$02,$02,$02,$01,$01,$01,$01,$00
 DC.B $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 DC.B $00,$00,$00,$00,$00,$01,$01,$01,$01,$02,$02,$02,$03,$03,$03
 DC.B $04,$04,$05,$05,$05,$06,$06,$07,$08,$08,$09,$09,$0A,$0A,$0B
 DC.B $0C,$0C,$0D,$0E,$0F,$0F,$10,$11,$12,$13,$13,$14,$15,$16,$17
 DC.B $18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$20,$21,$22,$23,$24,$25,$26
 DC.B $27,$28,$2A,$2B,$2C,$2D,$2E,$30,$31,$32,$33,$35,$36,$37,$38
 DC.B $3A,$3B,$3C,$3E,$3F,$40,$42,$43,$45,$46,$47,$49,$4A,$4C,$4D
 DC.B $4F,$50,$51,$53,$54,$56,$57,$59,$5A,$5C,$5D,$5F,$60,$62,$63
 DC.B $65,$67,$68,$6A,$6B,$6D,$6E,$70,$71,$73,$75,$76,$78,$79,$7B
 DC.B $7C,$7E

*----------------*
* Scroll handler *

Scroll_handler:
	lea	sc_data(pc),a3
	move.w	(a3),d0
	move.w	d0,d1
	addi.w	#12,d0
	cmpi.w	#scroll_len*6,d0
	blo.B	.lower
	clr.w	d0
.lower	move.w	d0,(a3)+
	lea	scrolldata,a2
	adda.w	d1,a2

	lea	scrolltextptr(pc),a1
	move.l	(a1),a0
	addq.w	#2,(a3)
	cmpi.w	#16,(a3)
	bne.S	.NOPE
	clr.w	(a3)
.gettxt	addq.l	#1,a0
	tst.b	(a0)
	bne.B	.newtxt1
	lea	credit.text(pc),a0
.newtxt1
	cmpi.b	#$EF,(a0)
	bne.B	.newtxt2
	move.l	$7ff00,a0
	move.l	10(a0),a0
.newtxt2
	cmpi.b	#10,(a0)
	beq.B	.gettxt
.NOPE
	move.l	a0,(a1)

	moveq	#0,d0
	move.b	(a0),d0
	subi.b	#' ',d0
	andi.w	#$7f,d0
	mulu	#6*16,d0
	move.w	(a3),d1
	mulu	#6,d1
	lea	sinfont.coords,a0
	add.w	d1,d0
	adda.w	d0,a0
	lea	scroll_len*6(a2),a3
	move.l	(a0),(a2)+
	move.l	(a0)+,(a3)+
	move.l	(a0),(a2)+
	move.l	(a0)+,(a3)+
	move.l	(a0),(a2)+
	move.l	(a0)+,(a3)+
	rts
* SCROLL data
sc_data:	dc.w 0,0
scrolltextptr:	dc.l 0
credit.text:
 dc.b `          \\ Intro rushed by TAS  \\  `
 dc.b `Music by Liquid  \\  Logo by JTF  \\  Font by AirWalk/Kefrens  \\  `
 dc.b `                        `,$EF
 even


*----------*
* SELECTOR *

select:	lea	CPselect+6(pc),a0
	moveq	#6,d7
.loop	move.w	(a0),d0
	bsr.W	sel_fade
	move.w	d0,(a0)
	addq.w	#8,a0
	dbf	d7,.loop
	lea	CPselect8+6(pc),a0
	move.w	(a0),d0
	bsr.W	sel_fade
	move.w	d0,(a0)

	move.b	$a(a6),d0
	move.b	oldy(pc),d1
	move.b	d0,oldy
	sub.b	d1,d0
	neg.b	d0
	ext.w	d0
	cmpi.w	#9,d0
	ble.B	.max
	moveq	#9,d0
.max	cmpi.w	#-9,d0
	bge.B	.min
	moveq	#-9,d0
.min
	move.w	pos(pc),d1
	sub.w	d0,d1
	bpl.B	.ok1
	clr.w	d1
.ok1	move.w	antal(pc),d2
	mulu	#9,d2
	subq.w	#1,d2
	cmp.w	d2,d1
	ble.B	.ok2
	move.w	d2,d1
.ok2	move.w	d1,pos
	ext.l	d1
	divu	#9,d1
	cmpi.w	#7,d1
	beq.B	.sel8
	lea	CPselect(pc),a0
	lsl.w	#3,d1
	move.w	#$fff,6(a0,d1.W)
	rts
.sel8:	lea	CPselect8+6(pc),a0
	move.w	#$fff,(a0)
	rts

sel_fade:
	move.w	(a0),d0
	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f00,d1
	andi.w	#$0f0,d2
	cmpi.w	#$200,d1
	beq.B	.fade1
	subi.w	#$100,d1
.fade1	cmpi.w	#$40,d2
	beq.B	.fade2
	subi.w	#$010,d2
.fade2	andi.w	#$00f,d0
	or.w	d1,d0
	or.w	d2,d0
	rts
* Select data
pos:	dc.w 0
oldy:	dc.w 0



*-----*
* BOX *

box:	lea	counter(pc),a0
	addq.w	#1,(a0)
	cmpi.w	#50,(a0)
	bne.B	.nores
	clr.w	(a0)
.nores	move.w	(a0),d0
	mulu	#10*66*2,d0
	lea	animarea,a0
	adda.l	d0,a0
	lea	animscreen,a1
	adda.w	#[40*80]+30,a1

	lea	ysize(pc),a2
	cmpi.w	#66,(a2)
	beq.B	.sizeok
	addq.w	#1,(a2)
.sizeok	move.w	(a2),d0
	lsl.w	#7,d0
	addq.w	#5,d0
	BLTW
	move.l	#$09f00000,BLTCON0(a6)
	moveq	#-1,d1
	move.l	d1,BLTAFWM(a6)
	clr.w	BLTAMOD(a6)
	move.w	#40-10,BLTDMOD(a6)
	movem.l	a0/a1,BLTAPT(a6)
	move.w	d0,BLTSIZE(a6)

	move.w	counter(pc),d0
	add.w	d0,d0
	move.w	farver(PC,d0.W),d0
	asr.w	#5,d0
	lea	boxfarver(pc),a0
	move.w	d0,d1
	move.w	d0,6(a0)
	mulu	#$111,d0		;color of P
	move.w	d0,10(a0)
	subq.b	#8,d1
	andi.w	#$f,d1
	move.w	d1,2(a0)
	rts
* box data
counter:	dc.w 0
ysize:		dc.w 0
farver:		ds.w 50



*---------*
* FADE IN *

fade_in:
	moveq	#0,d3
.loop	lea	logocolors(pc),a0
	lea	CPlogocolors(pc),a1
	move.w	#$120,d0
	bsr.W	RC
	addq.w	#1,d0
	bsr.W	RC
	moveq	#6,d7
.fade1	move.w	(a0)+,d0
	bsr.W	fade
	move.w	d0,2(a1)
	addq.l	#4,a1
	dbf	d7,.fade1

	move.w	#$fff,d0
	bsr.W	fade
	lea	CPselect(pc),a0
	moveq	#6,d7
.fade2	move.w	d0,6(a0)
	addq.l	#8,a0
	dbf	d7,.fade2
	lea	CPselect8(pc),a0
	move.w	d0,6(a0)

	lea	barcolors(pc),a0
	lea	CPbar1(pc),a1
	lea	CPbar2(pc),a2
	moveq	#15,d7
.fade3	move.w	(a0)+,d0
	bsr.W	fade
	move.w	d0,2(a1)
	move.w	d0,2(a2)
	addq.l	#4,a1
	addq.l	#4,a2
	dbf	d7,.fade3

	subq.b	#1,sprite+1
	addq.w	#1,d3
	cmpi.w	#17,d3
	bne.B	.loop
	rts

*--------------*
* BUILD TABELS *

buildtabels:
	lea	deltabuffer,a0
	moveq	#16-5,d3		;idet 1<<5 = 32
	moveq	#-128,d5
	move.w	#255,d7
.loop1	move.l	d5,d1
	asl.l	d3,d1
	moveq	#0,d2
	moveq	#31,d6			;32 opdelinger
.loop2	add.l	d1,d2
	move.l	d2,d0
	swap	d0
	muls	#40,d0
	move.w	d0,(a0)+
	dbf	d6,.loop2
	addq.l	#1,d5
	dbf	d7,.loop1
	rts

*--------------*
* Make Sinfont *

makesinfont:
	lea	sinfont.coords,a0
	move.w	#$5ff,d0
	moveq	#-1,d1
.clr	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,.clr

	lea	sinfont.coords,a0
	lea	sinfont(pc),a2
	moveq	#40,d3
	moveq	#4,d7
.yloop	move.l	a2,a3
	moveq	#39,d6
.xloop	moveq	#7,d5
.bit1	move.l	a0,a1
	move.l	a3,a4
	moveq	#-2,d4
.bit2	addq.b	#2,d4

	btst	d5,(a4)
	beq.B	.try_again
	btst	d5,40(a4)
	bne.B	.nochg
	move.b	d4,(a1)
	subq.b	#2,(a1)+
	bra.B	.nochg
.try_again
	btst	d5,(a4)
	bne.B	.nochg
	btst	d5,40(a4)
	beq.B	.nochg
	move.b	d4,(a1)+
.nochg
	adda.w	d3,a4
	cmpi.b	#64,d4
	bne.B	.bit2

	addq.w	#6,a0
	dbf	d5,.bit1
	addq.w	#1,a3
	dbf	d6,.xloop
	adda.w	#33*40,a2
	dbf	d7,.yloop
	rts


*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	dcb.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e3081,$009024c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.l $01080000,$010a0000
 dc.w $0120,sprite/$10000
 dc.w $0122,sprite&$ffff
 dc.l $01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
 dc.l $01a20458,$01a40347,$01a60236

 dc.l $00e00000+[logo/$10000]
 dc.l $00e20000+[logo&$ffff]
 dc.l $00e40000+[logo/$10000]
 dc.l $00e60000+[logo&$ffff]+[62*40]
 dc.l $00e80000+[logo/$10000]
 dc.l $00ea0000+[logo&$ffff]+[62*40*2]
CPlogocolors:
 dc.l $01820000,$01840000,$01860000,$01880000,$018a0000,$018c0000,$018e0000

 dc.l $3001fffe,$01003200
 dc.l $6a01fffe,$01000200
 dc.w $00e0,textscreen/$10000
 dc.w $00e2,textscreen&$ffff
 dc.w $00e4,textscreen/$10000
 dc.w $00e6,[textscreen&$ffff]+40
 dc.l $01820bcc,$018409aa,$01860023
 dc.w $0108,40,$010a,40

 dc.l $7801fffe,$01002200
 dc.l $8001fffe,$01860134
 dc.l $8401fffe,$01860245
 dc.l $8601fffe,$01860356
 dc.l $8a01fffe,$01000200

CPbar1:
 dc.l $01800000,$01820000,$01840000,$01860000
 dc.l $01880000,$018a0000,$018c0000,$018e0000
 dc.l $01900000,$01920000,$01940000,$01960000
 dc.l $01980000,$019a0000,$019c0000,$019e0000
 dc.l $01080000,$010a0000

 dc.l $8c01fffe
 dc.l $01004200
 dc.w $00e0,streg/$10000
 dc.w $00e2,streg&$ffff
 dc.w $00e4,streg/$10000
 dc.w $00e6,streg&$ffff+[6*40]
 dc.w $00e8,streg/$10000
 dc.w $00ea,streg&$ffff+[12*40]
 dc.w $00ec,streg/$10000
 dc.w $00ee,streg&$ffff+[18*40]

 dc.l $8f01fffe
 dc.l $01000200
CPbplptr:
	dc.w $00e0,screen1/$10000
	dc.w $00e2,screen1&$ffff
	dc.w $00e4,animscreen/$10000
	dc.w $00e6,animscreen&$ffff
	dc.w $00e8,screen1/$10000
	dc.w $00ea,screen1&$ffff
	dc.w $00ec,animscreen/$10000
	dc.w $00ee,[animscreen&$ffff]+40
boxfarver:
 dc.l $01920000,$01940000,$01960000
 dc.w $0108,0,$010a,40

 dc.l $9001fffe
 dc.l $01004600
 dc.l $01800000,$01860888
 dc.l $9201fffe,$01860999
 dc.l $9501fffe,$01860AAA
 dc.l $9901fffe,$01860BBB
 dc.l $9e01fffe,$01860CCC
 dc.l $a401fffe,$01860DDD
 dc.l $ad01fffe,$01860EEE
 dc.l $b501fffe,$01860FFF
 dc.l $01004600
 dc.w $00e8,filescreen/$10000
 dc.w $00ea,filescreen&$ffff
CPselect:
 dc.l $01820FFF,$01840000
 dc.l $be01fffe,$01840000
 dc.l $c701fffe,$01840000
 dc.l $d001fffe,$01840000
 dc.l $d901fffe,$01840000
 dc.l $e201fffe,$01840000
 dc.l $eb01fffe,$01840000

 dc.l $ed01fffe,$01820EEE,$01860EEE
CPselect8:
 dc.l $f401fffe,$01840000
 dc.l $f501fffe,$01820DDD,$01860DDD
 dc.l $fc01fffe,$01820CCC,$01860CCC
 dc.l $ffe1fffe
 dc.l $0201fffe,$01820BBB,$01860BBB
 dc.l $0701fffe,$01820AAA,$01860AAA
 dc.l $0b01fffe,$01820999,$01860999
 dc.l $0e01fffe,$01820888,$01860888
 dc.l $1001fffe
 dc.l $01001200,$01020001
 dc.w $0108,-120
 dc.l $01820777
 dc.l $1101fffe,$01820666,$01020002
 dc.l $1201fffe,$01820555,$01020003
 dc.l $1401fffe,$01820444,$01020004
 dc.l $1801fffe,$01820333,$01020005
 dc.l $1c01fffe,$01020006
 dc.l $2001fffe,$01000200

CPbar2:
 dc.l $01800000,$01820000,$01840000,$01860000
 dc.l $01880000,$018a0000,$018c0000,$018e0000
 dc.l $01900000,$01920000,$01940000,$01960000
 dc.l $01980000,$019a0000,$019c0000,$019e0000
 dc.l $01020000,$01080000,$010a0000

 dc.l $2101fffe,$01800000
 dc.l $01004200
 dc.w $00e0,streg/$10000
 dc.w $00e2,streg&$ffff+[3*40]
 dc.w $00e4,streg/$10000
 dc.w $00e6,streg&$ffff+[9*40]
 dc.w $00e8,streg/$10000
 dc.w $00ea,streg&$ffff+[15*40]
 dc.w $00ec,streg/$10000
 dc.w $00ee,streg&$ffff+[21*40]
 dc.l $fffffffe

logocolors:
	DC.W	$0016,$0003,$0BDF,$08AD,$057B,$024A,$0028
barcolors:
	DC.W	$0000,$0AAE,$0FFF,$0CCF,$088D,$055A,$0337,$0002
	DC.W	$0114,$0EEF,$0026,$077C,$0448,$0014,$0003,$0000
sprite:
 dc.w $18e9,$2307
 dc.w $0000,$0000, $f270,$0000, $2700,$0040, $0000,$2520
 dc.w $0000,$2710, $38f0,$38f0, $0000,$0000, $0000,$0000
 dc.w $0000,$0000, $0000,$0000, $0000,$0000, $0000,$0000


*--------------*
* TEXT PRINT 1 *

printtitle:
	tst.w	dont
	beq.B	.ok
	rts
.ok	move.l	titlepointer(pc),a0
	lea	textscreen,a3
	moveq	#40,d3
	move.w	titlepos(pc),d6
	moveq	#0,d0
	move.b	(a0)+,d0
	beq.B	.xit
	cmpi.b	#'$',d0
	blo.B	.kiks
	subq.b	#1,d0
.kiks	subi.b	#' ',d0
	andi.w	#$7f,d0
	move.w	d0,d5
	divu	#40,d0
	move.w	d0,d1
	swap	d0
	mulu	#32*40,d1
	add.w	d1,d0
	lea	font2,a1
	adda.w	d0,a1

	move.w	d6,d0
	lsr.w	#3,d0
	lea	(a3,d0.W),a2
	move.w	d6,d0
	not.b	d0
	andi.w	#7,d0
	moveq	#0,d1
	moveq	#31,d4
.print	move.b	(a1),d1
	lsl.w	d0,d1
	or.b	d1,1(a2)
	lsr.w	#8,d1
	or.b	d1,(a2)
	adda.w	d3,a1
	adda.w	d3,a2
	dbf	d4,.print

	moveq	#0,d0
	move.b	alfasize(PC,d5.W),d0
	add.w	d0,d6
	cmpi.w	#320,d6
	bhs.B	.xit
	move.l	a0,titlepointer
	move.w	d6,titlepos
	rts
.xit	move.w	#-1,dont
	rts

* TITLE data
dont:		dc.w 0
titlepointer:	dc.l 0
titlepos:	dc.w 0
alfasize:
 dc.b 8,4,6,8,8,8,4,6,6,8,8,4,8,4,8
 dc.b 8,8,8,8,8,8,8,8,8,8
 dc.b 4,4,8,8,8,8,8
 blk.b 26,8
 dc.b 8,8,8,8,8,8
 dc.b 8,8,8,8,8,7,8,8,4,5,8,4,8,8,8,8,8,8,8,6,8,8,8,8,8,8
 blk.b 38,8

*--------------*
* TEXT PRINT 2 *

printfiles:
	lea	filescreen,a0
	move.l	#$1000,d0
	bsr.W	clear

	move.w	antal(pc),d7
	move.l	$7ff00,a0
	move.l	2(a0),a0
	lea	filescreen,a2
	lea	filedata(pc),a4
	subq.w	#1,d7
	moveq	#40,d4
.loop1	move.b	(a0)+,(a4)+
	moveq	#29,d6
.loop2	move.b	(a0)+,d0
	subi.b	#' ',d0
	andi.w	#$7f,d0
	lsl.w	#3,d0
	lea	smallfont(pc),a1
	adda.w	d0,a1
	move.l	a2,a3	
	moveq	#7,d5
.print	move.b	(a1)+,(a3)
	adda.w	d4,a3
	dbf	d5,.print
	addq.l	#1,a2
	dbf	d6,.loop2
	adda.w	#[40*8]+10,a2
	dbf	d7,.loop1
	rts

antal:		dc.w 0
filedata:	dcb.b 8

*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$400,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmp.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

fade:	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f,d0
	andi.w	#$f0,d1
	andi.w	#$f00,d2
	mulu	d3,d0
	mulu	d3,d1
	mulu	d3,d2
	andi.w	#$f0,d0
	andi.w	#$f00,d1
	andi.w	#$f000,d2
	or.w	d1,d0
	or.w	d2,d0
	lsr.w	#4,d0
	rts


smallfont:
 dc.b	$00,$00,$00,$00,$00,$00,$00,$00	;" "
 dc.b	$18,$3C,$3C,$18,$18,$00,$18,$00	;"!"
 dc.b	$36,$36,$6C,$00,$00,$00,$00,$00	;"""
 dc.b	$00,$6C,$FE,$6C,$FE,$6C,$00,$00	;"#"
 dc.b	$18,$7E,$F0,$7C,$1E,$FC,$30,$00	;"$"
 dc.b	$C6,$8E,$1C,$38,$70,$E6,$C4,$00	;"%"
 dc.b	$78,$CC,$68,$36,$5A,$CC,$76,$00	;"&"
 dc.b	$18,$18,$30,$00,$00,$00,$00,$00	;"'"
 dc.b	$1C,$30,$60,$60,$70,$30,$1C,$00	;"("
 dc.b	$70,$18,$0C,$0C,$1C,$18,$70,$00	;")"
 dc.b	$00,$6C,$38,$7C,$38,$6C,$00,$00	;"*"
 dc.b	$00,$18,$18,$7E,$18,$18,$00,$00	;"+"
 dc.b	$00,$00,$00,$00,$00,$18,$18,$30	;","
 dc.b	$00,$00,$00,$7E,$00,$00,$00,$00	;"-"
 dc.b	$00,$00,$00,$00,$00,$18,$18,$00	;"."
 dc.b	$06,$0E,$1C,$38,$70,$E0,$C0,$00	;"/"
 dc.b	$3C,$66,$66,$6E,$76,$76,$3C,$00	;"0"
 dc.b	$08,$18,$38,$18,$1C,$1C,$3E,$00	;"1"
 dc.b	$7C,$66,$4C,$38,$70,$66,$7E,$00	;"2"
 dc.b	$7C,$66,$4C,$18,$4C,$66,$7C,$00	;"3"
 dc.b	$36,$66,$36,$1A,$0C,$06,$06,$00	;"4"
 dc.b	$1E,$36,$60,$3C,$46,$6C,$78,$00	;"5"
 dc.b	$3C,$60,$30,$58,$6C,$66,$3C,$00	;"6"
 dc.b	$7A,$66,$4C,$18,$18,$18,$18,$00	;"7"
 dc.b	$3C,$66,$34,$18,$2C,$66,$3C,$00	;"8"
 dc.b	$3C,$66,$36,$1A,$0C,$06,$3C,$00	;"9"
 dc.b	$00,$18,$18,$00,$00,$18,$18,$00	;":"
 dc.b	$00,$18,$18,$00,$00,$18,$18,$30	;";"
 dc.b	$0C,$18,$30,$60,$30,$18,$0C,$00	;"<"
 dc.b	$00,$00,$7E,$00,$7E,$00,$00,$00	;"="
 dc.b	$30,$18,$0C,$06,$0C,$18,$30,$00	;">"
 dc.b	$7C,$66,$5C,$38,$30,$00,$30,$30	;"?"
 dc.b	$30,$30,$18,$00,$00,$00,$00,$00	;"`"
 dc.b	$00,$3C,$66,$C6,$FE,$E6,$E6,$00	;"a"
 dc.b	$00,$F8,$CC,$D8,$EC,$E6,$FC,$00	;"b"
 dc.b	$00,$7C,$C6,$C0,$E0,$E6,$7C,$00	;"c"
 dc.b	$00,$F8,$CC,$C6,$E6,$E6,$FC,$00	;"d"
 dc.b	$00,$FE,$C6,$F0,$E0,$E6,$FE,$00	;"e"
 dc.b	$00,$FE,$C6,$F0,$E0,$E0,$E0,$00	;"f"
 dc.b	$00,$7C,$C0,$CE,$E6,$E6,$7E,$00	;"g"
 dc.b	$00,$C6,$C6,$DE,$E6,$E6,$E6,$00	;"h"
 dc.b	$00,$FE,$30,$30,$38,$38,$FE,$00	;"i"
 dc.b	$00,$3E,$06,$1E,$0E,$CE,$7C,$00	;"j"
 dc.b	$00,$C6,$CC,$D8,$EC,$E6,$E6,$00	;"k"
 dc.b	$00,$C0,$C0,$C0,$E0,$E6,$FE,$00	;"l"
 dc.b	$00,$C6,$EE,$FE,$D6,$E6,$E6,$00	;"m"
 dc.b	$00,$C6,$E6,$F6,$DE,$EE,$E6,$00	;"n"
 dc.b	$00,$7C,$C6,$C6,$E6,$E6,$7C,$00	;"o"
 dc.b	$00,$FC,$C6,$CC,$D8,$E0,$E0,$00	;"p"
 dc.b	$00,$7C,$C6,$C6,$CE,$CE,$7E,$00	;"q"
 dc.b	$00,$FC,$C6,$CC,$D8,$EC,$E6,$00	;"r"
 dc.b	$00,$3E,$66,$3A,$8C,$C6,$FC,$00	;"s"
 dc.b	$00,$FE,$B2,$30,$38,$38,$7C,$00	;"t"
 dc.b	$00,$C6,$C6,$C6,$E6,$E6,$7E,$00	;"u"
 dc.b	$00,$C6,$C6,$C6,$E6,$6C,$38,$00	;"v"
 dc.b	$00,$C6,$C6,$C6,$F6,$FE,$EE,$00	;"w"
 dc.b	$00,$EE,$6C,$38,$38,$6C,$EE,$00	;"x"
 dc.b	$00,$EE,$6C,$38,$30,$38,$7C,$00	;"y"
 dc.b	$00,$FE,$CC,$18,$30,$76,$FE,$00	;"z"
 dc.b	$1C,$30,$30,$30,$38,$38,$1C,$00	;"{"
 dc.b	$18,$18,$18,$18,$18,$18,$18,$00	;"|"
 dc.b	$38,$0C,$0C,$0C,$1C,$1C,$38,$00	;"}"




*------------------------
* filled vector routine

filled_vector:
	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	clr.w	$74(a6)
	lea	screen1,a0
	move.l	a0,BLTDPT(a6)
	move.w	#vec_width-12,BLTDMOD(a6)
	move.w	#80<<7+6,BLTSIZE(a6)

	lea	vectorxy(pc),a4
	lea	sintabel,a1
	lea	256(a1),a2
	move.w	(a4),d0
	addi.w	#10,(a4)
	andi.w	#$3fe,d0
	lea	calc+2(pc),a0
	move.w	(a1,d0.W),(a0)
	move.w	(a1,d0.W),4(a0)
	move.w	(a2,d0.W),8(a0)
	move.w	(a2,d0.W),12(a0)

	lea	vectorbuffer,a3
	lea	vec_obj.coords(pc),a0
	moveq	#15,d5
.vecloop1
	movem.w	(a0)+,d0-d2
	bsr.W	vectorcalc
	neg.w	d0
	addi.w	#40,d0
	addi.w	#33,d1
	move.w	d0,(a3)+
	move.w	d1,(a3)+
	cmpi.w	#$8000,(a0)
	bne.B	.vecloop1

	bsr.W	polykill

	lea	vec_obj.data(pc),a0
	lea	vectorbuffer,a1
	BLTW
	move.w	#$ffff,$44(a6)
	move.l	#$ffff8000,$72(a6)
	move.w	#vec_width*2,$60(a6)
	move.w	#vec_width*2,$66(a6)
.vecloop2
	moveq	#0,d7
	tst.b	(a0)+
	beq.B	.vecloop2a
	bmi.B	.vecdrawend
	move.b	(a0)+,d7
	lea	2(a0,d7.W),a0
	bra.B	.vecloop2
.vecloop2a
	move.b	(a0)+,d7
	subq.w	#1,d7
	move.b	(a0)+,color
.vecloop2b
	moveq	#0,d5
	moveq	#0,d6
	move.b	(a0)+,d5
	move.b	(a0),d6
	movem.w	(a1,d5.W),d0/d1
	movem.w	(a1,d6.W),d2/d3
	bsr.W	drawvector
	dbf	d7,.vecloop2b
	addq.l	#1,a0
	bra.B	.vecloop2
.vecdrawend

	lea	screen1,a0
	adda.w	#[80*vec_width*2]+10,a0
	moveq	#vec_width-12,d0
	move.l	a0,a1
	BLTW
	move.l	#$09f00012,BLTCON0(a6)
	moveq	#-1,d1
	move.l	d1,BLTAFWM(a6)
	movem.l	a0/a1,BLTAPT(a6)
	move.w	d0,BLTAMOD(a6)
	move.w	d0,BLTDMOD(a6)
	move.w	#80<<7+6,BLTSIZE(a6)

	lea	animptr(pc),a4
	move.l	(a4),a3
	lea	screen1,a0
	BLTW
	move.l	#$09f00000,BLTCON0(a6)
	movem.l	a0/a3,BLTAPT(a6)
	move.w	#vec_width-10,BLTAMOD(a6)
	clr.w	BLTDMOD(a6)
	move.w	#66<<7+5,BLTSIZE(a6)
	adda.l	#10*66*2,(a4)
	rts

vectorcalc:
	exg	d1,d2
	neg.w	d1
	muls	#$7fff,d1
	muls	#$7fff,d2
	asr.l	d5,d1
	asr.l	d5,d2
	move.w	d2,d4
	move.w	d0,d3
calc	muls	#0,d4
	muls	#0,d3
	muls	#0,d0
	muls	#0,d2
	sub.l	d4,d0
	add.l	d3,d2
	asr.l	d5,d0
	asr.l	d5,d2
	addi.w	#800,d2
	lsl.l	#8,d0
	lsl.l	#8,d1
	divs	d2,d0
	divs	d2,d1
	rts	

drawvector:
	cmp.w	d1,d3
	bgt.B	.vecexg
	exg	d0,d2
	exg	d1,d3
	beq.W	noline
.vecexg
	move.w	d1,d4
	sub.w	d3,d4
	cmp.w	d0,d2
	beq.B	.draw4
	blo.B	.draw2
	move.w	d0,d5
	sub.w	d2,d5
	bra.B	.draw3
.vectorcontrol dc.b $01,$11,$09,$15,$05,$19,$0d,$1d
.draw2	move.w	d2,d5
	sub.w	d0,d5
.draw3	add.w	d4,d4
	cmp.w	d4,d5
	bhi.B	.draw4
	subq.w	#1,d3
.draw4	moveq	#0,d4
	move.w	d1,d4
	mulu	#vec_width*2,d4
	moveq   #-16,d5
	and.w	d0,d5
	lsr.w	#3,d5
	add.w	d5,d4
	add.l	#screen1,d4
	moveq	#0,d5
	sub.w	d1,d3
	bge.B	.draw5
	neg.w	d3
.draw5	sub.w	d0,d2
	roxl.b	#1,d5
	tst.w	d2
	bge.B	.draw6
	neg.w	d2
.draw6	move.w	d3,d1
	sub.w	d2,d1
	bge.B	.draw7
	exg	d2,d3
.draw7	roxl.b	#1,d5
	move.b	.vectorcontrol(pc,d5.W),d5
	andi.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0b4a,d0
	add.w	d2,d2
	move.w	d2,d1
	sub.w	d3,d2
	bge.B	.draw8
	ori.b	#$40,d5
.draw8	ori.b	#3,d5
	move.w	d2,d6
	sub.w	d3,d2
	lsl.w	#6,d3
	addq.w	#2,d3
	btst	#0,color
	beq.B	.col1
	BLTW
	movem.w	d0/d5,$40(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
.col1	addi.l	#vec_width,d4
	btst	#1,color
	beq.B	noline
	BLTW
	movem.w	d0/d5,$40(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d6,$52(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d3,$58(a6)
noline	rts


polykill:
	lea	vectorbuffer,a0
	lea	vec_obj.data(pc),a1
.loop	clr.b	(a1)
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	move.b	3(a1),d0
	move.b	4(a1),d1
	move.b	5(a1),d2
	movem.w	(a0,d1.W),d3/d4
	movem.w	(a0,d2.W),d5/d6
	movem.w	(a0,d0.W),d0/d1
	sub.w	d3,d0
	sub.w	d4,d1
	sub.w	d3,d5
	sub.w	d4,d6
	muls	d1,d5
	muls	d0,d6
	sub.l	d6,d5
	bmi.B	.polykillA
	move.b	#1,(a1)
.polykillA
	moveq	#0,d0
	move.b	1(a1),d0
	lea	4(a1,d0.W),a1
	tst.b	(a1)
	bpl.B	.loop
	rts

* Vector data
animptr:	dc.l animarea
vectorxy:	dc.w 0
color:		dc.b 0
 even

*--------------------*
* VECTOR OBJECT DATA *

vec_obj.data:
 dc.b 0,4,2, 4,16,20,0,4
 dc.b 0,4,2, 24,8,12,28,24
 dc.b 0,16,1, 32,36,40,44,48,52,56,60,64,68,72, 76,80,84,88,92,32
 dc.b 0,6,1, 96,100,104,108,112,116,96
 dc.b 0,4,1, 24,16,4,8,24
 dc.b 0,4,1, 12,0,20,28,12
; dc.b 0,4,1, 8,4,0,12,8
; dc.b 0,4,1, 16,24,28,20,16
 dc.b -1
 even
vec_obj.coords:
 dc.w 20,90,-90,	20,-90,-90,	-20,-90,-90,	-20,90,-90
 dc.w 20,-90,90,	20,90,90,	-20,-90,90,	-20,90,90
;P
 dc.w -20,-10,65, -20,-65,65, -20,-65,-65, -20,-10,-65, -20,-10,-10
 dc.w -20,10,-10, -20,35,-5, -20,45,0
 dc.w -20,55,10, -20,60,20, -20,62,32
 dc.w -20,60,40, -20,55,47
 dc.w -20,50,55, -20,40,60, -20,20,65
;P-hul
 dc.w -20,-10,40, -20,-10,20, -20,20,20
 dc.w -20,22,22, -20,14,36, -20,10,38
 dc.w $8000,$8000,$8000

