<<<<<<<<<; filled vector logo
;								TAS/may1992

*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  tabels			$6d000	$6e000
*  vectorscreens		$6e000	$7f000


DEMOSTARTUP = 0

 INCLUDE chipmap.inc
 ORG $2a800
 LOAD $2a800
sintabel	= $27800
>EXTERN "sin1024.data",sintabel


width	= 44
size	= $4600
screen1		= $6e000
screen2		= screen1+size
screen3		= screen2+size
bufferscreen	= screen3+size
ytabel		= $6d000
vectorbuffer	= $6d400
vectordata	= $6da00

cantal1 = $6a
cantal2 = $5f


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	 IFEQ DEMOSTARTUP
	move.l	$1c(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$05b0,$96(a6)
	move.w	#$8240,$96(a6)
	move.w	#$fff,$180(a6)
	move.w	#$0200,$100(a6)

	lea	screen1,a0
	move.l	#size*4,d0
	bsr.W	clear

	lea	bufferscreen+[width],a0
	move.w	#$aaaa,d1
	move.w	#199,d7
.mask1	moveq	#[width/2]-1,d6
.mask2	move.w	d1,(a0)+
	dbf	d6,.mask2
	ror.w	d1
	adda.w	#width,a0
	dbf	d7,.mask1

	lea	ytabel,a0 
	moveq	#0,d0
	move.w	#255,d7
.sety	move.w	d0,(a0)+
	addi.w	#width*2,d0
	dbf	d7,.sety

	lea	coords1(pc),a0
	moveq	#cantal1,d7
.koori1	sub.w	#115/2,(a0)+
	sub.w	#57/2,(a0)+
	addq.l	#2,a0
	dbf	d7,.koori1
	lea	coords2(pc),a0
	moveq	#cantal2,d7
.koori2	sub.w	#115/2,(a0)+
	sub.w	#57/2,(a0)+
	addq.l	#2,a0
	dbf	d7,.koori2

	move.w	#$120,d0
	bsr.W	RC
	lea	copperlist,a0
	move.l	a0,$80(a6)
	move.w	#$81b0,$96(a6)			;Turn on DMA

	bsr.W	ML

exit:	lea	DMA,a6			;Allow interrupts
	BLTW
	moveq	#0,d0
error:	rts					;Exit this program!
quit: dc.w 0


*---------------------*
*      MAIN LOOP      *

ML:
	bsr.W	controlroom
	bsr.B	createvector

	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001	;;
	beq.B	slipout		;;
	 ENDC

	tst.w	quit
	beq.B	ML
	rts

slipout: addq.l	#4,sp
	rts

*------------------------
* filled vector routine

createvector:
	lea	display(pc),a2
	movem.l	(a2),d0-d5
	movem.l	d2-d5,(a2)
	movem.l	d0/d1,16(a2)

	move.l	d3,a0
	tst.l	(a0)
	beq.B	.noclear
	move.w	#$8400,$96(a6)
	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	(a0)+,BLTDPT(a6)
	move.w	(a0)+,BLTDMOD(a6)
	move.w	(a0)+,BLTSIZE(a6)
.noclear

	 IFNE DEMOSTARTUP
.wait	tst.w	$140.W
	beq.B	.wait
	clr.w	$140.W
	 ENDC

	move.l	display+16(pc),a0
	lea	CPptrs+2(pc),a1
	moveq	#width,d1
	moveq	#1,d7
.loop	move.l	a0,d0
	swap	d0
	move.w	d0,(a1)
	move.w	a0,4(a1)
	adda.w	d1,a0
	addq.l	#8,a1
	dbf	d7,.loop

	lea	edges+8(pc),a2
	move.l	#$01500000,(a2)+
	move.l	#$00c80000,(a2)
	move.w	#$0400,$96(a6)

	lea	vekobj1(pc),a4
	bsr.W	sincos
	lea	coords1,a0
	lea	vectorbuffer,a1
	bsr.W	calc_coords

	lea	vekobj2(pc),a4
	bsr.W	sincos
	lea	coords2,a0
	lea	vectorbuffer+$400,a1
	bsr.W	calc_coords


	lea	vectorbuffer+4,a0
	moveq	#cantal1-1,d7
	move.w	(a0),d0
.sort1	cmp.w	(a0),d0
	ble.B	.no1
	move.w	(a0),d0
.no1	addq.l	#8,a0
	dbf	d7,.sort1
	lea	vectorbuffer+$404,a0
	moveq	#cantal2-1,d7
	move.w	(a0),d1
.sort2	cmp.w	(a0),d1
	ble.B	.no2
	move.w	(a0),d1
.no2	addq.l	#8,a0
	dbf	d7,.sort2

	cmp.w	d0,d1
	bge.B	.print2first

	lea	vektortabel1,a0
	lea	vectorbuffer,a1
	bsr.W	draw_vektor
	lea	vektortabel2,a0
	lea	vectorbuffer+$400,a1
	bsr.W	draw_vektor
	bra.W	end_drawing
.print2first:
	lea	vektortabel2,a0
	lea	vectorbuffer+$400,a1
	bsr.W	draw_vektor
	lea	vektortabel1,a0
	lea	vectorbuffer,a1
	bsr.W	draw_vektor
	bra.W	end_drawing
	rts


draw_vektor:
	lea	bufferscreen,a4
	move.w	(a0)+,antal
.vloop1	lea	edges(pc),a3
	move.w	(a0)+,mode
	moveq	#0,d7
	move.w	(a0)+,d7
	subq.w	#1,d7
	move.w	(a0)+,color
	lea	ytabel,a2
	BLTW
	move.w	#width*2,$60(a6)
	move.w	#width*2,$66(a6)
	move.l	#$ffff8000,$72(a6)
	move.w	#$ffff,$44(a6)
	clr.b	$42(a6)
.vloop2
	move.w	(a0)+,d5
	move.w	(a0),d6
	lsl.w	#3,d5
	lsl.w	#3,d6
	movem.w	(a1,d5.W),d0/d1
	movem.w	(a1,d6.W),d2/d3
	bsr.W	drawvector
.nodraw	dbf	d7,.vloop2
	addq.l	#2,a0
	subq.w	#1,antal
	bne.B	.vloop1

	movem.w	(a3),d0-d7
	cmp.w	d0,d4
	ble.B	.bdr1
	move.w	d0,d4
.bdr1	cmp.w	d1,d5
	bge.B	.bdr2
	move.w	d1,d5
.bdr2	cmp.w	d2,d6
	ble.B	.bdr3
	move.w	d2,d6
.bdr3	cmp.w	d3,d7
	bge.B	.bdr4
	move.w	d3,d7
.bdr4	movem.w	d4-d7,8(a3)

	lea	bufferscreen,a0
	movem.w	(a3),d0-d3
	tst.w	d0
	bpl.B	.vecok1
	clr.w	d0
.vecok1	cmpi.w	#335,d1
	ble.B	.vecok2
	move.w	#335,d1
.vecok2	tst.w	d2
	bpl.B	.vecok3
	clr.w	d2
.vecok3	cmpi.w	#200,d3
	ble.B	.vecok4
	move.w	#200,d3
.vecok4
	move.w	d3,d4
	subq.w	#1,d4
	add.w	d4,d4
	move.w	(a2,d4.W),d4
	lsr.w	#4,d0
	lsr.w	#4,d1
	add.w	d1,d4
	add.w	d1,d4
	sub.w	d2,d3
	ble.W	vectordrawn
	sub.w	d0,d1
	addq.w	#1,d1
	ble.W	vectordrawn
	lsl.w	#6,d3
	or.w	d1,d3
	add.w	d1,d1
	move.w	#width*2,d0
	sub.w	d1,d0
	move.w	d0,d1
	swap	d1
	move.w	d0,d1

	adda.w	d4,a0
	BLTW
	move.l	#$09f00012,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	d1,BLTAMOD(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a0,BLTDPT(a6)
	move.w	d3,BLTSIZE(a6)

	move.l	display(pc),a1
	adda.w	d4,a1

	moveq	#width,d4
	move.w	color(pc),d5
	moveq	#1,d6
	move.w	#$0bfa,d7
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0002,BLTCON1(a6)
	move.l	d1,BLTCMOD(a6)
	move.l	d1,BLTAMOD(a6)
.prloop	move.l	a0,a2
	move.w	d7,d2
	ror.b	d5
	btst	#3,d5
	beq.B	.nopatt
	move.w	#$0fca,d2
	adda.w	#width,a2
	bra.B	.nocolor
.nopatt	bmi.B	.nocolor
	move.b	#$0a,d2
.nocolor
	BLTW
	move.w	d2,BLTCON0(a6)
	movem.l	a1/a2,BLTCPT(a6)
	movem.l	a0/a1,BLTAPT(a6)
	move.w	d3,BLTSIZE(a6)
	adda.w	d4,a1
	dbf	d6,.prloop
cleararea:
	BLTW
	move.l	#$01000002,BLTCON0(a6)
	move.l	a0,BLTDPT(a6)
	move.w	d1,BLTDMOD(a6)
	move.w	d3,BLTSIZE(a6)
vectordrawn:
	move.l	#$01500000,(a3)
	move.l	#$00c80000,4(a3)
	move.w	#$0400,$96(a6)
	rts

end_drawing:
	move.l	display(pc),a0
	lea	ytabel,a2
	movem.w	8(a3),d0-d3
	tst.w	d0
	bpl.B	.vecb1
	clr.w	d0
.vecb1	cmpi.w	#336,d1
	ble.B	.vecb2
	move.w	#336,d1
.vecb2	tst.w	d2
	bge.B	.vecb3
	clr.w	d2
.vecb3	cmpi.w	#200,d3
	ble.B	.vecb4
	move.w	#200,d3
.vecb4
	move.w	d2,d4
	add.w	d4,d4
	move.w	(a2,d4.W),d4
	lsr.w	#4,d0
	lsr.w	#4,d1
	add.w	d0,d4
	add.w	d0,d4
	sub.w	d0,d1
	sub.w	d2,d3
	addq.w	#1,d3
	ble.B	.nofill
	addq.w	#1,d1
	ble.B	.nofill
	move.w	d3,d2
	add.w	d2,d3
	lsl.w	#6,d3
	or.w	d1,d3
	add.w	d1,d1
	moveq	#width,d0
	sub.w	d1,d0
	adda.w	d4,a0
	move.l	display+4,a2
	move.l	a0,(a2)+
	movem.w	d0/d3,(a2)
.nofill	rts


*--------------------*
* VECTOR SUBROUTINES *

calc_coords:
	lea	matrix_vectors(pc),a2
	move.w	#176,a3
	move.w	#100,a4
	moveq	#6,d4
calc2:	move.w	#0,a5
vecloop1
	movem.w	(a0)+,d5-d7
calc1	addi.w	#0,d5
	addi.w	#0,d6
	addi.w	#0,d7
	move.w	d5,d0
	move.w	d6,d1
	move.w	d7,d2
	muls	(a2)+,d0
	muls	(a2)+,d1
	muls	(a2)+,d2
	add.l	d1,d0
	add.l	d2,d0
	asr.l	d4,d0

	move.w	d5,d1
	move.w	d6,d2
	move.w	d7,d3
	muls	(a2)+,d1
	muls	(a2)+,d2
	muls	(a2)+,d3
	add.l	d2,d1
	add.l	d3,d1
	asr.l	d4,d1

	muls	(a2)+,d5
	muls	(a2)+,d6
	muls	(a2),d7
	add.l	d6,d5
	add.l	d7,d5
	lsr.l	#8,d5
	lsr.l	d4,d5
	add.w	a5,d5
	divs	d5,d0
	divs	d5,d1
	add.w	a3,d0
	add.w	a4,d1
	movem.w	d0/d1/d5,(a1)
	addq.l	#8,a1
	lea	-16(a2),a2
	cmpi.w	#$8000,(a0)
	bne.B	vecloop1
	rts

sincos	lea	sintabel,a1
	lea	256(a1),a2
	movem.w	(a4)+,d0-d2
	move.w	#$3fe,d3
	and.w	d3,d0
	and.w	d3,d1
	and.w	d3,d2
	move.w	(a1,d0.W),calc4+2
	move.w	(a1,d0.W),calc4+6
	move.w	(a2,d0.W),calc4+10
	move.w	(a2,d0.W),calc4+14
	move.w	(a1,d1.W),calc5+2
	move.w	(a1,d1.W),calc5+6
	move.w	(a2,d1.W),calc5+10
	move.w	(a2,d1.W),calc5+14
	move.w	(a1,d2.W),calc3+2
	move.w	(a1,d2.W),calc3+6
	move.w	(a2,d2.W),calc3+10
	move.w	(a2,d2.W),calc3+14
	movem.w	(a4)+,d0-d3
	move.w	d0,calc1+2
	move.w	d1,calc1+6
	move.w	d2,calc1+10
	move.w	d3,calc2+2

	lea	matrixpos+4(pc),a0
	lea	matrix_vectors(pc),a1
	moveq	#2,d7
matrixloop
	movem.w	(a0),d0-d2
	move.w	d1,d4
	move.w	d0,d3
calc3	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d1
	sub.l	d4,d0
	add.l	d3,d1
	add.l	d0,d0
	swap	d0
	add.l	d1,d1
	swap	d1
	move.w	d2,d4
	move.w	d1,d3
calc4	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d1
	muls	#$0000,d2
	sub.l	d4,d1
	add.l	d3,d2
	add.l	d1,d1
	swap	d1
	add.l	d2,d2
	swap	d2
	move.w	d2,d4
	move.w	d0,d3
calc5	muls	#$0000,d4
	muls	#$0000,d3
	muls	#$0000,d0
	muls	#$0000,d2
	sub.l	d4,d0
	add.l	d3,d2
	add.l	d0,d0
	swap	d0
	add.l	d2,d2
	swap	d2
	move.w	d2,12(a1)
	move.w	d1,6(a1)
	move.w	d0,(a1)+
	subq.l	#2,a0
	dbf	d7,matrixloop
	rts

* DATA *
matrixpos:	dc.w 0,0,$4000,0,0
matrix_vectors:	blk.w 9


drawvector:
	cmp.w	d0,d2			;check border
	bge.B	.vecexg1
	exg	d0,d2
	exg	d1,d3
.vecexg1
	cmp.w	(a3)+,d0
	bge.B	.vecb1
	move.w	d0,-2(a3)
.vecb1	cmp.w	(a3)+,d2
	ble.B	.vecb2
	move.w	d2,-2(a3)
.vecb2	cmp.w	d1,d3
	bge.B	.vecexg2
	exg	d0,d2
	exg	d1,d3
.vecexg2
	cmp.w	(a3)+,d1
	bge.B	.vecb3
	move.w	d1,-2(a3)
.vecb3	cmp.w	(a3)+,d3
	ble.B	.vecb4
	move.w	d3,-2(a3)
.vecb4	subq.l	#8,a3

	tst.w	d3
	bmi.W	noline
	tst.w	d1
	bmi.W	bcut6
	cmpi.w	#200,d1
	bhs.W	noline
	cmpi.w	#200,d3
	bhs.W	bcut7
	tst.w	d0
	bmi.W	bcut2
	tst.w	d2
	bmi.W	bcut1
	cmpi.w	#336,d0
	bge.W	bcut4
	cmpi.w	#336,d2
	bge.W	bcut4

drawline:
	sub.w	d1,d3
	beq.B	noline
	moveq	#0,d4
	move.w	d1,d4
	add.w	d4,d4
	move.w	(a2,d4.W),d4
	move.w	d0,d5
	addi.l	a4,d4
	asr.w	#3,d5
	add.w	d5,d4
	moveq	#0,d5
	sub.w	d0,d2
	bpl.B	.line1
	moveq	#1,d5
	neg.w	d2
.line1	move.w	d3,d1
	add.w	d1,d1
	cmp.w	d2,d1
	dbhi	d3,.line2
.line2	move.w	d3,d1
	sub.w	d2,d1
	bpl.B	.line3
	exg	d2,d3
.line3	addx.w	d5,d5
	add.w	d2,d2
	move.w	d2,d1
	sub.w	d3,d2
	addx.w	d5,d5
	andi.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0a4a,d0
	BLTW
	move.w	d2,$52(a6)
	sub.w	d3,d2
	lsl.w	#6,d3
	addq.w	#2,d3
	move.w	d0,$40(a6)
	move.b	oktant(PC,d5.W),$43(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d3,$58(a6)
noline:	rts
oktant:		dc.b $03,$43,$13,$53,$0b,$4b,$17,$57

bcut1	exg	d0,d2
	exg	d1,d3
	bra.B	bcut3
bcut2	tst.w	d2
	blt.W	noline
bcut3	sub.w	d3,d1
	sub.w	d2,d0
	muls	d2,d1
	divs	d0,d1
	neg.w	d1
	add.w	d3,d1
	moveq	#0,d0
	bra.W	drawvector
bcut4	move.w	#335,d6
	cmpi.w	d6,d0
	ble.B	.bcut5
	cmpi.w	d6,d2
	bge.B	.bcut5a
	move.w	d0,d4
	subi.w	d6,d4
	move.w	d3,d5
	sub.w	d1,d5
	muls	d5,d4
	move.w	d2,d5
	sub.w	d0,d5
	divs	d5,d4
	movem.w	d0/d1,-(sp)
	sub.w	d4,d1
	move.w	d6,d0
	movem.w	d0/d1,-(sp)
	bsr.W	drawline
	movem.w	(sp)+,d0-d3
	move.w	#335,d2
	bra.W	drawvector
.bcut5a	move.w	d6,d0
	move.w	d6,d2
	bra.W	drawvector
.bcut5	cmpi.w	d6,d2
	ble.W	drawvector
	move.w	d2,d4
	subi.w	d6,d4
	move.w	d1,d5
	sub.w	d3,d5
	muls	d5,d4
	move.w	d0,d5
	sub.w	d2,d5
	divs	d5,d4
	movem.w	d2/d3,-(sp)
	sub.w	d4,d3
	move.w	d6,d2
	movem.w	d2/d3,-(sp)
	bsr.W	drawline
	movem.w	(sp)+,d0-d3
	move.w	#335,d2
	bra.W	drawvector
bcut6	sub.w	d2,d0
	sub.w	d3,d1
	muls	d3,d0
	divs	d1,d0
	neg.w	d0
	add.w	d2,d0
	moveq	#0,d1
	bra.W	drawvector
bcut7	sub.w	d0,d2
	sub.w	d1,d3
	move.w	#199,d4
	sub.w	d1,d4
	muls	d4,d2
	divs	d3,d2
	add.w	d0,d2
	move.w	#199,d3
	bra.W	drawvector


* TASK 1 data
display:	dc.l screen1,edges+16
		dc.l screen2,edges+24
		dc.l screen3,edges+32
edges:		dc.l $01500000,$00c80000
		dc.l $01500000,$00c80000
		dc.l 0,0, 0,0, 0,0

antal:		dc.w 0
color:		dc.w 0
mode:		dc.w 0
vekobj1:
 dc.w 0,0,0
 dc.w 0,0,0,10
vekobj2:
 dc.w 0,0,0
 dc.w 0,0,0,10


*--------------*
* CONTROL ROOM *

controlroom:
	lea	counter(pc),a0
	addq.w	#1,(a0)
	move.w	(a0),d0
	lea	vekobj1(pc),a1
	lea	vekobj2(pc),a2

	cmp.w	#3,d0
	bne.B	.no3
	move.w	#$102,copperlist+2
.no3
	cmp.w	#16,d0
	bhi.B	.fade
	move.w	d0,-(sp)
	move.w	d0,d3
	move.w	#~$102,d0
	bsr.W	fade
	not.w	d0
	and.w	#$fff,d0
	move.w	d0,CPcolors+2
	move.w	#~$d49,d0
	bsr.W	fade
	not.w	d0
	and.w	#$fff,d0
	move.w	d0,CPcolors+6
	move.w	#~$925,d0
	bsr.W	fade
	not.w	d0
	and.w	#$fff,d0
	move.w	d0,CPcolors+10
	move.w	(sp)+,d0
.fade

	cmp.w	#25,d0
	bhi.B	.nxt1
	add.w	#7,12(a1)
	add.w	#7,12(a2)
	rts
.nxt1	cmp.w	#110,d0
	bhi.B	.nxt2
	add.w	#12,2(a1)
	add.w	#12,2(a2)
	rts
.nxt2	cmp.w	#207,d0
	bhi.B	.nxt3
	add.w	#14,4(a1)
	add.w	#14,4(a2)
	add.w	#10,(a1)
	add.w	#10,(a2)
	rts
.nxt3	cmp.w	#219,d0
	bhs.B	.nxt4
	sub.w	#13,12(a1)
	sub.w	#9,12(a2)
	sub.w	#10,8(a1)
	add.w	#8,8(a2)
	rts
.nxt4	move.w	#-1,quit
	rts

* CONTROLROOM COUNTER
counter: dc.w 0


*------*
* SUBS *
*------*

RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

fade:	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f,d0
	andi.w	#$f0,d1
	andi.w	#$f00,d2
	mulu	d3,d0
	mulu	d3,d1
	mulu	d3,d2
	andi.w	#$f0,d0
	andi.w	#$f00,d1
	andi.w	#$f000,d2
	or.w	d1,d0
	or.w	d2,d0
	lsr.w	#4,d0
	rts

*--------*
*  DATA  *
*--------*
oldint:		dc.l 0
intregs:	dc.w 0,0
 even


*----------------------*
*     COPPER-LISTS     *
*----------------------*
copperlist:
 dc.l $01800fff
 dc.l $008e3c61,$009014c1,$00920030,$009400d0
 dc.l $00968020
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
 dc.l $01000200,$01020000,$01040009
 dc.w $0108,2+[width],$010a,2+[width]
 dc.l $01a20000
CPptrs:
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.w $00e4,screen1/$10000,$00e6,screen1&$ffff
CPcolors:
 dc.l $01800fff,$01820d49,$01840925
 dc.l $3c01fffe
 dc.l $01002200
 dc.l $ffe1fffe
 dc.l $0301fffe,$01000200
 dc.l $fffffffe


vektortabel1:
	DC.W 	2
	DC.W	$0,$2C,$1
	DC.W	$0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$A,$B
	DC.W	$C,$D,$E,$F,$10,$11,$12,$13
	DC.W	$14,$15,$16,$17,$18,$19,$1A,$1B
	DC.W	$1C,$1D,$1E,$1F,$20,$21,$22,$23
	DC.W	$24,$25,$26,$27,$28,$29,$2A,$2B
	DC.W	$0
	DC.W	$0,$3F,$1
	DC.W	$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,$36,$37
	DC.W	$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
	DC.W	$40,$41,$42,$43,$44,$45,$46,$47
	DC.W	$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
	DC.W	$50,$51,$52,$53,$54,$55,$56,$57
	DC.W	$58,$59,$5A,$5B,$5C,$5D,$5E,$5F
	DC.W	$60,$61,$62,$63,$64,$65,$66,$67
	DC.W	$68,$69,$6A,$2C
coords1:
	DC.W	$3,$3,$0, $22,$3,$0, $23,$4
	DC.W	$0, $25,$4,$0, $26,$5,$0, $27
	DC.W	$5,$0, $2A,$8,$0, $2A,$9,$0
	DC.W	$2B,$A,$0, $2B,$C,$0, $2C,$D
	DC.W	$0,$2C,$F,$0,$2B,$10,$0,$2B
	DC.W	$12,$0,$2A,$13,$0,$2A,$14,$0
	DC.W	$26,$18,$0,$24,$16,$0,$21,$16
	DC.W	$0,$20,$15,$0,$1F,$15,$0,$1E
	DC.W	$16,$0,$1B,$16,$0,$1A,$17,$0
	DC.W	$19,$17,$0,$18,$18,$0,$15,$18
	DC.W	$0,$14,$19,$0,$12,$19,$0,$11
	DC.W	$18,$0,$10,$18,$0,$E,$16,$0
	DC.W	$C,$16,$0,$B,$15,$0,$9,$15
	DC.W	$0,$8,$14,$0,$8,$11,$0,$9
	DC.W	$10,$0,$1C,$10,$0,$1E,$E,$0
	DC.W	$1C,$C,$0,$3,$C,$0,$2,$B
	DC.W	$0,$2,$4,$0,$3C,$3,$0,$72
	DC.W	$3,$0,$73,$4,$0,$73,$A,$0
	DC.W	$72,$B,$0,$6C,$B,$0,$6B,$C
	DC.W	$0,$6B,$18,$0,$6A,$17,$0,$65
	DC.W	$17,$0,$64,$18,$0,$62,$18,$0
	DC.W	$61,$19,$0,$5F,$19,$0,$5E,$1A
	DC.W	$0,$5D,$1A,$0,$5D,$C,$0,$5C
	DC.W	$B,$0,$3E,$B,$0,$3D,$C,$0
	DC.W	$3C,$C,$0,$3A,$E,$0,$3A,$F
	DC.W	$0,$3C,$11,$0,$3D,$11,$0,$3E
	DC.W	$12,$0,$49,$12,$0,$4A,$13,$0
	DC.W	$4C,$13,$0,$4D,$14,$0,$4E,$14
	DC.W	$0,$52,$18,$0,$52,$19,$0,$51
	DC.W	$19,$0,$50,$18,$0,$4E,$18,$0
	DC.W	$4C,$16,$0,$45,$16,$0,$44,$17
	DC.W	$0,$3C,$17,$0,$3B,$16,$0,$3A
	DC.W	$16,$0,$39,$15,$0,$38,$15,$0
	DC.W	$37,$14,$0,$35,$14,$0,$34,$15
	DC.W	$0,$32,$15,$0,$31,$14,$0,$31
	DC.W	$13,$0,$30,$12,$0,$30,$10,$0
	DC.W	$2F,$F,$0,$30,$E,$0,$30,$C
	DC.W	$0,$31,$B,$0,$31,$A,$0,$34
	DC.W	$7,$0,$35,$7,$0,$37,$5,$0
	DC.W	$38,$5,$0,$39,$4,$0,$3B,$4
	DC.W	$0
	DC.W	$8000,$8000,$8000

vektortabel2:
	DC.W	3
	DC.W	$0,$1F,$2
	dc.w	$0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$A,$B
	DC.W	$C,$D,$E,$F,$10,$11,$12,$13
	DC.W	$14,$15,$16,$17,$18,$19,$1A,$1B
	DC.W	$1C,$1D,$1E,$0
	DC.W	$0,$34,$2
	DC.W	$1F,$20,$21,$22,$23,$24,$25,$26,$27
	DC.W	$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
	DC.W	$30,$31,$32,$33,$34,$35,$36,$37
	DC.W	$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
	DC.W	$40,$41,$42,$43,$44,$45,$46,$47
	DC.W	$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
	DC.W	$50,$51,$52,$1F
	DC.W	$0,$D,$2
	DC.W	$53,$54,$55,$56,$57,$58,$59,$5A,$5B
	DC.W	$5C,$5D,$5E,$5F,$53

coords2:
	DC.W	$8,$15,$0,$8,$15,$0,$9,$16
	DC.W	$0,$B,$16,$0,$C,$17,$0,$E
	DC.W	$17,$0,$10,$19,$0,$11,$19,$0
	DC.W	$12,$1A,$0,$14,$1A,$0,$15,$19
	DC.W	$0,$18,$19,$0,$19,$18,$0,$1A
	DC.W	$18,$0,$1B,$17,$0,$1E,$17,$0
	DC.W	$1F,$16,$0,$20,$16,$0,$21,$17
	DC.W	$0,$24,$17,$0,$25,$18,$0,$24
	DC.W	$18,$0,$23,$19,$0,$1F,$19,$0
	DC.W	$1E,$1A,$0,$17,$1A,$0,$16,$1B
	DC.W	$0,$16,$29,$0,$15,$2A,$0,$9
	DC.W	$2A,$0,$8,$29,$0,$35,$15,$0
	DC.W	$37,$15,$0,$38,$16,$0,$39,$16
	DC.W	$0,$3A,$17,$0,$3B,$17,$0,$3C
	DC.W	$18,$0,$44,$18,$0,$45,$17,$0
	DC.W	$4C,$17,$0,$4E,$19,$0,$50,$19
	DC.W	$0,$51,$1A,$0,$53,$1A,$0,$53
	DC.W	$1C,$0,$54,$1D,$0,$54,$1F,$0
	DC.W	$53,$20,$0,$53,$21,$0,$52,$22
	DC.W	$0,$52,$23,$0,$51,$24,$0,$51
	DC.W	$25,$0,$50,$26,$0,$50,$27,$0
	DC.W	$4F,$28,$0,$4F,$2C,$0,$4E,$2D
	DC.W	$0,$4E,$31,$0,$4D,$32,$0,$4D
	DC.W	$35,$0,$4D,$33,$0,$4C,$32,$0
	DC.W	$4C,$31,$0,$4B,$30,$0,$4B,$2E
	DC.W	$0,$4A,$2D,$0,$4A,$2C,$0,$48
	DC.W	$2A,$0,$1A,$2A,$0,$19,$29,$0
	DC.W	$19,$22,$0,$1A,$21,$0,$42,$21
	DC.W	$0,$44,$1F,$0,$44,$1D,$0,$42
	DC.W	$1B,$0,$39,$1B,$0,$38,$1A,$0
	DC.W	$36,$1A,$0,$32,$16,$0,$34,$16
	DC.W	$0,$65,$18,$0,$6A,$18,$0,$6B
	DC.W	$19,$0,$6B,$29,$0,$6A,$2A,$0
	DC.W	$5E,$2A,$0,$5D,$29,$0,$5D,$1B
	DC.W	$0,$5E,$1B,$0,$5F,$1A,$0,$61
	DC.W	$1A,$0,$62,$19,$0,$64,$19,$0
	DC.W	$8000,$8000,$8000

 END

