; mouse pointer
;								TAS / feb1992


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000

 include chipmap.inc
 org $20000
 load $20000

screen = $60000
xydata = $70000
width = 80


BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.S	.\@
	 ENDM

*------------------*
* START UP PROGRAM *

s	lea	DMA,a6
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	move.w	#$01bf,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)
	lea	$bfd100,a0
	bset	#7,(a0)
	and.b	#$87,(a0)
	ori.b	#$78,(a0)
	move.l	$4.W,a0
;;	clr.l	56(a0)	;Reset!


*-------
* SETUP

	clr.w	$36(a6)		;clear mouse xy-pos

	lea	$60000,a0
	move.l	#$2d00,d0
	bsr.W	fill


*----------------------------
* PREPARE COPPER, DMA ECT

	lea	cp(pc),a0
	move.l	a0,$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)
;	move.w	#$c020,INTENA(a6)

c=10
	move.w	#$ffff,$44(a6)
	move.l	#$ffff8000,$72(a6)
	move.w	#width,$60(a6)
	move.w	#width,$66(a6)
	moveq	#0,d0
	moveq	#0,d1
	move.w	#320-c,d2
	move.w	#$90-c,d3
	bsr.W	drawline
	move.w	#639,d0
	moveq	#0,d1
	move.w	#320-c,d2
	move.w	#$90-c,d3
	bsr.W	drawline

*-----------------------*
*	MAIN LOOP	*

ML
	move.b	#$fe,d0
	bsr.W	RC
	move.b	#$ff,d0
	bsr.W	RC

	bsr.W	spritehandler
	btst	#6,$bfe001
	bne.S	ML

*------*
* EXIT *
	move.l	#$7fff7fff,INTENA(a6)
	move.l	intregs(pc),d0
	ori.l	#$80008000,d0
	move.l	d0,INTENA(a6)

	move.l	$4.W,a0
	move.l	$9c(a0),a0
	move.l	$26(a0),$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)
	moveq	#0,d0
	rts

*----------------
* sprite handler

spritehandler:
	lea	sprite(pc),a0
	lea	68(a0),a1
	lea	CPspr1(pc),a2
	move.l	a0,d0
	swap	d0
	move.w	d0,2(a2)
	move.w	a0,6(a2)
	move.l	a1,d0
	swap	d0
	move.w	d0,10(a2)
	move.w	a1,14(a2)

	move.l	pointer(pc),a2
	addq.l	#4,pointer
	movem.w	(a2),d0/d1
	moveq	#1,d2
	lsr.w	#2,d0
	bcs.S	.1shift
	moveq	#0,d2
.1shift	addi.b	#$38,d0		;scrx-left pos
;	addi.w	#$28,d1		;scry-upper pos
	cmpi.w	#256,d1
	blo.S	.low1
	ori.b	#4,d2
.low1	move.b	d1,(a0)+
	move.b	d0,(a0)+
	move.b	d1,(a1)+
	move.b	d0,(a1)+
	addi.w	#15,d1		;spr height
	cmpi.w	#256,d1
	blo.S	.low2
	ori.b	#2,d2
.low2	move.b	d1,(a0)+
	move.b	d2,(a0)+
	ori.b	#$80,d2
	move.b	d1,(a1)+
	move.b	d2,(a1)+
	rts

* SPRITE data
pointer: dc.l xydata
sprite:
 dc.w 0,0
 dc.w	$07c0,$07c0, $1e30,$1ff0, $3d28,$3e18, $7ad4,$7ccc
 dc.w	$5b24,$7dec, $9b2a,$fde6, $bae2,$fcee, $7d52,$be4e
 dc.w	$dc66,$bf9e, $ff1e,$9ffe, $0ffc,$5ffc, $67f4,$6ffc
 dc.w	$3d98,$3be8, $1e70,$1610, $0640,$04c0, $0000,$0000
 dc.w 0,0
 dc.w	$07c0,$0000, $1ff0,$0000, $3ff8,$0000, $7f3c,$0000
 dc.w	$7e1c,$0000, $fe1e,$0000, $ff1e,$0000, $ffbe,$0000
 dc.w	$fffe,$0000, $fffe,$0000, $7ffc,$0000, $5ffc,$0000
 dc.w	$27f8,$0000, $19f0,$0000, $07c0,$0000, $0000,$0000


drawline:
	cmp.w	d3,d1
	bge.S	.draw1
	exg	d1,d3
	exg	d0,d2
.draw1	moveq	#0,d4
	move.w	d1,d4
	mulu	#width,d4
	moveq	#-$10,d5
	and.w	d0,d5
	lsr.w	#3,d5
	add.w	d5,d4
	add.l	#screen,d4
	moveq	#0,d5
	sub.w	d1,d3
	neg.w	d3
	sub.w	d0,d2
	roxl.b	#1,d5
	tst.w	d2
	bge.S	.vec2
	neg.w	d2
.vec2	move.w	d3,d1
	sub.w	d2,d1
	bge.S	.vec3
	exg	d3,d2
.vec3	roxl.b	#1,d5
	move.b	.oktant2(pc,d5.W),d5
	add.w	d2,d2
	ori.w	#$40,d5	
	andi.w	#$f,d0
	ror.w	#4,d0
	move.w	d2,d1
	lsl.w	#1,d3
	sub.w	d3,d2
	lsl.w	#5,d3
	beq.w	.vectordrawxx
	addq.w	#2,d3
	move.w	d0,d6
	move.w	d6,d0
	ori.w	#$0b0a,d0
	ori.b	#$c0,d0
	BLTW
	movem.w	d1/d2,$62(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	move.w	d2,$52(a6)
	movem.w	d0/d5,$40(a6)
	move.w	d3,$58(a6)
.vectordrawxx:
	rts
.oktant2:	dc.b $05,$19,$0d,$1d,$41,$f9,$00,$03




*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e2881,$009030d1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.l $01080000,$010a0000
CPspr1: dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.w $01a0,$0000, $01a2,$0abe, $01a4,$089c, $01a6,$057a
 dc.w $01a8,$0459, $01aa,$0348, $01ac,$0237, $01ae,$0125
 dc.w $01b0,$0def, $01b2,$0abd, $01b4,$079c, $01b6,$057a
 dc.w $01b8,$0358, $01ba,$0236, $01bc,$0125, $01be,$0013

 dc.l $4001fffe
 dc.l $00e00006,$00e20000
 dc.l $01800fff,$0182000a
 dc.l $4101fffe,$01800000
 dc.l $01009200

 dc.l $d001fffe,$01800fff,$01000200
 dc.l $d101fffe,$01800000 
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	cmp.b	$6(a6),d0
	bne.S	RC
;	clr.w	$180(a6)
	rts

fill:	BLTW
	move.l	#$01000000,$40(a6)
	move.l	#-1,$44(a6)
	clr.w	$66(a6)
	move.l	a0,$54(a6)
	lsr.l	#1,d0
	move.w	d0,$58(a6)
	BLTW
	rts

copins:	move.w	a1,6(a0)
	move.l	a1,d1
	swap	d1
	move.w	d1,2(a0)
	adda.w	d0,a1
	addq.l	#8,a0
	subq.w	#1,d7
	bne.S	copins
	rts

 END

