<<<<<<<<<;Bregne Fraktal
;								TAS / jun1992

DEMOSTARTUP = 0

 include chipmap.inc
 org $32900
 load $32900

border = $4e000
>EXTERN "DF1:border.bpl",border


width = 80
screen = $70000
ytabel = $77000


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.S	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	move.w	#$120,d0
	bsr.W	RC
	 IFEQ DEMOSTARTUP
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.l	sp,stack

	lea	screen,a0
	move.l	#$7000,d0
	bsr.W	fill

	lea	ytabel,a0
	moveq	#0,d0
	move.w	#511,d7
.loop	move.l	d0,(a0)+
	addi.l	#width,d0
	dbf	d7,.loop

*----------------------------
* PREPARE COPPER, DMA ECT

.rc	cmp.b	#$ff,$6(a6)
	bne.S	.rc

	lea	CP(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83f0,DMACON(a6)

	bsr.B	fraktal

exit:	move.l	stack,sp
	lea	DMA,a6
	bsr.W	fade_out
	BLTW
	rts
error:	illegal


*---------
* fraktal

fraktal:
	lea	count(pc),a0
	clr.l	(a0)
	lea	rnd(pc),a1
	lea	parametre(pc),a2
	lea	sandsynligheder(pc),a3
	lea	ytabel,a4
	lea	screen,a5

	move.b	$6(a6),d0
	muls	$4(a6),d0
	addi.w	#$1249,d0
	move.w	d0,(a1)

	move.b	$6(a6),d5
	muls	(a1),d5
	andi.w	#$3fff,d5
	ext.w	d5
	muls	#6,d5

	moveq	#0,d6
	move.b	$6(a6),d6
	muls	$4(a6),d6
	andi.w	#$3fff,d6
	mulu	#12,d6

	moveq	#6,d2
	moveq	#10,d4
	moveq	#99,d7
	addq.l	#6,a6
.find	bsr.B	bladIFS
	dbf	d7,.find

	move.w	(a1),d7
.loop	bsr.B	bladIFS

	move.w	d6,d0
	move.w	d5,d1
	addi.w	#150,d1
	cmpi.w	#640,d0
	bhi.B	.nodot
	cmpi.w	#320,d1
	bhi.B	.nodot
	move.w	d0,d3
	lsr.w	#3,d3
	add.w	d1,d1
	add.w	d1,d1
	add.l	(a4,d1.W),d3
	not.b	d0
	bset	d0,(a5,d3.W)
.nodot
	dbf	d7,.nope		;create slight difference in RND func
	move.w	(a6),d7
	add.w	d7,(a1)
	andi.w	#$7f,d7
.nope
	addq.l	#1,(a0)
	cmpi.l	#60000,(a0)
	beq.B	.quit
	btst	#6,$bfe001
	bne.B	.loop
.quit	bra.B	goexit

bladIFS:
	moveq	#0,d0
	move.w	(a6),d0
	abcd	d5,d0
	muls	(a1),d0
	addi.w	#$1249,d0
	move.w	d0,(a1)
	andi.w	#$3ff,d0

	moveq	#0,d3
.loop	cmp.w	(a3,d3.W),d0
	bls.S	.lower
	addq.w	#2,d3
	bra.S	.loop
.lower
	move.w	d5,d0
	move.w	d6,d1
	muls	(a2,d3.W),d0
	muls	8(a2,d3.W),d1
	add.l	d1,d0

	move.w	d5,d1
	muls	16(a2,d3.W),d1
	muls	24(a2,d3.W),d6
	add.l	d1,d6
	add.w	d3,d3
	move.l	32(a2,d3.W),d1
	asl.l	d2,d1
	add.l	d1,d6

	asr.l	d4,d0
	asr.l	d4,d6
	move.w	d0,d5
	rts


goexit:	lea	DMA,a6
	lea	colors(pc),a0
	moveq	#14,d7
.fade	cmp.b	#$FC,$6(a6)
	bne.S	.fade
.rc1	cmp.b	#$FF,$6(a6)
	bne.S	.rc1
.rc2	cmp.b	#$FE,$6(a6)
	bne.S	.rc2
	move.w	2(a0),d0
	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f00,d0
	andi.w	#$0f0,d1
	andi.w	#$00f,d2
	cmp.w	#$100,d0
	beq.B	.fadeok1
	sub.w	#$100,d0
.fadeok1
	cmp.w	#2,d2
	beq.B	.fadeok2
	subq.w	#1,d2
.fadeok2
	sub.w	#$010,d1
	or.w	d1,d0
	or.w	d2,d0
	move.w	d0,2(a0)
	move.w	d0,6(a0)
	move.w	d0,10(a0)
;	sub.w	d1,2(a0)
;	sub.w	d1,6(a0)
;	sub.w	d1,10(a0)
	dbf	d7,.fade
	rts

* TASK 1 data
rnd:	dc.w 0
count:	dc.l 0
parametre:
	dc.w 0,870,205,-154
	dc.w 0,41,-266,287
	dc.w 0,-41,266,266
	dc.w 256,870,225,246
	dc.l 0,1638,819,1024

sandsynligheder:
	dc.w 20,840,922,1024



*---------*
* FADE IN *
*---------*

fade_out:
	move.w	#256,d6
.loop	move.w	#$120,d0
	bsr.W	RC
	move.w	#$121,d0
	bsr.W	RC

	lea	bordercolors(pc),a0
	lea	CPbordercol1(pc),a1
	moveq	#14,d7
.fade	move.w	#$102,d0
	move.w	(a0)+,d1
	bsr.W	fade
	move.w	d0,2(a1)
	addq.l	#4,a1
	dbf	d7,.fade
	lea	CPbordercol1(pc),a0
	lea	CPbordercol2(pc),a1
	move.w	2(a0),2(a1)
	move.w	6(a0),6(a1)
	move.w	10(a0),10(a1)

	subq.w	#8,d6
	tst.w	d6
	bpl.B	.loop
	rts


*--------*
*  DATA  *
*--------*
stack:		dc.l 0
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even


*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800102
 dc.l $008e2881,$009030c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,0
 dc.w $010a,0
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

CPbordercol1:
 dc.w $0182,$779
 dc.w $0184,$668
 dc.w $0186,$557
 dc.w $0188,$446
 dc.w $018a,$335
 dc.w $018c,$224
 dc.w $018e,$113
 dc.w $0190,$7a5
 dc.w $0192,$694
 dc.w $0194,$574
 dc.w $0196,$463
 dc.w $0198,$352
 dc.w $019a,$242
 dc.w $019c,$131
 dc.w $019e,$121

 dc.l $2801fffe
 dc.l $01004200
 dc.w $00e0,border/$10000,$00e2,border&$ffff
 dc.w $00e4,border/$10000,$00e6,border&$ffff+$500
 dc.w $00e8,border/$10000,$00ea,border&$ffff+$a00
 dc.w $00ec,border/$10000,$00ee,border&$ffff+$f00

 dc.l $3801fffe,$01000200
 dc.w $00e0,[screen/$10000],$00e2,[screen&$ffff]
 dc.w $00e4,[screen/$10000],$00e6,[screen&$ffff]+width
 dc.w $0108,width,$010a,width
colors:
 dc.l $01820FFF,$01840FFF,$01860FFF
 dc.l $5501fffe,$0100a204
 dc.l $f501fffe,$01000200

 dc.l $ffe1fffe
 dc.l $2001fffe
 dc.l $01004200
 dc.w $00e0,border/$10000,$00e2,border&$ffff+$280
 dc.w $00e4,border/$10000,$00e6,border&$ffff+$780
 dc.w $00e8,border/$10000,$00ea,border&$ffff+$c80
 dc.w $00ec,border/$10000,$00ee,border&$ffff+$1180
CPbordercol2:
 dc.w $0182,$779
 dc.w $0184,$668
 dc.w $0186,$557
 dc.w $0108,0,$010a,0

 dc.l $fffffffe

bordercolors:
	DC.W	$0779,$0668,$0557,$0446,$0335,$0224,$0113
	DC.W	$07A5,$0694,$0574,$0463,$0352,$0242,$0131,$0121


*-------------*
* SUBROUTINES *
*-------------*

RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

fill:	clr.l	(a0)+
	clr.l	(a0)+
	subq.l	#8,d0
	bpl.B	fill
	rts

copins:	move.l	a0,d1
	swap	d1
	move.w	d1,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d7
	bne.S	copins
	rts

fade:	move.w	d1,d3
	move.w	d0,d1
	move.w	d0,d2
	move.w	d3,d4
	move.w	d3,d5
	andi.w	#$00f,d0
	andi.w	#$0f0,d1
	andi.w	#$f00,d2
	andi.w	#$00f,d3
	andi.w	#$0f0,d4
	andi.w	#$f00,d5
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5
	muls	d6,d3
	muls	d6,d4
	muls	d6,d5
	asr.l	#8,d3
	asr.l	#8,d4
	asr.l	#8,d5
	andi.w	#$fff0,d4
	andi.w	#$ff00,d5
	add.w	d3,d0
	add.w	d4,d1
	add.w	d5,d2
	or.w	d2,d0
	or.w	d1,d0
	rts

 END

