<<<<<<<<<;
; dig this animation
;

DEMOSTARTUP = 0

 ORG $2A000
 LOAD $2A000
>EXTERN 'DF1:logo.ANIM',iffanim
>EXTERN 'DF1:logo2.bpl',logo

screen1		= $7a000
screen2		= $7d000

iffanim		= $62800
logo		= $69620
logosize = 55*40

*------------------*
* the IFF animator *
*------------------*

s:	clr.w	$dff180
	move.w	#$0180,$dff096
	 IFEQ DEMOSTARTUP
	move.w	#$7fff,$dff09a
	 ENDC

	lea	$dff000,a6
	lea	CP1(pc),a0
	move.l	a0,$80(a6)			;turn on copperlist
	move.w	#$83f0,$96(a6)

	moveq	#0,d3
.fadein	bsr.W	vblank
	bsr.W	vblank
	lea	logo+[logosize*4]+18,a0
	lea	logocolors+4(pc),a1
	moveq	#6,d7
.flop1	move.w	(a0)+,d0
	bsr.W	fade
	move.w	d0,2(a1)
	addq.l	#4,a1
	dbf	d7,.flop1
	addq.w	#1,d3
	cmpi.w	#17,d3
	bne.B	.fadein

	move.w	#39,d7
.wait	bsr.W	vblank
	dbf	d7,.wait

	moveq	#16,d3
.fadeout
	bsr.W	vblank
	bsr.W	vblank
	lea	logo+[logosize*4]+16,a0
	clr.w	(a0)
	lea	logocolors(pc),a1
	moveq	#7,d7
.flop2	move.w	(a0)+,d0
	not.w	d0
	bsr.W	fade
	not.w	d0
	move.w	d0,2(a1)
	addq.l	#4,a1
	dbf	d7,.flop2
	dbf	d3,.fadeout

	lea	screen1,a0
	move.l	#screen2-screen1,d0
	bsr.W	clear

	lea	iffanim,a5
	move.l	display(pc),rawbuffer
	bsr.W	iffread_pix

	lea	ytabel(pc),a0			;make mulu y-tabel
	moveq	#0,d0
	move.w	#255,d7
.ytab	move.w	d0,(a0)+
	add.w	xsizebytes(pc),d0
	dbf	d7,.ytab

	movem.l	display(pc),a0/a1		;copy to both screens
	move.l	rawbuffersize(pc),d0
.copy	move.b	(a0)+,(a1)+
	subq.l	#1,d0
	tst.l	d0
	bne.B	.copy

	lea	$dff000,a6
	move.w	#$120,d0
	bsr.W	RC
	lea	CP2(pc),a0
	move.l	a0,$80(a6)			;turn on copperlist
	clr.w	copcols+2
	move.l	iffanimation(pc),a5
	move.w	animcount(pc),counter
	clr.w	$140.W

.loop2
	 IFEQ DEMOSTARTUP
	bsr.W	vblank
	bsr.W	vblank
	 ELSE
.vent	cmp.w	#2,$140.W
	blo.B	.vent
	clr.w	$140.W
	 ENDC

	lea	display(pc),a0			;swap buffer
	move.l	(a0),a1
	move.l	4(a0),(a0)
	move.l	a1,4(a0)

	lea	copptr,a0			;insert bitplane ptrs
	move.l	a1,d0
	swap	d0
	move.w	d0,2(a0)
	move.w	a1,6(a0)

	cmpi.w	#9,counter
	bhs.W	.noadd
	lea	copcols+2(pc),a0
	cmpi.w	#$fff,(a0)
	beq.B	.noadd
	cmpi.w	#$eee,(a0)
	bne.B	.addcols
	move.w	#$fff,(a0)
	bra.B	.noadd
.addcols
	addi.w	#$222,(a0)
.noadd

	move.l	display(pc),rawbuffer
	bsr.W	iffread_anim			;show anim frame
	adda.l	iffsize(pc),a5			;find next

	subq.w	#1,counter			;loop
	tst.w	counter
	bne.W	.loop2
.quit	rts

* data
loop:		dc.w 0
counter:	dc.w 0
display:	dc.l screen1,screen2



*------------------------------------------*
* routines to convert & show IFF-animation *
*------------------------------------------*

iffread_pix:
	tas	d0
	cmpi.l	#"FORM",(a5)+
	bne.W	error
	addq.l	#4,a5
	cmpi.l	#"ANIM",(a5)+
	bne.B	error

	cmpi.l	#"FORM",(a5)+
	bne.B	error
	addq.l	#4,a5
	cmpi.l	#"ILBM",(a5)+
	bne.B	error
	cmpi.l	#"BMHD",(a5)+
	bne.B	error
	move.l	(a5)+,iffsize
	bsr.B	iffreadbmhd
	adda.l	iffsize(pc),a5
	cmpi.l	#"CMAP",(a5)+
	bne.B	error
	move.l	(a5)+,iffsize
	adda.l	iffsize(pc),a5
.find_dpan
	cmpi.w	#"DP",(a5)+
	bne.B	.find_dpan
	cmpi.w	#"AN",(a5)
	bne.B	.find_dpan
	addq.l	#2,a5
	move.w	6(a5),animcount
	move.b	8(a5),rate+1
.find_body
	cmpi.w	#"BO",(a5)+
	bne.B	.find_body
	cmpi.w	#"DY",(a5)
	bne.B	.find_body
	addq.l	#2,a5
	move.l	(a5)+,iffsize
	bsr.W	iffreadbody
	adda.l	iffsize(pc),a5
	move.l	a5,iffanimation
	rts
error:	illegal

iffreadbmhd:
	movem.w	(a5),d0/d1
	move.w	d1,ysize
	move.b	8(a5),bitplanes+1
	move.w	10(a5),crunched
	addi.w	#$f,d0
	andi.w	#$fff0,d0
	move.w	d0,xsize
	lsr.w	#3,d0
	move.w	d0,xsizebytes
	mulu	d1,d0
	move.w	d0,bitplanesize
	mulu	bitplanes(pc),d0
	move.l	d0,rawbuffersize
	rts


iffreadbody:
	tst.w	crunched
	bne.B	iffreadbodyB
	rts

iffreadbodyB:
	move.l	a5,a1
	move.l	rawbuffer(pc),a3
	move.w	ysize(pc),d0
	subq.w	#1,d0
.bodyB1	move.l	a3,a2
.bodyB2	move.l	a2,a0
	move.w	xsizebytes(pc),d2
.bodyB3	moveq	#0,d3
	move.b	(a1)+,d3
	bmi.B	.body_fill
	sub.w	d3,d2
.copy1	move.b	(a1)+,(a0)+
	dbf	d3,.copy1
	bra.B	.body_next
.body_fill
	neg.b	d3
	sub.w	d3,d2
	move.b	(a1)+,d4
.copy2	move.b	d4,(a0)+
	dbf	d3,.copy2
.body_next
	subq.w	#1,d2
	bne.B	.bodyB3
	adda.w	xsizebytes(pc),a3
	dbf	d0,.bodyB1
	rts


iffread_anim:
	move.l	a5,d0
	andi.w	#1,d0
	adda.w	d0,a5
	cmpi.l	#"FORM",(a5)+
	bne.W	error
	addq.l	#4,a5
	cmpi.l	#"ILBM",(a5)+
	bne.W	error
	cmpi.l	#"ANHD",(a5)+
	bne.W	error
	move.l	(a5)+,iffsize
	cmp.b	#5,(a5)			;anim must be compressed! (offset 16?)
	bne.W	error
	adda.l	iffsize(pc),a5
	cmp.l	#"DLTA",(a5)+
	bne.W	error
	move.l	(a5)+,iffsize

	move.l	a5,a4
	move.l	rawbuffer(pc),a3		;destination screen
.decrunch
	move.l	(a4)+,d0
	beq.B	.done
	lea	(a5,d0.L),a0
	move.l	a3,a2
	bsr.B	iffdecrunch
.done	rts


iffdecrunch:
	movem.l	d0-d5/a1-a3,-(sp)
	moveq	#0,d2
	move.w	xsizebytes(pc),d2
	move.w	d2,d4
	lea	ytabel(pc),a3
	subq.w	#1,d4
.dcrunch1
	move.l	a2,a1
	moveq	#0,d0
	move.b	(a0)+,d0
	bra.B	.next
.dcrunch2
	moveq	#0,d1
	move.b	(a0)+,d1
	bmi.B	.do_copy
	beq.B	.do_fill
	add.w	d1,d1
	adda.w	(a3,d1.W),a1
.next	dbf	d0,.dcrunch2
	addq.l	#1,a2
	dbf	d4,.dcrunch1
	movem.l	(sp)+,d0-d5/a1-a3
	rts	
.do_fill
	move.b	(a0)+,d1
	move.b	(a0)+,d3
	move.w	d1,d5
	lsr.w	#3,d1
	andi.w	#7,d5
	lsl.w	#2,d5
	neg.w	d5
	jmp	.code1(PC,d5.W)
.copy1	 REPT 8
	move.b	d3,(a1)
	adda.w	d2,a1
	 ENDR
.code1	dbf	d1,.copy1
	bra.B	.next
.do_copy
	andi.b	#$7f,d1
	move.w	d1,d5
	lsr.w	#3,d1
	andi.w	#7,d5
	lsl.w	#2,d5
	neg.w	d5
	jmp	.code2(PC,d5.W)
.copy2	 REPT 8
	move.b	(a0)+,(a1)
	adda.w	d2,a1
	 ENDR
.code2	dbf	d1,.copy2
	bra.W	.next

*
* IFF data
*
iffanimation:	dc.l 0
iffsize:	dc.l 0
animcount:	dc.w 0
rate:		dc.w 0
ytabel:		ds.w 256

xsize:		dc.w 0
ysize:		dc.w 0
xsizebytes:	dc.w 0
bitplanes:	dc.w 0
bitplanesize:	dc.w 0
crunched:	dc.w 0
rawbuffer:	dc.l 0
rawbuffersize:	dc.l 0

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP1:
 dc.l $01800000
 dc.l $00968020
 dc.l $008e2881,$009030c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,0,$010a,0
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.w $00e0,logo/$10000,$00e2,logo&$ffff
 dc.w $00e4,logo/$10000,$00e6,logo&$ffff+logosize
 dc.w $00e8,logo/$10000,$00ea,logo&$ffff+logosize*2
 dc.w $00ec,logo/$10000,$00ee,logo&$ffff+logosize*3
logocolors:
 dc.w $0190,0,$0192,0,$0194,0,$0196,0,$0198,0,$019a,0,$019c,0,$019e,0
 dc.w $0182,0,$0184,0,$0186,0,$0188,0,$018a,0,$018c,0,$018e,0
 dc.l $9001fffe,$01004200
 dc.l $c701fffe,$01000200
 dc.l $fffffffe

CP2:
 dc.l $01000200,$01020000,$01040024
 dc.l $008e2a81,$00902ac1,$00920038,$009400d0
 dc.w $0108,0,$010a,0
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
 dc.l $2a01fffe,$01001200
copptr:
 dc.w $00e0,screen2/$10000,$00e2,screen2&$ffff
copcols:
 dc.l $01800000,$01820fff
 dc.l $ffe1fffe
 dc.l $2a01fffe,$01000200
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*

vblank:	move.w	#$120,d0
	bsr.W	RC
	move.w	#$121,d0
RC:	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

fade:	move.w	d0,d1
	move.w	d0,d2
	andi.w	#$f,d0
	andi.w	#$f0,d1
	andi.w	#$f00,d2
	mulu	d3,d0
	mulu	d3,d1
	mulu	d3,d2
	andi.w	#$f0,d0
	andi.w	#$f00,d1
	andi.w	#$f000,d2
	or.w	d1,d0
	or.w	d2,d0
	lsr.w	#4,d0
	rts

 END

