<<<<<<<<<; the pink circle
;								TAS / jun1992

DEMOSTARTUP = 0


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  screens			$40000	$50000
*  matrix area			$50000	$60000

 INCLUDE chipmap.inc
 ORG $35300
 LOAD $35300
sintabel = $27800
>EXTERN 'DF0:sin1024.data',sintabel

copperlist = $7e000

width = 40
scrsize = 128*40*3
screen1		= $57000
screen2 	= screen1+scrsize
screen3 	= screen2+scrsize
screen4 	= screen3+scrsize
maskscreen	= screen4+scrsize
matrixarea	= $6b000

colorpos = $7c000
cantal = 128

farve1tab = $7d000+230
farve2tab = $7d000+580


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	clr.l	$0.W
	move.w	#$130,d0
	bsr.W	RC
	 IFEQ DEMOSTARTUP
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC
	move.w	#$05b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	move.w	#$102,$180(a6)
	move.w	#$0200,$100(a6)

	lea	sintabel,a0
	lea	matrixarea,a1
	move.w	#255,d7
.mloop1	moveq	#-128,d1
	move.w	(a0),d2
	move.w	#255,d6
.mloop2	move.w	d1,d0
	muls	d2,d0
	add.l	d0,d0
	swap	d0
	move.b	d0,(a1)+
	addq.w	#1,d1
	dbf	d6,.mloop2
	addq.l	#4,a0
	dbf	d7,.mloop1

	lea	screen1,a0
	move.l	#scrsize*4,d0
	bsr.W	fill
	lea	farve1tab-$400,a0
	move.l	#$1000,d0
	bsr.W	fill

	lea	maskscreen,a0
	moveq	#-1,d1
	move.w	#127,d7
.fill	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	adda.w	#width*2,a0
	dbf	d7,.fill

	lea	farve1tab,a0
	move.l	a0,a1
	move.w	#2048,d6	;start intensitet
	move.w	#113,d7		;antal
	move.w	#$000,d0	;from color
	move.w	#$f0f,d1	;dest color
	move.w	#3,d2		;mid antal
	move.w	#18,d3		;sub intensity
	bsr.W	dofade

	lea	farve2tab,a0
	move.l	a0,a1
	move.w	#2048,d6
	move.w	#58,d7
	move.w	#$000,d0
	move.w	#$f0f,d1
	move.w	#2,d2
	move.w	#35,d3
	bsr.W	dofade

	bsr.W	CP
	lea	copperlist,a0
	move.l	a0,$80(a6)
	move.w	#$83d0,DMACON(a6)

*-----------------------*
*	MAIN LOOP	*

ML:
;	move.w	#$f00,$180(a6)
	move.l	$4(a6),d0
	lsr.l	#1,d0
	lsr.w	#7,d0
	cmpi.w	#$128,d0
	bne.B	ML
;	clr.w	$180(a6)

	bsr.B	T1
	bsr.W	T2
	bsr.W	T3
	bsr.W	T4
	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	exit
	 ENDC
	cmp.l	#$73b,counter
	bne.B	ML

exit:	BLTW
	moveq	#0,d0
	rts


*--------------------------
* TASK 1 - the pink circle

T1:	lea	display(pc),a0
	movem.l	(a0),d0-d3
	movem.l	d1-d3,(a0)
	move.l	d0,12(a0)

	move.l	d0,a1
	move.l	CPbplptr(pc),a0
	moveq	#width,d0
	moveq	#3,d7
	bsr.W	copins

	BLTW
	move.l	#$01000000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	display+8(pc),a0
	addq.l	#2,a0
	move.l	a0,BLTDPT(a6)
	move.w	#6,BLTDMOD(a6)
	move.w	#[128*3]<<6+17,BLTSIZE(a6)

	lea	colorpos,a2
	lea	xsinpos(pc),a3
	moveq	#width*3,d3
	moveq	#3,d5

	lea	vinkel(pc),a0
	addq.b	#1,1(a0)
	move.w	(a0),d4
	addi.b	#32,d4
	andi.w	#$7f,d4
	cmp.b	#$40,d4
	bhs.B	.side
	pea	dotty2(pc)
	pea	dotty3(pc)
	lea	dotty1(pc),a5
	bra.B	.ok
.side	pea	dotty5(pc)
	pea	dotty6(pc)
	lea	dotty4(pc),a5
.ok
	move.w	d4,d0
	move.w	d0,d1
	ext.w	d0
	asl.w	#8,d0
	lea	matrixarea+$8000,a0
	lea	(a0,d0.W),a1
	add.w	d1,d1
	move.w	(a3,d1.W),d6
	move.l	display+4(pc),a4
	adda.w	#width,a4
	lea	xpos1(pc),a0
	moveq	#127,d7
	jsr	(a5)

	move.l	display+4(pc),a4
	adda.w	#[width*2],a4
	adda.w	#64*width*3,a4
	lea	xpos2(pc),a0
	moveq	#63,d7
	jsr	(a5)

	move.w	d4,d0
	subi.b	#$80,d0
	move.w	d0,d1
	ext.w	d0
	asl.w	#8,d0
	lea	matrixarea+$8000,a0
	lea	(a0,d0.W),a1
	add.w	d1,d1
	move.w	(a3,d1.W),d6

	move.l	display+4(pc),a4
	adda.w	#64*width*3,a4
	lea	xpos2(pc),a0
	moveq	#63,d7
	move.l	(sp)+,a5
	jsr	(a5)

	move.l	display(pc),a0
	adda.w	#scrsize-6,a0
	BLTW
	move.l	#$09f00012,BLTCON0(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a0,BLTDPT(a6)
	move.l	#$00060006,BLTAMOD(a6)
	move.w	#[128*3]<<6+17,BLTSIZE(a6)

	move.l	display+4(pc),a4
	lea	xpos1(pc),a0
	moveq	#127,d7
	move.l	(sp)+,a5
	jsr	(a5)
	rts


dotty1:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	neg.w	d0
	add.w	d6,d0

	move.w	d0,d1				;skygge linier (2!)
	lsr.w	d5,d0
	not.b	d1
	bset	d1,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty1
	rts
dotty2: move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2
	move.w	d0,(a2)+
	move.w	d2,(a2)+

	move.w	d0,d1				;venstre big line
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	move.w	d2,d0				;hjer big line
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	bchg	d2,width(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty2
	rts
dotty3:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2
	move.w	d0,(a2)+
	move.w	d2,(a2)+

	move.w	d0,d1				;hjer hul line
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	move.w	d2,d0				;venstre hul line
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	bchg	d2,width*2(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty3
	rts

dotty4:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	add.w	d6,d0

	move.w	d0,d1
	lsr.w	d5,d0
	not.b	d1
	bset	d1,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty4
	rts
dotty5:	move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2
	move.w	d0,(a2)+
	move.w	d2,(a2)+

	move.w	d0,d1
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	bchg	d1,width(a4,d0.W)
	move.w	d2,d0
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty5
	rts
dotty6: move.w	(a0)+,d0
	move.b	(a1,d0.W),d0
	ext.w	d0
	move.w	d0,d2
	neg.w	d0
	add.w	d6,d0
	add.w	d6,d2
	move.w	d0,(a2)+
	move.w	d2,(a2)+

	move.w	d0,d1
	lsr.w	d5,d0
	not.b	d1
	bchg	d1,(a4,d0.W)
	bchg	d1,width*2(a4,d0.W)
	move.w	d2,d0
	lsr.w	d5,d0
	not.b	d2
	bchg	d2,(a4,d0.W)
	adda.w	d3,a4
	dbf	d7,dotty6
	rts

* TASK 1 data
display:	dc.l screen1,screen2,screen3,screen4
vinkel:		dc.w 0


xpos1:
 DC.W $80,$8B,$93,$99,$9D,$A1,$A5,$A8
 DC.W $AB,$AD,$B0,$B2,$B5,$B7,$B9,$BB
 DC.W $BD,$BE,$C0,$C2,$C3,$C5,$C7,$C8
 DC.W $C9,$CB,$CC,$CD,$CF,$D0,$D1,$D2
 DC.W $D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB
 DC.W $DC,$DD,$DE,$DF,$E0,$E0,$E1,$E2
 DC.W $E3,$E4,$E4,$E5,$E6,$E7,$E7,$E8
 DC.W $E9,$EA,$EA,$EB,$EB,$EC,$ED,$ED
 DC.W $EE,$EE,$EF,$F0,$F0,$F1,$F1,$F2
 DC.W $F2,$F3,$F3,$F4,$F4,$F4,$F5,$F5
 DC.W $F6,$F6,$F6,$F7,$F7,$F8,$F8,$F8
 DC.W $F9,$F9,$F9,$FA,$FA,$FA,$FA,$FB
 DC.W $FB,$FB,$FB,$FC,$FC,$FC,$FC,$FD
 DC.W $FD,$FD,$FD,$FD,$FD,$FE,$FE,$FE
 DC.W $FE,$FE,$FE,$FE,$FE,$FF,$FF,$FF
 DC.W $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

dat1_circle:
 DC.W $80,$8B,$93,$99,$9D,$A1,$A5,$A8
 DC.W $AB,$AD,$B0,$B2,$B5,$B7,$B9,$BB
 DC.W $BD,$BE,$C0,$C2,$C3,$C5,$C7,$C8
 DC.W $C9,$CB,$CC,$CD,$CF,$D0,$D1,$D2
 DC.W $D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB
 DC.W $DC,$DD,$DE,$DF,$E0,$E0,$E1,$E2
 DC.W $E3,$E4,$E4,$E5,$E6,$E7,$E7,$E8
 DC.W $E9,$EA,$EA,$EB,$EB,$EC,$ED,$ED
 DC.W $EE,$EE,$EF,$F0,$F0,$F1,$F1,$F2
 DC.W $F2,$F3,$F3,$F4,$F4,$F4,$F5,$F5
 DC.W $F6,$F6,$F6,$F7,$F7,$F8,$F8,$F8
 DC.W $F9,$F9,$F9,$FA,$FA,$FA,$FA,$FB
 DC.W $FB,$FB,$FB,$FC,$FC,$FC,$FC,$FD
 DC.W $FD,$FD,$FD,$FD,$FD,$FE,$FE,$FE
 DC.W $FE,$FE,$FE,$FE,$FE,$FF,$FF,$FF
 DC.W $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

dat1_egg:
 DC.W $C0,$C7,$CD,$D1,$D4,$D7,$D9,$DC
 DC.W $DE,$DF,$E1,$E3,$E4,$E5,$E7,$E8
 DC.W $E9,$EA,$EB,$ED,$ED,$EE,$EF,$F0
 DC.W $F1,$F2,$F2,$F3,$F4,$F5,$F5,$F6
 DC.W $F6,$F7,$F8,$F8,$F9,$F9,$F9,$FA
 DC.W $FA,$FB,$FB,$FB,$FC,$FC,$FC,$FD
 DC.W $FD,$FD,$FD,$FE,$FE,$FE,$FE,$FE
 DC.W $FE,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 BLK.W 64,$FF

dat1_pyramid:
 DC.W $80,$81,$82,$83,$84,$85,$86,$87
 DC.W $88,$89,$8A,$8B,$8C,$8D,$8E,$8F
 DC.W $90,$91,$92,$93,$94,$95,$96,$97
 DC.W $98,$99,$9A,$9B,$9C,$9D,$9E,$9F
 DC.W $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7
 DC.W $A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF
 DC.W $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7
 DC.W $B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF
 DC.W $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7
 DC.W $C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF
 DC.W $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7
 DC.W $D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF
 DC.W $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7
 DC.W $E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF
 DC.W $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7
 DC.W $F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF


xpos2:
 DC.W $80,$79,$73,$6F,$6C,$69,$67,$64
 DC.W $62,$61,$5F,$5D,$5C,$5B,$59,$58
 DC.W $57,$56,$55,$53,$53,$52,$51,$50
 DC.W $4F,$4E,$4E,$4D,$4C,$4B,$4B,$4A
 DC.W $4A,$49,$48,$48,$47,$47,$47,$46
 DC.W $46,$45,$45,$45,$44,$44,$44,$43
 DC.W $43,$43,$43,$42,$42,$42,$42,$42
 DC.W $42,$41,$41,$41,$41,$41,$41,$41

dat2_circle:
 DC.W $80,$79,$73,$6F,$6C,$69,$67,$64
 DC.W $62,$61,$5F,$5D,$5C,$5B,$59,$58
 DC.W $57,$56,$55,$53,$53,$52,$51,$50
 DC.W $4F,$4E,$4E,$4D,$4C,$4B,$4B,$4A
 DC.W $4A,$49,$48,$48,$47,$47,$47,$46
 DC.W $46,$45,$45,$45,$44,$44,$44,$43
 DC.W $43,$43,$43,$42,$42,$42,$42,$42
 DC.W $42,$41,$41,$41,$41,$41,$41,$41

dat2_egg:
 dc.w $79,$74,$71,$6E,$6C,$6A,$68,$66,$65,$64,$62
 DC.W $61,$60,$5F,$5E,$5D,$5B,$5A,$59,$58,$57,$56,$55,$54,$53,$52,$51
 DC.W $50,$4F,$4E,$4D,$4C,$4B,$4A,$49,$49,$48,$47,$46,$46,$45,$44,$44
 DC.W $43,$42,$42,$41,$41,$40,$40,$3F,$3F,$3F,$3E,$3E,$3E,$3D,$3D,$3D
 DC.W $3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D,$3D

dat2_pyramid:
 DC.W $80,$7F,$7E
 DC.W $7D,$7C,$7B,$7A,$79,$78,$77,$76
 DC.W $75,$74,$73,$72,$71,$70,$6F,$6E
 DC.W $6D,$6C,$6B,$6A,$69,$68,$67,$66
 DC.W $65,$64,$63,$62,$61,$60,$5F,$5E
 DC.W $5D,$5C,$5B,$5A,$59,$58,$57,$56
 DC.W $55,$54,$53,$52,$51,$50,$4F,$4E
 DC.W $4D,$4C,$4B,$4A,$49,$48,$47,$46
 DC.W $45,$44,$43,$42,$41,$40,$3F,$3E
 DC.W $3D,$3C,$3B,$3A,$39,$38,$37,$36

dat2_nothing: BLK.W 64,$80


*------------------
* TASK 2 - handler

T2:
	bsr.B	transform
	lea	counter(pc),a0
	lea	struktur(pc),a1
	addq.l	#1,(a0)
	cmp.l	#$100,(a0)
	bne.B	.no1
	move.l	#dat1_egg,(a1)
.no1	cmp.l	#$1f0,(a0)
	bne.B	.no2
	move.l	#dat2_egg,4(a1)
.no2	cmp.l	#$240,(a0)
	bne.B	.no3
	move.l	#dat1_pyramid,(a1)
.no3	cmp.l	#$360,(a0)
	bne.B	.no4
	move.l	#dat2_pyramid,4(a1)
.no4
	cmp.l	#$4f0,(a0)
	bne.B	.no6
	move.l	#dat2_circle,4(a1)
.no6	cmp.l	#$550,(a0)
	bne.B	.no7
	move.l	#dat1_circle,(a1)
.no7	cmp.l	#$5f0,(a0)
	bne.B	.no8
	move.l	#dat2_nothing,4(a1)
.no8	rts


transform:
	lea	xpos1(pc),a0
	move.l	struktur(pc),a1
	moveq	#63,d7
.comp1	move.w	(a1)+,d0
	cmp.w	(a0),d0
	beq.B	.same1
	blo.B	.lower1
	addq.w	#1,(a0)
	bra.B	.same1
.lower1	subq.w	#1,(a0)
.same1	addq.l	#2,a0

	move.w	(a1)+,d0
	cmp.w	(a0),d0
	beq.B	.same2
	blo.B	.lower2
	addq.w	#1,(a0)
	bra.B	.same2
.lower2	subq.w	#1,(a0)
.same2	addq.l	#2,a0
	dbf	d7,.comp1

	lea	xpos2(pc),a0
	move.l	struktur+4(pc),a1
	moveq	#63,d7
.comp2	move.w	(a1)+,d0
	cmp.w	(a0),d0
	beq.B	.same3
	blo.B	.lower3
	addq.w	#1,(a0)
	bra.B	.same3
.lower3	subq.w	#1,(a0)
.same3	addq.l	#2,a0
	dbf	d7,.comp2
	rts


* TASK 2 data
struktur:	dc.l xpos1,xpos2
counter:	dc.l 0


*------------------
* TASK 3 - colors

T3:	lea	colorpos+256,a0
	move.l	CPcol1(pc),a1
	addq.l	#6,a1
	lea	farve1tab,a2
	move.w	#63,d7
.farv1	move.w	256(a0),d0
	sub.w	(a0)+,d0
	add.w	d0,d0
	move.w	(a2,d0.W),d0
	move.w	d0,(a1)
	move.w	d0,14-6(a1)
	lea	16(a1),a1

	move.w	256(a0),d0
	sub.w	(a0)+,d0
	add.w	d0,d0
	move.w	(a2,d0.W),d0
	move.w	d0,(a1)
	move.w	d0,14-6(a1)
	lea	16(a1),a1
	dbf	d7,.farv1

	lea	colorpos,a0
	move.l	CPcol1(pc),a1
	adda.w	#[64*16]+10,a1
	lea	farve2tab,a2
	move.w	#63,d7
.farv2	move.w	128(a0),d0
	sub.w	(a0)+,d0
	add.w	d0,d0
	move.w	(a2,d0.W),(a1)
	lea	16(a1),a1
	dbf	d7,.farv2

	lea	vinkel(pc),a0
	move.w	(a0),d0
	subi.b	#32,d0
	move.w	d0,d1
	andi.w	#63,d0
	asr.w	#2,d0
	andi.w	#127,d1
	cmpi.w	#$40,d1
	blo.B	.col0
	not.b	d0
.col0	andi.w	#$f,d0
	add.w	d0,d0
	move.w	farve0tab(pc,d0.W),d0
	move.l	CPcol0(pc),a0
	move.w	d0,2(a0)
	move.w	d0,6(a0)
	move.w	d0,10(a0)

	move.l	CPcol1(pc),a0
	move.l	CPcol2(pc),a1
	addq.w	#2,a0
	adda.w	#[[cantal]*16]+2,a1
	move.w	#$8400,$96(a6)
	BLTW
	move.w	#$0400,$96(a6)
	move.l	#$09f00000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.w	#2,BLTAMOD(a6)
	move.w	#-6,BLTDMOD(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#[128*4]<<6+1,BLTSIZE(a6)
	rts

farve0tab:
	DC.W	$0F0F,$0E0E,$0D0D,$0C0C,$0B0B,$0A0A,$0909,$0808
	DC.W	$0707,$0606,$0505,$0404,$0303,$0202,$0101,$0000


*------------------
* TASK 4 - in/out

T4:
	lea	fcounter(pc),a0
	addq.w	#1,(a0)
	cmp.w	#128,(a0)
	bls.B	.in
	move.w	#$73b,d3		;das ende!
	move.w	d3,d0
	subi.w	#128,d0
	cmp.w	(a0),d0
	blo.B	.out
	rts
.in	move.w	(a0),d0
	subq.w	#1,d0
	eori.w	#127,d0
	mulu	#width*3,d0
	lea	maskscreen,a0
	adda.w	d0,a0
	moveq	#0,d0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	rts
.out	move.w	(a0),d0
	sub.w	d3,d0
	subq.w	#1,d0
	andi.w	#127,d0
	mulu	#width*3,d0
	lea	maskscreen,a0
	adda.w	d0,a0
	moveq	#-1,d0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	rts


* TASK 4 data
fcounter:	dc.w 0


*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:	lea	copperlist,a0
	move.l	#$01800102,(a0)+
	move.l	#$008e2881,(a0)+
	move.l	#$009027c1,(a0)+
	move.l	#$00920038,(a0)+
	move.l	#$009400d0,(a0)+
	move.l	#$01000200,(a0)+
	move.l	#$01020000,(a0)+
	move.l	#$01040024,(a0)+
	move.l	#$01200000,(a0)+
	move.l	#$01220000,(a0)+
	move.l	#$01400000,(a0)+
	move.l	#$01420000,(a0)+
	move.l	#$01080000+[width*2],(a0)+
	move.l	#$010a0000+[width*2],(a0)+
	move.l	a0,CPbplptr
	move.l	#$00e00000,(a0)+
	move.l	#$00e20000,(a0)+
	move.l	#$00e40000,(a0)+
	move.l	#$00e60000,(a0)+
	move.l	#$00e80000,(a0)+
	move.l	#$00ea0000,(a0)+
	move.l	#$00ec0000+[maskscreen/$10000],(a0)+
	move.l	#$00ee0000+[maskscreen&$ffff],(a0)+
	move.l	#$01800102,(a0)+
	move.l	a0,CPcol0
	move.l	#$01820000,(a0)+
	move.l	#$01860000,(a0)+
	move.l	#$018a0000,(a0)+
	move.l	#$018e0000,(a0)+

	move.l	#$01900102,(a0)+
	move.l	#$01920102,(a0)+
	move.l	#$01940102,(a0)+
	move.l	#$01960102,(a0)+
	move.l	#$01980102,(a0)+
	move.l	#$019a0102,(a0)+
	move.l	#$019c0102,(a0)+
	move.l	#$019e0102,(a0)+
	move.l	#$2801fffe,(a0)+
	move.l	#$01004200,(a0)+

	move.l	a0,CPcol1
	move.b	#$28,d0
	move.w	#cantal-1,d7
.farve1	move.b	d0,(a0)+
	move.b	#$01,(a0)+
	move.w	#$fffe,(a0)+
	move.l	#$01840000,(a0)+
	move.l	#$01880000,(a0)+
	move.l	#$018c0000,(a0)+
	addq.b	#1,d0
	dbf	d7,.farve1

	move.l	#$a701fffe,(a0)+
	move.l	#$01080000+[-width*4]&$FFFF,(a0)+
	move.l	#$010a0000+[-width*4]&$FFFF,(a0)+

	move.l	a0,CPcol2
	move.b	#$a7,d0
	move.w	#cantal-1,d7
.farve2	tst.b	d0
	bne.B	.no0
	move.l	#$ffe1fffe,(a0)+
	bra.B	.nxt
.no0	move.b	d0,(a0)+
	move.b	#$01,(a0)+
	move.w	#$fffe,(a0)+
.nxt	move.l	#$01840000,(a0)+
	move.l	#$01880000,(a0)+
	move.l	#$018c0000,(a0)+
	addq.b	#1,d0
	dbf	d7,.farve2
	move.l	#$2701fffe,(a0)+
	move.l	#$01000200,(a0)+
	move.l	#$fffffffe,(a0)
	rts

CPbplptr: 	dc.l 0
CPcol0:		dc.l 0
CPcol1: 	dc.l 0
CPcol2: 	dc.l 0


*-------------*
* SUBROUTINES *
*-------------*

RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

copins:	move.l	a1,d1
	swap	d1
	move.w	d1,2(a0)
	move.w	a1,6(a0)
	adda.w	d0,a1
	addq.l	#8,a0
	subq.w	#1,d7
	bne.S	copins
	rts

fill:	clr.l	(a0)+
	clr.l	(a0)+
	subq.l	#8,d0
	bpl.B	fill
	rts

dofade:
	move.w	d2,fademid
	clr.w	fadeantal		;antal zame
.fade	movem.w	d0-d7,-(sp)
	bsr.B	fade

	cmp.w	lastfade(pc),d0
	beq.B	.zame
	clr.w	fadeantal
.zame	move.w	d0,lastfade
	addq.w	#1,fadeantal

	move.w	fademid(pc),d1
	cmp.w	fadeantal(pc),d1
	blo.B	.xx1
	addi.w	#$010,d0
.xx1	move.w	fademid(pc),d1
	addq.w	#2,d1
	cmp.w	fadeantal(pc),d1
	bhi.B	.xx2
	subi.w	#$100,d0
.xx2
	move.w	d0,(a0)+
	move.w	d0,-(a1)
	movem.w	(sp)+,d0-d7
	subi.w	d3,d6
	dbf	d7,.fade
	rts

fademid:	dc.w 0
fadeantal:	dc.w 0
lastfade:	dc.w 0

fade:	move.w	d1,d3
	move.w	d0,d1
	move.w	d0,d2
	move.w	d3,d4
	move.w	d3,d5
	andi.w	#$00f,d0
	andi.w	#$0f0,d1
	andi.w	#$f00,d2
	andi.w	#$00f,d3
	andi.w	#$0f0,d4
	andi.w	#$f00,d5
	sub.w	d0,d3
	sub.w	d1,d4
	sub.w	d2,d5
	muls	d6,d3
	muls	d6,d4
	muls	d6,d5
	asr.l	#8,d3
	asr.l	#8,d4
	asr.l	#8,d5
	asr.l	#3,d3
	asr.l	#3,d4
	asr.l	#3,d5
	andi.w	#$00f,d3
	andi.w	#$0f0,d4
	andi.w	#$f00,d5
	add.w	d3,d0
	add.w	d4,d1
	add.w	d5,d2
	or.w	d2,d0
	or.w	d1,d0
	rts


xsinpos:
 DC.W $B4,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B2,$B2,$B2,$B2
 DC.W $B2,$B1,$B1,$B1,$B1,$B0,$B0,$B0,$AF,$AF,$AF,$AE,$AE,$AE,$AD,$AD
 DC.W $AC,$AC,$AC,$AB,$AB,$AA,$AA,$A9,$A9,$A8,$A8,$A7,$A7,$A6,$A6,$A5
 DC.W $A5,$A4,$A4,$A3,$A2,$A2,$A1,$A1,$A0,$A0,$9F,$9E,$9E,$9D,$9D,$9C
 DC.W $9B,$9B,$9A,$9A,$99,$99,$98,$97,$97,$96,$96,$95,$95,$94,$93,$93
 DC.W $92,$92,$91,$91,$90,$90,$8F,$8F,$8E,$8E,$8D,$8D,$8C,$8C,$8B,$8B
 DC.W $8B,$8A,$8A,$89,$89,$89,$88,$88,$88,$87,$87,$87,$86,$86,$86,$86
 DC.W $85,$85,$85,$85,$85,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84
 DC.W $84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$84,$85,$85,$85,$85
 DC.W $85,$86,$86,$86,$86,$87,$87,$87,$88,$88,$88,$89,$89,$89,$8A,$8A
 DC.W $8B,$8B,$8B,$8C,$8C,$8D,$8D,$8E,$8E,$8F,$8F,$90,$90,$91,$91,$92
 DC.W $92,$93,$93,$94,$95,$95,$96,$96,$97,$97,$98,$99,$99,$9A,$9A,$9B
 DC.W $9C,$9C,$9D,$9D,$9E,$9E,$9F,$A0,$A0,$A1,$A1,$A2,$A2,$A3,$A4,$A4
 DC.W $A5,$A5,$A6,$A6,$A7,$A7,$A8,$A8,$A9,$A9,$AA,$AA,$AB,$AB,$AC,$AC
 DC.W $AC,$AD,$AD,$AE,$AE,$AE,$AF,$AF,$AF,$B0,$B0,$B0,$B1,$B1,$B1,$B1
 DC.W $B2,$B2,$B2,$B2,$B2,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3,$B3

 END

