; NAME
;								TAS / jul1992


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  ...				$50000	...

; auto js\
 include chipmap.inc
>extern 'df0:pst2.bpl',picture
 org $20000
 load $20000
copperlist = $7a000
width = 40


xsize = 120
ysize = 57

picture = $40000
size = ysize*40

color1pix = $42000
drawscreen = $44000

coords = $50000
vektortabel = $54000


BLTW:	 MACRO
.\@	btst	#14,$2(a6)
	bne.B	.\@
	 ENDM

*------------------*
* START UP PROGRAM *

s	lea	DMA,a6
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	move.w	#$01bf,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	clr.w	$180(a6)
	lea	$bfd100,a0
	bset	#7,(a0)
	andi.b	#$87,(a0)
	ori.b	#$78,(a0)
	move.l	$4.W,a0
;;	clr.l	56(a0)	;Reset!


*-------
* SETUP

	lea	$42000,a0
	move.l	#$30000,d0
	bsr.W	clear

	lea	coords,a0
	moveq	#-1,d0
	move.w	#$fff,d1
.clear	move.w	d0,(a0)+
	dbf	d1,.clear

*----------------------------
* PREPARE COPPER, DMA ECT

	lea	CP(pc),a0
	move.l	a0,$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)

*----------------*
* MAIN CALC HEAD *

	lea	coords,a2
	lea	vektortabel,a3
	clr.w	(a3)+
	moveq	#1,d0		;color
	bsr.W	extract
	bsr.W	build

	lea	drawscreen,a0
	lea	picture+20,a1
	BLTW
	move.l	#$09f00000,BLTCON0(a6)
	move.l	#-1,BLTAFWM(a6)
	move.w	#20,BLTAMOD(a6)
	move.w	#20,BLTDMOD(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+10,BLTSIZE(a6)

	lea	coords,a2
	lea	vektortabel,a3
	clr.w	(a3)+

	moveq	#3,d0		;color
	bsr.W	extract
	bsr.W	build


	lea	drawscreen,a0
	lea	picture+20+size,a1
	BLTW
	move.l	#$09f00000,BLTCON0(a6)
	move.l	#-1,BLTAFWM(a6)
	move.w	#20,BLTAMOD(a6)
	move.w	#20,BLTDMOD(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+10,BLTSIZE(a6)

.mouse	btst	#6,$bfe001
	bne.B	.mouse

*------*
* EXIT *
	BLTW
	move.l	#$7fff7fff,INTENA(a6)
	move.l	intregs(pc),d0
	ori.l	#$80008000,d0
	move.l	d0,INTENA(a6)

	move.l	$4.W,a0
	move.l	$9c(a0),a0
	move.l	$26(a0),$80(a6)
	tas	$88(a6)
	move.w	#$83f0,DMACON(a6)
	moveq	#0,d0
	rts


extract:
	move.w	d0,ColorOfFace

	lea	color1pix,a0
	move.l	#$2000,d0
	bsr.W	clear

	lea	picture,a0
	lea	color1pix,a1
	move.w	ColorOfFace(pc),d0
	moveq	#2,d2
	moveq	#ysize,d7
.yloop	moveq	#[xsize/8]-1,d6
.xloop	moveq	#7,d5
.ploop	moveq	#0,d1
	btst	d5,(a0)
	beq.B	.no1
	moveq	#1,d1
.no1	btst	d5,size(a0)
	beq.B	.no2
	or.b	d2,d1
.no2	cmp.w	d0,d1
	bne.B	.notsame
	bset	d5,(a1)
.notsame
	dbf	d5,.ploop
	addq.l	#1,a0
	addq.l	#1,a1
	dbf	d6,.xloop
	adda.w	#40-[xsize/8],a0
	adda.w	#40-[xsize/8],a1
	dbf	d7,.yloop
	rts


build:
	lea	direction_add(pc),a4
	moveq	#0,d6				;antal punkter
hovedloop
	lea	color1pix,a0
	clr.w	d1
.ylop	clr.w	d0
.xlop	move.w	d0,d2
	move.w	d0,d3
	lsr.w	#3,d2
	not.b	d3
	btst	d3,(a0,d2.W)
	bne.B	.found
	addq.w	#1,d0
	cmp.w	#xsize,d0
	bne.B	.xlop
	adda.w	#40,a0
	addq.w	#1,d1
	cmp.w	#ysize,d1
	bne.B	.ylop
	bra.W	no_pixels_left
.found
	addq.w	#1,vektortabel


	lea	color1pix,a0
	moveq	#2,d4				;retning

	clr.w	(a3)+
	move.l	a3,PointsInFace
	move.w	#0,(a3)+
	move.w	ColorOfFace(pc),(a3)+
	
	move.w	d0,startx
	move.w	d1,starty
	move.w	d6,startnum
	bsr.W	setkoord
.loop
	move.w	d4,d5
	subq.w	#2,d4			;check  DIR-2
	bsr.W	test_dir
	tst.b	d2
	bne.B	.found_dir
	addq.w	#1,d4			;check  DIR-1
	bsr.W	test_dir
	tst.b	d2
	bne.B	.found_dir

	move.w	d5,d4			;check DIR
	bsr.W	test_dir
	tst.b	d2
	beq.B	.notstraight
	move.w	d4,d2
	lsl.w	#2,d2
	add.w	(a4,d2.W),d0
	add.w	2(a4,d2.W),d1
	cmp.w	startx(pc),d0
	bne.B	.loop
	cmp.w	starty(pc),d1
	bne.B	.loop
	bra.B	StartFound
.notstraight

	addq.w	#1,d4			;check DIR+1
	bsr.W	test_dir
	tst.b	d2
	bne.B	.found_dir
	addq.w	#1,d4			;check DIR+2
	bsr.W	test_dir
	tst.b	d2
	bne.B	.found_dir
	addq.w	#1,d4			;check DIR+3
	bsr.W	test_dir
	tst.b	d2
	bne.B	.found_dir
	addq.w	#1,d4			;check DIR+4
	bsr.W	test_dir
	tst.b	d2
	bne.B	.found_dir
	bra.W	error

.found_dir
	bsr.W	setkoord
	bsr.W	draw_it
	move.w	d4,d2
	lsl.w	#2,d2
	add.w	(a4,d2.W),d0
	add.w	2(a4,d2.W),d1
	cmp.w	startx(pc),d0
	bne.B	.loop
	cmp.w	starty(pc),d1
	bne.W	.loop


startfound:
	move.w	startnum,(a3)+
	bsr.W	draw_it

.rmb1	btst	#2,$16(a6)
	bne.B	.rmb1
.rmb2	btst	#2,$16(a6)
	bne.B	.rmb2

	lea	drawscreen,a0
	lea	color1pix,a1
	BLTW
	move.l	#$0d0c0000,BLTCON0(a6)
	move.l	#-1,BLTAFWM(a6)
	clr.l	BLTAMOD(a6)
	clr.w	BLTBMOD(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+20,BLTSIZE(a6)
	adda.w	#40,a1
	BLTW
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+20,BLTSIZE(a6)
	suba.w	#80,a1
	BLTW
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+20,BLTSIZE(a6)
	BLTW
	adda.w	#80,a1
	move.l	#$1d0c0000,BLTCON0(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+20,BLTSIZE(a6)
	BLTW
	adda.w	#80,a1
	move.l	#$1d0c0000,BLTCON0(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a1,BLTBPT(a6)
	move.l	a1,BLTDPT(a6)
	move.w	#ysize<<6+20,BLTSIZE(a6)
	bra.W	hovedloop


no_pixels_left:
	move.w	#$0f0,status180+2
	bsr.W	draw_it
	moveq	#0,d7
	rts	


error:	move.w	#$4000,d0
.loop	move.w	#$f00,$dff180
	dbf	d0,.loop
	move.w	#$f00,status180+2
	moveq	#-1,d7
	rts

test_dir:
	andi.w	#7,d4
	movem.l	d0/d1/d4,-(sp)
	lsl.w	#2,d4
	add.w	(a4,d4.W),d0
	add.w	2(a4,d4.W),d1

	move.w	d0,d2
	mulu	#width,d1
	lsr.w	#3,d2
	add.w	d2,d1
	not.b	d0
	btst	d0,(a0,d1.W)
	sne	d2
	movem.l	(sp)+,d0/d1/d4
	rts


setkoord:
	and.w	#7,d5
	move.w	d0,(a2)+
	move.w	d1,(a2)+
	move.w	#0,(a2)+
	move.w	d6,(a3)+
	addq.w	#1,d6
	addq.w	#1,antal
	move.l	a0,-(sp)
	move.l	PointsInFace(pc),a0
	addq.w	#1,(a0)
	move.l	(sp)+,a0
	rts

*-----------*
* CALC DATA *

PointsInFace:	dc.l 0
direction_add:	dc.w 0,-1, 1,-1, 1,0, 1,1, 0,1, -1,1, -1,0, -1,-1
startx:		dc.w 0
starty:		dc.w 0
startnum:	dc.w 0
Antal:		dc.w 0
LastDir:	dc.w 0
ColorOfFace:	dc.w 0



*-------------*
* DRAW VECTOR *

draw_it:
	movem.l	d0-a6,-(sp)
	lea	$dff000,a6
	lea	drawscreen,a0
	BLTW
	move.l	#$01000000,BLTCON0(a6)
	move.l	a0,BLTDPT(a6)
	move.l	#-1,BLTAFWM(a6)
	clr.l	BLTAMOD(a6)
	move.w	#80*64+20,BLTSIZE(a6)

	lea	drawscreen,a0
	lea	vektortabel,a1
	lea	coords,a2
	move.w	(a1)+,d7
.gogo
	move.w	2(a1),d6
	cmpi.w	#3,d6
	bls.W	.fuck
	subq.w	#1,d6

	addq.l	#6,a1
	BLTW
	move.w	#width,$60(a6)
	move.w	#width,$66(a6)
	move.l	#$ffff8000,$72(a6)
	move.l	#$ffffffff,$44(a6)
	clr.b	$42(a6)
.loop
	move.w	(a1)+,d2
	mulu	#6,d2
	movem.w	(a2,d2.W),d0/d1
	move.w	(a1),d2
	mulu	#6,d2
	movem.w	(a2,d2.W),d2/d3

	bsr.W	draw_line
	dbf	d6,.loop

	addq.l	#2,a1
	subq.w	#1,d7
	tst.w	d7
	bne.B	.gogo

	lea	drawscreen,a0
	adda.w	#[80*40]-2,a0
	BLTW
	move.l	#$09f0000a,BLTCON0(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a0,BLTDPT(a6)
	move.l	#-1,BLTAFWM(a6)
	clr.l	BLTAMOD(a6)
	move.w	#80*64+20,BLTSIZE(a6)

.fuck	movem.l	(sp)+,d0-a6
	rts




draw_line:
	cmp.w	d1,d3
	bgt.S	.exg
	exg	d0,d2
	exg	d1,d3
.exg	cmp.w	d1,d3
	beq.S	.noline
	move.w	d1,d4
	muls	#width,d4
	move.w	d0,d5
	add.l	a0,d4
	asr.w	#3,d5
	add.w	d5,d4
	moveq	#0,d5
	sub.w	d1,d3
	sub.w	d0,d2
	bpl.S	.line7a
	moveq	#1,d5
	neg.w	d2
.line7a	move.w	d3,d1
	add.w	d1,d1
	cmp.w	d2,d1
	dbhi	d3,.line84
.line84	move.w	d3,d1
	sub.w	d2,d1
	bpl.S	.line8c
	exg	d2,d3
.line8c	addx.w	d5,d5
	add.w	d2,d2
	move.w	d2,d1
	sub.w	d3,d2
	addx.w	d5,d5
	andi.w	#$f,d0
	ror.w	#4,d0
	ori.w	#$0a4a,d0
	BLTW
	move.w	d2,$52(a6)
	sub.w	d3,d2
	lsl.w	#6,d3
	addq.w	#2,d3
	move.w	d0,$40(a6)
	move.b	oktant(PC,d5.w),$43(a6)
	move.l	d4,$48(a6)
	move.l	d4,$54(a6)
	movem.w	d1/d2,$62(a6)
	move.w	d3,$58(a6)
.noline	rts

oktant:	dc.b	$03,$43,$13,$53,$0b,$4b,$17,$57



*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800000
 dc.l $008e2881,$009030c1,$00920038,$009400d0
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,0,$010a,0
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.l $01800046
 dc.l $01820eee
 dc.l $01840888
 dc.l $01860ccc

 dc.l $2801fffe
 dc.l $01002200
 dc.w $00e0,$4,$00e2,0
 dc.w $00e4,$4,$00e6,size

 dc.l $6101fffe
 dc.l $01001200
 dc.w $00e0,$4,$00e2,$2000

 dc.l $9a01fffe
 dc.l $01001200
 dc.w $00e0,$4,$00e2,$4000
 dc.l $01820FFF

 dc.l $d301fffe
 dc.l $01002200
 dc.w $00e0,$4,$00e2,$2000
 dc.w $00e4,$4,$00e6,$4000
 dc.l $01800046
 dc.l $01820fff
 dc.l $01840ff0
 dc.l $01860646

 dc.l $ffe1fffe
 dc.l $0c01fffe
 dc.l $01800aaa
 dc.l $0d01fffe
status180:
 dc.l $01800Fa3
 dc.l $1001fffe
 dc.l $01800aaa
 dc.l $1101fffe
 dc.l $01800046

 dc.l $fffffffe



*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

 END

