<<<<<<<<<;
; rotating scroll:  *THE FAMOUS SNURKELSCROLL* PART III
;
; denne version bruger et pp-crunched font
;								TAS / jul1992

DEMOSTARTUP = 0


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000	$21000
*  screens			$50000	$59600
*  animations			$60000	$7f800

 INCLUDE chipmap.inc
 ORG $2B100
 LOAD $2B100
sintabel = $27800
>EXTERN "df0:sin1024.data",sintabel

width = 50

font	= $58000
fontw	= 40
fonty	= 40

size	= 200*width*2
screen1	= $5a000
screen2	= screen1+size

megakode	= screen1
coords		= megakode+$4000
animarea	= $64000


BLTW:	 MACRO
	btst	#14,$2(a6)
	bne.B	*-6
	 ENDM

*------------------*
* START UP PROGRAM *

S:	lea	DMA,a6
	 IFEQ DEMOSTARTUP
	clr.l	$0.W
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	 ENDC

	move.w	#$01b0,DMACON(a6)
	move.w	#$8240,DMACON(a6)
	move.w	#$253,$180(a6)
	move.w	#$0200,$100(a6)

	moveq	#4,d0			;no decrunch color
	lea	fontcru,a0
	adda.w	#fontlength,a0
	lea	font,a1
	bsr.W	decruncher

	lea	animarea,a0
	move.l	#$1b000,d0
	bsr.W	clear

	bsr.W	rotate_font
	bsr.W	convert_text

	lea	screen1,a0
	move.l	#size*2,d0
	bsr.W	clear

	move.w	#$120,d0
	bsr.W	RC
	lea	CP(pc),a0
	move.l	a0,$80(a6)
	move.w	#$83f0,DMACON(a6)

*---------------------*
*      MAIN LOOP      *

ML:	move.w	#$128,d0
	bsr.W	RC

	bsr.W	T1
	 IFEQ DEMOSTARTUP
	btst	#6,$bfe001
	beq.B	.exit
	 ENDC
	tst.w	quit
	beq.B	ML

.exit	BLTW
	moveq	#0,d0
	rts
quit:	dc.w 0


convert_text:
	lea	text(pc),a0
.loop1	move.b	(a0),d0
	bmi.B	.end
	lea	.alfabet(pc),a1
	moveq	#-1,d1
.loop2	addq.w	#1,d1
	tst.b	(a1)
	beq.B	.ok
	cmp.b	(a1)+,d0
	bne.B	.loop2
.ok	move.b	d1,(a0)+
	bra.B	.loop1
.end	rts
.alfabet: DC.B `.!ABCDEFGHIJKLMNOPQRSTUVWXYZ `,0
 even


*-------------------
* TASK 1 - scroller

T1:	lea	display(pc),a0
	movem.l	(a0),d0/d1
	exg	d0,d1
	movem.l	d0/d1,(a0)
	addq.l	#6,d1
	lea	CPbpl(pc),a0
	move.w	d1,6(a0)
	swap	d1
	move.w	d1,2(a0)
	swap	d1
	addi.l	#200*width,d1
	move.w	d1,14(a0)
	swap	d1
	move.w	d1,10(a0)
	
	move.l	display(pc),a0
	addq.l	#6,a0
	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.l	BLTAFWM(a6)
	move.l	a0,BLTDPT(a6)
	move.w	#6,BLTDMOD(a6)
	move.w	#200<<6+22,BLTSIZE(a6)
	adda.w	#200*width,a0
	movem.l	clrbuffer(pc),d0-d5
	movem.l	clrbuffer(pc),a1-a5
	moveq	#width,d6
	moveq	#99,d7
.clr	movem.l	d0-d5/a1-a5,(a0)
	adda.w	d6,a0
	movem.l	d0-d5/a1-a5,(a0)
	adda.w	d6,a0
	dbf	d7,.clr

	move.l	textpointer(pc),a0
	lea	sinus(pc),a1
	lea	animdata(pc),a4
	move.l	display(pc),a5
	movem.w	sinpos(pc),d1-d3
	move.w	#-64,d5
	sub.w	scrollxadd(pc),d5
	moveq	#19,d7
	move.w	d5,lastx
	clr.w	lasty
	BLTW
	clr.w	BLTCON1(a6)
	move.l	#$ffff0000,BLTAFWM(a6)
	move.w	#-2,BLTAMOD(a6)
	move.w	#width-8,BLTBMOD(a6)
	move.w	#width-8,BLTDMOD(a6)
.loop
	movem.w	d0-d3/d5/d7,-(sp)
	moveq	#0,d0
	move.b	(a0)+,d0
	bpl.B	.charok
	lea	text(pc),a0
	move.b	(a0),d0
.charok	move.w	d0,d4
	mulu	#fonty*6,d0
	lea	animarea,a2
	adda.w	d0,a2

	moveq	#0,d0
	move.b	(a1,d1.W),d0
	move.b	(a1,d2.W),d1
	ext.w	d0
	ext.w	d1
	sub.w	d1,d0
	asr.w	#2,d0
	add.w	d0,d5
	moveq	#0,d6
	move.b	(a1,d3.W),d6
	ext.w	d6
	asr.w	#1,d6
	addi.w	#76,d6		;middle y

	cmpi.b	#28,d4		;SPACE
	beq.B	.nextchar

	move.w	d5,d4
	move.w	d6,d3
	moveq	#$f,d0
	sub.w	lastx(pc),d4
	asr.w	#1,d4
	bpl.B	.qneg1
	neg.w	d4
	moveq	#$1f,d0
.qneg1	sub.w	lasty(pc),d3
	asr.w	#1,d3
	bpl.B	.qneg2
	neg.w	d3
	subq.b	#8,d0
.qneg2	cmp.w	d4,d3
	blo.B	.qcarry
	exg	d4,d3
	subq.b	#4,d0
.qcarry	lsr.w	#1,d4
	sub.w	d4,d3
	bpl.B	.qneg3
	subq.b	#2,d0
	neg.w	d3
.qneg3	lsr.w	#1,d4
	sub.w	d4,d3
	bpl.B	.qneg4
	subq.b	#1,d0
.qneg4	move.b	(a4,d0.W),d0
	andi.w	#$f,d0
	mulu	#fonty*6*28,d0
	adda.l	d0,a2
	bsr.W	print_bob

.nextchar
	move.w	d5,lastx
	move.w	d6,lasty
	movem.w	(sp)+,d0-d3/d5/d7
	addi.w	#30,d5		;x afstand
	subi.w	#22,d1
	subi.w	#31,d2
	addi.w	#36,d3
	andi.w	#$1ff,d1
	andi.w	#$1ff,d2
	andi.w	#$1ff,d3
	dbf	d7,.loop

	lea	sinpos(pc),a0
	addq.w	#5,(a0)
	addq.w	#6,2(a0)
	addq.w	#4,4(a0)
	move.w	#$1ff,d0
	and.w	d0,(a0)+
	and.w	d0,(a0)+
	and.w	d0,(a0)

	lea	scrollxadd(pc),a0
	addq.w	#2,(a0)		;scroll speed
	cmpi.w	#30,(a0)
	bne.B	.nonewchar
	clr.w	(a0)
	lea	sinpos(pc),a0
	sub.w	#22,(a0)
	sub.w	#31,2(a0)
	add.w	#36,4(a0)
	andi.w	#$1ff,(a0)+
	andi.w	#$1ff,(a0)+
	andi.w	#$1ff,(a0)+
	lea	textpointer(pc),a0
	addq.l	#1,(a0)
	move.l	(a0),a0
	tst.b	(a0)
	bpl.B	.nonewchar
	move.w	#-1,quit
.nonewchar
	rts

print_bob:
	cmpi.w	#384,d5
	bhi.B	.no1
	cmpi.w	#200,d6
	bhi.B	.no1
	move.w	d5,d0
	move.w	d6,d1
	mulu	#width,d1
	lea	(a5,d1.W),a3
	move.w	d0,d1
	lsr.w	#4,d0
	add.w	d0,d0
	adda.w	d0,a3
	andi.w	#$f,d1
	ror.w	#4,d1
	ori.w	#$0DFC,d1
	BLTW
	move.w	d1,BLTCON0(a6)
	move.l	a2,BLTAPT(a6)
	move.l	a3,BLTBPT(a6)
	move.l	a3,BLTDPT(a6)
	move.w	#fonty<<6+4,BLTSIZE(a6)
.no1
	move.w	d5,d0
	move.w	d6,d1
	subi.w	#160+[7*8],d0
	subi.w	#90,d1
	ext.l	d0
	asl.l	#8,d0
	divs	#280,d0
	ext.l	d1
	asl.l	#8,d1
	divs	#280,d1
	addi.w	#160+[7*8],d0
	addi.w	#100,d1

	cmpi.w	#384,d0
	bhi.B	.no2
	cmpi.w	#200,d1
	bhi.B	.no2
	mulu	#width,d1
	lea	(a5,d1.W),a3
	adda.w	#200*width,a3
	move.w	d0,d1
	lsr.w	#4,d0
	add.w	d0,d0
	adda.w	d0,a3
	andi.w	#$f,d1
	ror.w	#4,d1
	ori.w	#$0DFC,d1
	BLTW
	move.w	d1,BLTCON0(a6)
	move.l	a2,BLTAPT(a6)
	move.l	a3,BLTBPT(a6)
	move.l	a3,BLTDPT(a6)
	move.w	#fonty<<6+4,BLTSIZE(a6)
.no2	rts

* TASK 1 data
scrollxadd:	dc.w 0
display:	dc.l screen1,screen2
sinpos:		dc.w 0,0, 0,0
lastx		dc.w 0
lasty		dc.w 0
animdata: dc.b $12,$11,$13,$14,$17,$18,$16,$15,$1e,$00,$1f,$1d,$1a,$19,$1b,$1c

textpointer:	dc.l text
text:
 DC.B `               `
 DC.B ` AS THE GRASS IS GREEN.. SO IS THIS SCROLLER.. OG DEN DREJER RUNDT OG`
 DC.B ` OPFOERER SIG MAERKELIGT.. OG TING!! `
 DC.B $FF
 even

*
* SINUSDATA "df0:SIN256.512"
*
sinus:	DC.B	$00,$01,$03,$04,$06,$07,$09,$0A
	DC.B	$0C,$0E,$0F,$11,$12,$14,$15,$17
	DC.B	$18,$1A,$1C,$1D,$1F,$20,$22,$23
	DC.B	$25,$26,$28,$29,$2B,$2C,$2E,$2F
	DC.B	$30,$32,$33,$35,$36,$38,$39,$3A
	DC.B	$3C,$3D,$3F,$40,$41,$43,$44,$45
	DC.B	$47,$48,$49,$4A,$4C,$4D,$4E,$4F
	DC.B	$51,$52,$53,$54,$55,$57,$58,$59
	DC.B	$5A,$5B,$5C,$5D,$5E,$5F,$60,$61
	DC.B	$62,$63,$64,$65,$66,$67,$68,$69
	DC.B	$6A,$6B,$6C,$6C,$6D,$6E,$6F,$70
	DC.B	$70,$71,$72,$73,$73,$74,$75,$75
	DC.B	$76,$76,$77,$77,$78,$79,$79,$7A
	DC.B	$7A,$7A,$7B,$7B,$7C,$7C,$7C,$7D
	DC.B	$7D,$7D,$7E,$7E,$7E,$7E,$7F,$7F
	DC.B	$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
	DC.B	$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
	DC.B	$7F,$7F,$7F,$7E,$7E,$7E,$7E,$7D
	DC.B	$7D,$7D,$7C,$7C,$7C,$7B,$7B,$7A
	DC.B	$7A,$7A,$79,$79,$78,$77,$77,$76
	DC.B	$76,$75,$75,$74,$73,$73,$72,$71
	DC.B	$70,$70,$6F,$6E,$6D,$6C,$6C,$6B
	DC.B	$6A,$69,$68,$67,$66,$65,$64,$63
	DC.B	$62,$61,$60,$5F,$5E,$5D,$5C,$5B
	DC.B	$5A,$59,$58,$57,$55,$54,$53,$52
	DC.B	$51,$4F,$4E,$4D,$4C,$4A,$49,$48
	DC.B	$47,$45,$44,$43,$41,$40,$3F,$3D
	DC.B	$3C,$3A,$39,$38,$36,$35,$33,$32
	DC.B	$30,$2F,$2E,$2C,$2B,$29,$28,$26
	DC.B	$25,$23,$22,$20,$1F,$1D,$1C,$1A
	DC.B	$18,$17,$15,$14,$12,$11,$0F,$0E
	DC.B	$0C,$0A,$09,$07,$06,$04,$03,$01
	DC.B	$FF,$FE,$FC,$FB,$F9,$F8,$F6,$F5
	DC.B	$F3,$F1,$F0,$EE,$ED,$EB,$EA,$E8
	DC.B	$E7,$E5,$E3,$E2,$E0,$DF,$DD,$DC
	DC.B	$DA,$D9,$D7,$D6,$D4,$D3,$D1,$D0
	DC.B	$CF,$CD,$CC,$CA,$C9,$C7,$C6,$C5
	DC.B	$C3,$C2,$C0,$BF,$BE,$BC,$BB,$BA
	DC.B	$B8,$B7,$B6,$B5,$B3,$B2,$B1,$B0
	DC.B	$AE,$AD,$AC,$AB,$AA,$A8,$A7,$A6
	DC.B	$A5,$A4,$A3,$A2,$A1,$A0,$9F,$9E
	DC.B	$9D,$9C,$9B,$9A,$99,$98,$97,$96
	DC.B	$95,$94,$93,$93,$92,$91,$90,$8F
	DC.B	$8F,$8E,$8D,$8C,$8C,$8B,$8A,$8A
	DC.B	$89,$89,$88,$88,$87,$86,$86,$85
	DC.B	$85,$85,$84,$84,$83,$83,$83,$82
	DC.B	$82,$82,$81,$81,$81,$81,$80,$80
	DC.B	$80,$80,$80,$80,$80,$80,$80,$80
	DC.B	$80,$80,$80,$80,$80,$80,$80,$80
	DC.B	$80,$80,$80,$81,$81,$81,$81,$82
	DC.B	$82,$82,$83,$83,$83,$84,$84,$85
	DC.B	$85,$85,$86,$86,$87,$88,$88,$89
	DC.B	$89,$8A,$8A,$8B,$8C,$8C,$8D,$8E
	DC.B	$8F,$8F,$90,$91,$92,$93,$93,$94
	DC.B	$95,$96,$97,$98,$99,$9A,$9B,$9C
	DC.B	$9D,$9E,$9F,$A0,$A1,$A2,$A3,$A4
	DC.B	$A5,$A6,$A7,$A8,$AA,$AB,$AC,$AD
	DC.B	$AE,$B0,$B1,$B2,$B3,$B5,$B6,$B7
	DC.B	$B8,$BA,$BB,$BC,$BE,$BF,$C0,$C2
	DC.B	$C3,$C5,$C6,$C7,$C9,$CA,$CC,$CD
	DC.B	$CF,$D0,$D1,$D3,$D4,$D6,$D7,$D9
	DC.B	$DA,$DC,$DD,$DF,$E0,$E2,$E3,$E5
	DC.B	$E7,$E8,$EA,$EB,$ED,$EE,$F0,$F1
	DC.B	$F3,$F5,$F6,$F8,$F9,$FB,$FC,$FE



*-------------*
* ROTATE FONT *

rotate_font:
	lea	kodestykke(pc),a1	;opbyg 32*32 check bit kodeomrde
	lea	megakode,a2
	moveq	#0,d0		;fontbyte offset
	move.w	#31,d7
.copy1	moveq	#3,d6
.copy2	moveq	#7,d5
.copy3	move.l	a1,a0
	move.l	(a0)+,(a2)+
	move.w	d5,-2(a2)	;checkbit
	move.l	(a0)+,(a2)+
	move.w	d0,-4(a2)	;byte offset
	move.l	(a0)+,(a2)+
	move.w	(a0)+,(a2)+
	dbf	d5,.copy3
	addq.w	#1,d0
	dbf	d6,.copy2
	addi.w	#fontw-4,d0
	dbf	d7,.copy1
	move.w	#$4e75,(a2)+	;RTS

	move.w	#-$100,vinkel
	moveq	#15,d7
.hovedged
	move.w	d7,-(sp)

	lea	sintabel,a1			;beregn z-rot 32*32 matrix
	lea	256(a1),a2
	move.w	vinkel(pc),d0
	andi.w	#$3fe,d0
	move.w	(a1,d0.W),sincos+2
	move.w	(a1,d0.W),sincos+6
	move.w	(a2,d0.W),sincos+10
	move.w	(a2,d0.W),sincos+14
	lea	coords,a0
	move.w	#245,d2		;Z koord
	moveq	#15,d5
	moveq	#-16,d6		;Y koord
	moveq	#31,d7
.ccalc	moveq	#16,d0
	move.w	d6,d1
	bsr.W	calccoord
	moveq	#-16,d0
	move.w	d6,d1
	bsr.W	calccoord
	addq.w	#1,d6
	dbf	d7,.ccalc

	lea	coords,a0	;her beregnes de 32*32 mellemliggende x-koord
	lea	megakode,a1	;og endelige bitpos indsttes i generede kode
	move.w	#31,a2
.loop1	movem.w	(a0)+,d5/d6
	movem.w	(a0)+,d3/d4
	sub.w	d3,d5
	sub.w	d4,d6
	ext.l	d5
	ext.l	d6
	moveq	#11,d0
	asl.l	d0,d5
	asl.l	d0,d6
	swap	d3
	swap	d4
	clr.w	d3
	clr.w	d4
	moveq	#31,d2
.loop2	move.l	d3,d0
	move.l	d4,d1
	swap	d0
	swap	d1
	add.w	d1,d1		;\
	move.w	d1,d7		; \
	add.w	d1,d1		;  > D7 = D1 * 6
	add.w	d1,d7		; /
	move.w	d0,d1
	asr.w	#3,d1
	add.w	d1,d7
	not.b	d0
	movem.w	d0/d7,10(a1)
	add.l	d5,d3
	add.l	d6,d4
	adda.w	#14,a1
	dbf	d2,.loop2
	subq.w	#1,a2
	cmpa.w	#0,a2
	bne.B	.loop1

	lea	font,a3
	clr.w	charcount
	moveq	#27,d7		;28 karakterer
.drawloop
	move.l	a3,a0
	move.l	animptr(pc),a1
	jsr	megakode		;14,3 Kbytes kode!

	move.l	animptr(pc),a0		;overmal bitfejl
	BLTW
	move.l	#$0DFC1000,BLTCON0(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	clr.l	BLTAMOD(a6)
	clr.w	BLTBMOD(a6)
	move.l	a0,BLTAPT(a6)
	move.l	a0,BLTDPT(a6)
	move.l	a0,BLTBPT(a6)
	move.w	#47<<6+3,BLTSIZE(a6)
	adda.l	#fonty*6,animptr
	addq.l	#4,a3
	lea	charcount(pc),a0
	addq.w	#1,(a0)			;da fontet er forkert sat op
	cmpi.w	#10,(a0)
	bne.B	.nonxtline
	clr.w	(a0)
	adda.w	#31*40,a3
.nonxtline
	dbf	d7,.drawloop

	move.w	(sp)+,d7
	addi.w	#32,vinkel
	dbf	d7,.hovedged
	rts

calccoord:
	move.w	d1,d4
	move.w	d0,d3
sincos	muls	#0,d4
	muls	#0,d3
	muls	#0,d0
	muls	#0,d1
	sub.l	d4,d0
	add.l	d3,d1
	asr.l	d5,d0
	asr.l	d5,d1
	asl.l	#8,d0
	asl.l	#8,d1
	divs	d2,d0
	divs	d2,d1
	addi.w	#24,d0
	addi.w	#fonty/2,d1
	move.w	d0,(a0)+
	move.w	d1,(a0)+
	rts

* ROTATE data
;-----------------;
kodestykke:
 btst	#0,0(a0)
 beq.B	*+8
 bset	#0,0(a1)
;-----------------;
animptr:	dc.l animarea
charcount:	dc.w 0
vinkel:		dc.w 0

*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrbuffer:	blk.l 8,0
 even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP:
 dc.l $01800253
 dc.l $008e2861,$0090ffd1,$00920030,$009400d8
 dc.l $01000200,$01020000,$01040024
 dc.w $0108,6,$010a,6
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.l $018208e8,$018404a4,$018608e8
 dc.l $4701fffe
 dc.l $01002200
CPbpl:
 dc.w $00e0,screen1/$10000,$00e2,screen1&$ffff
 dc.w $00e4,screen1/$10000,$00e6,screen1&$ffff
 dc.l $ffe1fffe
 dc.l $0f01fffe
 dc.l $01000200
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

clear:	lsr.l	#3,d0
	moveq	#0,d1
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbf	d0,*-4
	rts

copins:	move.l	a0,d2
	swap	d2
	move.w	d2,2(a1)
	move.w	a0,6(a1)
	adda.w	d0,a0
	addq.l	#8,a1
	subq.w	#1,d1
	bne.B	copins
	rts

decruncher:
	movem.l	d2-d5/a2-a4,-(a7)
	lea	.decrunchdata(pc),a2
	lsl.w	#2,d0
	lea	.decrunchcolor(pc),a3
	move.l	(a3,d0.W),d0
	move.l	d0,a3
	moveq	#1,d5
	move.l	a1,a4
	move.l	-(a0),d1
	tst.b	d1
	beq.B	.dcr92
	bsr.B	.dcrb6
	subq.b	#1,d1
	lsr.l	d1,d5
.dcr92	lsr.l	#8,d1
	adda.l	d1,a1
.dcr96	bsr.B	.dcrb6
	bcs.B	.dcrd8
	moveq	#0,d2
.dcr9c	moveq	#1,d0
	bsr.B	.dcrc4
	add.w	d1,d2
	subq.w	#3,d1
	beq.B	.dcr9c
.dcra6	moveq	#7,d0
	bsr.B	.dcrc4
	move.b	d1,-(a1)
	dbf	d2,.dcra6
	cmpa.l	a1,a4
	bcs.B	.dcrd8
	bra.B	.dcr12
.dcrb6	lsr.l	#1,d5
	beq.B	.dcrbc
	rts
.dcrbc	move.l	-(a0),d5
	roxr.l	#1,d5
	rts
.dcrc2	subq.w	#1,d0
.dcrc4	moveq	#0,d1
.dcrc6	lsr.l	#1,d5
	beq.B	.dcrd2
.dcrca	roxl.l	#1,d1
	dbf	d0,.dcrc6
	rts
.dcrd2	move.l	-(a0),d5
	roxr.l	#1,d5
	bra.B	.dcrca
.dcrd8	moveq	#1,d0
	bsr.B	.dcrc4
	moveq	#0,d0
	move.b	(a2,d1.W),d0
	move.w	d1,d2
	subq.w	#3,d1
	bne.B	.dcrfe
	bsr.B	.dcrb6
	bcs.B	.dcree
	moveq	#7,d0
.dcree	bsr.B	.dcrc2
	move.w	d1,d3
.dcrf2	moveq	#2,d0
	bsr.B	.dcrc4
	add.w	d1,d2
	subq.w	#7,d1
	beq.B	.dcrf2
	bra.B	.dcr02
.dcrfe	bsr.B	.dcrc2
	move.w	d1,d3
.dcr02	addq.w	#1,d2
.dcr04	move.b	(a1,d3.W),-(a1)
	dbf	d2,.dcr04
	move.w	a1,(a3)
	cmpa.l	a1,a4
	bcs.B	.dcr96
.dcr12	movem.l	(a7)+,d2-d5/a2-a4
	rts
.decrunchcolor
	dc.l $dff180
	dc.l $dff182
	dc.l $dff1a2
	dc.l $dff102
	dc.l .nocolor
.nocolor: dc.w 0
.decrunchdata dc.b $09,$0a,$0b,$0b,$20,$6f,$00,$04,$70,$00,$72,$00,$78,$00,71
 even

fontcru: incbin 'DF1:rotfont.cru'
fontlength = *-fontcru

 END

