<<<<<<<<<; starwars scroller
;								TAS / aug1991


*  MEMORY MAP			FROM	TO
*  ----------			----	--
*  CODE				$20000
*  screens			$50000	$56000
*  font anims			$56000	$65000
*  code loops			$65000	$72000
*  text buffer			$72000	$75000


 INCLUDE chipmap.inc
 ORG $36C00
 LOAD $36C00

picture = $34C2C

DEMOSTARTUP = 0



ysize = 75
width = 40

screen1 = $50000
screen2 = $52000
screen3 = $54000

fontw = 53
zoomarea = $56000
kodeloop = $65000

txty = 20
txtarea = $72000
txtsize = 17*40*txty


*------------------*
* START UP PROGRAM *

s:

;;
;; HUSK DETTE NR DEMOEN SKAL STARTES OP !!!!!!!!!!!!
;;
	 IFEQ DEMOSTARTUP
	moveq	#0,d0
	 ENDC
	move.w	d0,modus

	clr.l	$0.W
	lea	DMA,a6
	move.w	#$128,d0
	bsr.W	RC
	 IFEQ DEMOSTARTUP
	move.l	INTENAR(a6),intregs
	move.l	#$7fff7fff,INTENA(a6)
	move.w	#$01b0,DMACON(a6)		;ikke slukke skrmen
	move.w	#$0200,$100(a6)
	 ENDC

	tst.w	modus
	beq.B	.straight
	move.w	#$01b0,DMACON(a6)
	move.w	#$0200,$100(a6)
.straight
	clr.w	$180(a6)

	lea	screen1,a0
	move.l	#[screen2-screen1]*3,d0
	bsr.W	fill
	lea	txtarea,a0
	move.l	#$4000,d0
	bsr.W	fill

	bsr.W	zoom
	bsr.W	buildloops

	clr.l	sinpos
	clr.l	disppos
	clr.w	scrollwait
	move.w	#-1,txtpos
	move.w	#txty-1,txtpos+2
	move.w	#$120,d0
	bsr.W	RC

	tst.w	modus
	bne.S	.mode2
	lea	maintxt(pc),a0
	move.l	a0,txtptr
	move.l	a0,txtptr+4
	move.l	#copptrs1,hent_ptr
	move.l	#CP1,$80(a6)
	bra.B	.okmode

.mode2	lea	hiddentxt(pc),a0
	move.l	a0,txtptr
	move.l	a0,txtptr+4
	move.l	#copptrs2,hent_ptr
	move.l	#CP2,$80(a6)
	lea	farver(pc),a0
	move.l	#$8001fffe,d0
	moveq	#ysize-1,d7
.lop	move.l	d0,(a0)+
	move.l	#$01820000,(a0)+
	addi.l	#$01000000,d0
	dbf	d7,.lop
.okmode
	move.w	#$83f0,DMACON(a6)
	 IFNE DEMOSTARTUP
	move.w	#$c020,INTENA(a6)
	 ENDC

*-----------------------*
*	MAIN LOOP	*

ML:	move.w	#$120,d0
	bsr.W	RC
	bsr.S	scroll
	bsr.W	printfont
	bsr.W	printfont
	btst	#6,$bfe001
	bne.B	ML

	 IFNE DEMOSTARTUP
	bra.W	ML
	 ELSE
	moveq	#0,d0
	rts
	 ENDC


*----------------------------
* TASK 1 - starwars scroller

scroll:	lea	display(pc),a0
	movem.l	(a0),d4/d5
	movem.l	8(a0),d0-d3
	movem.l	d0-d5,(a0)

	move.l	hent_ptr(pc),a0
	move.w	d4,6(a0)
	swap	d4
	move.w	d4,2(a0)

	bsr.W	BLTW
	move.l	#$01000000,BLTCON0(a6)
	clr.w	BLTDMOD(a6)
	moveq	#-1,d0
	move.l	d0,BLTAFWM(a6)
	move.l	d2,BLTDPT(a6)
	move.w	#160*64+20,BLTSIZE(a6)

	lea	disppos(pc),a0
	adda.l	#40,(a0)
	cmpa.l	#txtsize,(a0)
	blo.S	.norestore
	clr.l	(a0)
.norestore:
	move.l	(a0),d0

	tst.w	modus
	bne.s	mode2

	lea	txtarea,a0
	adda.l	d0,a0
	move.l	display(pc),a2
	lea	loop_ptrs+640(pc),a5
	lea	textadd(pc),a6
	moveq	#width,d5
	move.l	#txtarea+txtsize,d6
	move.w	#159,d7
	moveq	#0,d0
.loop	move.l	-(a5),a4
	jsr	(a4)
	adda.w	d5,a2
	adda.w	(a6)+,a0
	cmpa.l	d6,a0
	blo.S	.nores
	suba.w	#txtsize,a0
.nores	dbf	d7,.loop
	lea	DMA,a6
	rts

mode2:	move.l	d0,-(sp)

	lea	txtarea,a0
	adda.l	(sp)+,a0
	move.l	display(pc),a2
	lea	sinpointers(pc),a5
	moveq	#width,d5
	move.l	#txtarea+txtsize,d6
	moveq	#ysize-1,d7
	moveq	#0,d0
.loop	move.l	(a5)+,a4
	jsr	(a4)
	adda.w	d5,a2
	cmpa.l	d6,a0
	blo.S	.nores
	suba.w	#txtsize,a0
.nores	dbf	d7,.loop
	lea	DMA,a6

	lea	loop_ptrs(pc),a0
	lea	sinpointers(pc),a1
	lea	xsin(pc),a2
	lea	colors(pc),a3
	lea	farver(pc),a4
	moveq	#ysize-1,d7
	movem.w	sinpos(pc),d0/d1
.sinins	moveq	#0,d2
	moveq	#0,d3
	move.b	(a2,d0.W),d2
	move.b	(a2,d1.W),d3
	add.w	d3,d2
	lsr.w	#1,d2
	lsl.w	#2,d2
	move.l	(a0,d2.W),(a1)+
	lsr.w	#6,d2
	add.w	d2,d2
	move.w	(a3,d2.W),6(a4)
	addq.l	#8,a4
	addq.b	#1,d0
	subq.b	#2,d1
	dbf	d7,.sinins
	subq.b	#2,sinpos+1
	subq.b	#3,sinpos+3
	rts

* TASK 1 data
disppos:	dc.l 0
display:
	dc.l screen1,0
	dc.l screen2,0
	dc.l screen3,0

colors:
	dc.w $fff,$eee,$ddd,$ccc,$bbb,$aaa,$999,$888
	dc.w $777,$666,$555,$444,$333,$222,$111,$000
hent_ptr:	dc.l 0
sinpos:		dc.w 0,0
modus:		dc.w 0
sinpointers:	blk.l 80,kodeloop

textadd:
a=0
b=40
c=80
d=120
 dc.w d,d,c,d,d,c,d,d,c,c,d,c,c,d,c,c
 dc.w d,c,c,c,c,c,b,c,b,c,c,b,c,c,b,b
 dc.w c,b,b,c,b,b,c,b,b,b,c,b,b,b,c,b
 dc.w b,b,c,b,b,b,b,b,b,b,a,b,b,b,b,a,b,b
 dc.w b,b,b,a,b,b,b,a,b,b,b,a,b,b,b
 dc.w a,b,b,a,b,b,a,b,a,b,a,b,a,b,a
 dc.w b,a,b,a,b,a
 dc.w b,a,a,b,a,a,b,a,a,b,a,a,a
 dc.w b,a,a,a,b,a,a,a,b,a,a,a,a
 dc.w b,a,a,a,a,a,a,b,a,a,a,a,a,a
 blk.w 20,a


*
* SINUSDATA "df0:SIN140.256"
*
xsin:
 DC.B $46,$47,$49,$4B,$4C,$4E,$50,$51,$53,$55,$57,$58,$5A,$5B,$5D
 DC.B $5F,$60,$62,$63,$65,$66,$68,$69,$6B,$6C,$6E,$6F,$71,$72,$73
 DC.B $75,$76,$77,$78,$79,$7B,$7C,$7D,$7E,$7F,$80,$81,$82,$82,$83
 DC.B $84,$85,$85,$86,$87,$87,$88,$88,$89,$89,$8A,$8A,$8A,$8B,$8B
 DC.B $8B,$8B,$8B,$8B,$8B,$8B,$8B,$8B,$8B,$8B,$8B,$8A,$8A,$8A,$89
 DC.B $89,$88,$88,$87,$87,$86,$85,$85,$84,$83,$82,$82,$81,$80,$7F
 DC.B $7E,$7D,$7C,$7B,$79,$78,$77,$76,$75,$73,$72,$71,$6F,$6E,$6C
 DC.B $6B,$69,$68,$66,$65,$63,$62,$60,$5F,$5D,$5B,$5A,$58,$57,$55
 DC.B $53,$51,$50,$4E,$4C,$4B,$49,$47,$45,$44,$42,$40,$3F,$3D,$3B
 DC.B $3A,$38,$36,$34,$33,$31,$30,$2E,$2C,$2B,$29,$28,$26,$25,$23
 DC.B $22,$20,$1F,$1D,$1C,$1A,$19,$18,$16,$15,$14,$13,$12,$10,$0F
 DC.B $0E,$0D,$0C,$0B,$0A,$09,$09,$08,$07,$06,$06,$05,$04,$04,$03
 DC.B $03,$02,$02,$01,$01,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00
 DC.B $00,$00,$00,$00,$01,$01,$01,$02,$02,$03,$03,$04,$04,$05,$06
 DC.B $06,$07,$08,$09,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10,$12,$13,$14
 DC.B $15,$16,$18,$19,$1A,$1C,$1D,$1F,$20,$22,$23,$25,$26,$28,$29
 DC.B $2B,$2C,$2E,$30,$31,$33,$34,$36,$38,$3A,$3B,$3D,$3F,$40,$42
 DC.B $44

*---------------------
* TASK 2 - print font

printfont:
	lea	scrollwait(pc),a0
	addq.w	#1,(a0)
	cmpi.w	#17*2,(a0)
	bne.S	.nores
	clr.w	(a0)
.nores	cmpi.w	#20,(a0)
	blo.S	noprint
	rts
noprint:

	lea	txtpos(pc),a0
	addq.w	#1,(a0)
	cmpi.w	#20,(a0)
	bne.S	.nores
	clr.w	(a0)
	addq.w	#1,2(a0)
	cmpi.w	#txty,2(a0)
	bne.S	.nores
	clr.w	2(a0)
.nores
	lea	txtarea,a1
	movem.w	(a0),d0/d1
	add.w	d0,d0
	mulu	#17*40,d1
	adda.w	d0,a1
	adda.l	d1,a1

	move.l	txtptr(pc),a0
.gettxt	moveq	#0,d0
	move.b	(a0)+,d0
	bpl.S	.notxtres
	move.l	txtptr+4(pc),a0
	bra.S	.gettxt
.notxtres
	move.l	a0,txtptr
	subi.b	#' ',d0
	lsl.w	#4,d0
	lea	font(pc),a0
	adda.w	d0,a0

	addq.l	#1,a1
	move.w	#160,d0
	moveq	#3,d7		;copy 16 bytes
.loop	move.b	(a0)+,(a1)
	move.b	(a0)+,40(a1)
	move.b	(a0)+,80(a1)
	move.b	(a0)+,120(a1)
	adda.w	d0,a1
	dbf	d7,.loop
	rts

* FONT PRINT data
scrollwait:	dc.w 0
txtpos:		dc.w -1,txty-1
txtptr:		dc.l 0,0

maintxt:
 DC.B "      THE END       "
 BLK.B 2*20," "
 DC.B "  WE MUST SAY THAT  "
 DC.B " THIS DEMO HAS COME "
 DC.B " TO A RATHER SUDDEN "
 DC.B "        END.        "
 BLK.B 60," "
 DC.B "                    "
 DC.B "                    "
 DC.B " LET US HAVE A FULL "
 DC.B "   CREDIT-LIST:     "
 DC.B "                    "
 DC.B "--------------------"
 DC.B "                    "
 DC.B "VECTOR WEB,         "
 DC.B "SHADE BOBS,         "
 DC.B "TEXT WRITER,        "
 DC.B "VECTOR WALL,        "
 DC.B "PLASMA LIFE         "
 DC.B "         BY GARGOYLE"
 DC.B "                    "
 DC.B "DOT WORLD,          "
 DC.B "STAR WARS,          "
 DC.B "CUBESCROLL,         "
 DC.B "STAR FIELD,         "
 DC.B "AND OTHER STUFF     "
 DC.B "              BY TAS"
 DC.B "                    "
 DC.B "--------------------"
 DC.B "                    "
 DC.B "DESIGN AND IDEAS  BY"
 DC.B " GARGOYLE AND SLIDE "
 DC.B "                    "
 DC.B "--------------------"
 DC.B "                    "
 DC.B "DRAGON LOGO,        "
 DC.B "ENDPART LOGO,       "
 DC.B "ZYCLONIUM LOGO      "
 DC.B "           BY SPLATT"
 DC.B "                    "
 DC.B "DRAGON LOGO,        "
 DC.B "GREEN BORDERS,      "
 DC.B "ROTATESCROLL LOGO   "
 DC.B "           BY EASLEY"
 DC.B "                    "
 DC.B "CRYSTALS,           "
 DC.B "BLUE PARASITE LOGO  "
 DC.B "             BY DINO"
 DC.B "                    "
 DC.B "--------------------"
 DC.B "                    "
 DC.B " THE MUSIC  YOU ARE "
 DC.B "   LISTNING TO IS   "
 DC.B "CREATED BY OUR GREAT"
 DC.B "      MUSICIAN      "
 DC.B "                    "
 DC.B "       SLIDE!       "
 DC.B "                    "
 DC.B "  AND IT IS CALLED  "
 DC.B "    'MESMERIZED'    "
 DC.B "                    "
 DC.B "--------------------"
 BLK.B 80," "
 DC.B "MEMBERS OF PARASITE:"
 DC.B "                    "
 DC.B "        DINO        "
 DC.B "       DOCTOR       "
 DC.B "        DUFF        "
 DC.B "       EASLEY       "
 DC.B "      GARGOYLE      "
 DC.B "       LIQUID       "
 DC.B "       MOUNT        "
 DC.B "     NUT WELIN      "
 DC.B "       RAISE        "
 DC.B "      SHAYERA       "
 DC.B "       SLIDE        "
 DC.B "       SOLID        "
 DC.B "       SPEEDY       "
 DC.B "       SPLATT       "
 DC.B "        TAS         "
 DC.B "    THE WHISTLE     "
 BLK.B 100," "
 DC.B "   IF YOU HAVEN'T   "
 DC.B " FIGURED IT OUT YET "
 DC.B "  THEN PERHAPS WE   "
 DC.B "SHOULD TELL YOU  HOW"
 DC.B "TO WATCH  THE HIDDEN"
 DC.B " PARTS IN THIS DEMO "
 DC.B "                    "
 DC.B "  OR SHOULD WE....  "
 DC.B "                    "
 DC.B "  WELL, ALL WE CAN  "
 DC.B " TELL - IS THAT YOU "
 DC.B " SHOULD TRY HOLDING "
 DC.B " DOWN SOME  KEYS TO "
 DC.B "  SEE IF SOMETHING  "
 DC.B "      HAPPENS.      "
 blk.b 100," "
 DC.B "- - - - - - - - - - "
 DC.B "GREETINGS FLY OUT TO"
 DC.B "                    "
 DC.B "     ABSOLUTE       "
 DC.B "     ANGELICA       "
 DC.B "      ADDONIC       "
 DC.B "     ALCATRAZ       "
 DC.B "      ANARCHY       "
 DC.B "     ANDROMEDA      "
 DC.B "      ARCANE        "
 DC.B "     BUDBRAIN       "
 DC.B "      COMPLEX       "
 DC.B "   CRYBTOBURNERS    "
 DC.B "       CULT         "
 DC.B "       DAI          "
 DC.B "      DAMIAN        "
 DC.B "      DEVILS        "
 DC.B "     DUAL CREW      "
 DC.B "      FRAXION       "
 DC.B "        HLF         "
 DC.B "      INZZEST       "
 DC.B "      KEFRENS       "
 DC.B "  MAGNETIC FIELDS   "
 DC.B "       MAJIC        "
 DC.B "    MELON DEZIGN    "
 DC.B "       MENACE       "
 DC.B "      NILLION       "
 DC.B "       NITRO        "
 DC.B "      OFFWORLD      "
 DC.B "       PALACE       "
 DC.B "       PENEMY       "
 DC.B "        RAGE        "
 DC.B "       RAZOR        "
 DC.B "       REBELS       "
 DC.B "       SANITY       "
 DC.B "      SCOOPEX       "
 DC.B "      SILENTS       "
 DC.B "      SKID ROW      "
 DC.B "     SLIPSTREAM     "
 DC.B "    STATIC BYTES    "
 DC.B "      STELLAR       "
 DC.B "        TECH        "
 DC.B "        TEK         "
 DC.B "        TRSI        "
 DC.B "      TRIANGLE      "
 DC.B "     UPSTREAM HQ    "
 DC.B "       VISION       "
 DC.B "      WARPIGS       "
 DC.B "      X-TRADE       "
 DC.B "                    "
 DC.B " WE ARE VERY SORRY, "
 DC.B "   THIS IS A VERY   "
 DC.B "  UNCOMPLETED LIST  "
 DC.B "  SO WE GREET ALL   "
 DC.B " THAT KNOW WE WOULD "
 DC.B "HAVE GREETED THEM!!!"
 DC.B "                    "
 DC.B "- - - - - - - - - - "
 DC.B "                    "
 DC.B "INFO ABOUT DEMO:    "
 DC.B "                    "
 DC.B "  RUNS WITH ONLY A  "
 DC.B "HALF MEGABYTE OF RAM"
 DC.B "   IN ONE FILE!!!   "
 DC.B "                    "
 DC.B "- - - - - - - - - - "
 BLK.B 100," "
 DC.B "   THIS  SCROLLER   "
 DC.B "IS OVER NOW........."
 DC.B " BUT WE  WILL LEAVE "
 DC.B " YOU WITH THE MUSIC "
 DC.B " AND A RERUN OF THE "
 DC.B "    SCROLLTEXT.     "
 BLK.B 80," "
 DC.B "                 BYE"
 blk.b 200," "
 DC.B $FF

hiddentxt:
 DC.B "  SAY, THIS IS THE  "
 DC.B " SECOND HIDDEN PART "
 DC.B "    IN THIS DEMO    "
 BLK.B 20," "
 DC.B " I HOPE THIS BLOODY "
 DC.B "SHIT WORKS PROBERLY!"
 BLK.B 40," "
 DC.B "    IT WAS QUITE    "
 DC.B " DIFFICULT TO CRAM  "
 DC.B "   ALL THIS ON AN   "
 DC.B "   ORDINARY AMIGA   "
 DC.B "  WITHOUT A MEMORY  "
 DC.B " EXPANSION - BUT WE "
 DC.B "     DID IT !!      "
 BLK.B 40," "
 DC.B "  NO PUNISHER LANG  "
 DC.B " TEKST DENNE GANG!! "
 BLK.B 20," "
 DC.B " JEG GIDER SIMPELT  "
 DC.B "IKKE SKRIVE ALT DET "
 DC.B "     GED NU.        "
 BLK.B 20," "
 DC.B " DESUDEN KAN MAN JO "
 DC.B "  SLET IKKE LAESE   "
 DC.B "     DET HER...     "
 BLK.B 40," "
 DC.B "  I SKULLE TAGE OG  "
 DC.B "   LYTTE LIDT TIL   "
 DC.B "     MUZAKKEN,      "
 BLK.B 20," "
 DC.B " HAM SLIDE ER BARE  "
 DC.B "     MEGA-GO'.      "
 BLK.B 40," "
 DC.B " 'DET ER IKKE SAA   "
 DC.B " SVAERT, NAAR MAN   "
 DC.B " FOERST  FAAR DET   "
 DC.B "   LAERT......'     "
 BLK.B 20," "
 DC.B "  TRA LA LA LA LAJ  "
 DC.B "   TRA LI LA LAJ    "
 DC.B " TRA LA LAJ LA LAJ  "
 BLK.B 40," "
 DC.B "       HILSENER  FRA"
 DC.B "     TAS OG GARGOYLE"
 DC.B "            PARASITE"
 BLK.B 120," "
 DC.B $FF
 even

*--------*
*  DATA  *
*--------*
intregs:	ds.w 2
clrregs:	blk.l 8,0
even

*-------------------------*
*	COPPER-LIST	  *
*-------------------------*
CP1:
 dc.l $01800000
 dc.l $008e2881,$009028c1
 dc.l $00920038,$009400d0
 dc.l $01000200
 dc.l $01020000
 dc.l $01040024
 dc.l $01080000,$010a0000
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000

 dc.l $3801fffe,$01003200
 dc.w $00e0,picture/$10000
 dc.w $00e2,picture&$ffff
 dc.w $00e4,picture/$10000
 dc.w $00e6,picture&$ffff+[64*40]
 dc.w $00e8,picture/$10000
 dc.w $00ea,picture&$ffff+[64*40*2]
 dc.w $0180,$000
 dc.w $0182,$016
 dc.w $0184,$003
 dc.w $0186,$bdf
 dc.w $0188,$8ad
 dc.w $018a,$57b
 dc.w $018c,$24a
 dc.w $018e,$028

 dc.l $7801fffe
 dc.l $01000200
copptrs1
 dc.l $00e00000+[screen1/$10000],$00e20000+[screen1&$ffff]
 dc.l $01820fff
 dc.l $9001fffe,$01001200

 dc.l $9001fffe,$01820111
 dc.l $9101fffe,$01820222
 dc.l $9301fffe,$01820333
 dc.l $9601fffe,$01820444
 dc.l $9b01fffe,$01820555
 dc.l $a101fffe,$01820666
 dc.l $a801fffe,$01820777
 dc.l $b101fffe,$01820888
 dc.l $ba01fffe,$01820999
 dc.l $c501fffe,$01820AAA
 dc.l $d001fffe,$01820BBB
 dc.l $dc01fffe,$01820CCC
 dc.l $e901fffe,$01820DDD
 dc.l $f601fffe,$01820EEE
 dc.l $ffe1fffe
 dc.l $0201fffe,$01820FFF

 dc.l $2001fffe,$01000200
 dc.l $fffffffe

CP2:
 dc.l $01800000
 dc.l $008e2881,$009030c1
 dc.l $00920038,$009400d0
 dc.l $01000200
 dc.l $01020000
 dc.l $01040024
 dc.l $01080000,$010a0000
 dc.l $01200000,$01220000,$01240000,$01260000
 dc.l $01280000,$012a0000,$012c0000,$012e0000
 dc.l $01300000,$01320000,$01340000,$01360000
 dc.l $01380000,$013a0000,$013c0000,$013e0000
copptrs2
 dc.l $00e00000+[screen1/$10000],$00e20000+[screen1&$ffff]
 dc.l $01820fff
 dc.l $7001fffe,$01800121
 dc.l $7101fffe,$01800232
 dc.l $7201fffe,$01800353
 dc.l $7301fffe,$01800474
 dc.l $7401fffe,$01800595
 dc.l $7501fffe,$018006b6
 dc.l $7601fffe,$018007d7
 dc.l $7701fffe,$018007f7
 dc.l $7801fffe,$018007f7
 dc.l $7901fffe,$018007d7
 dc.l $7a01fffe,$018006b6
 dc.l $7b01fffe,$01800595
 dc.l $7c01fffe,$01800474
 dc.l $7d01fffe,$01800353
 dc.l $7e01fffe,$01800232
 dc.l $7f01fffe,$01800000

 dc.l $8001fffe,$01001200
farver: ds.l [ysize*2]
 dc.l $cb01fffe,$01000200
 dc.l $01800000
 dc.l $cc01fffe,$01800232
 dc.l $cd01fffe,$01800353
 dc.l $ce01fffe,$01800474
 dc.l $cf01fffe,$01800595
 dc.l $d001fffe,$018006b6
 dc.l $d101fffe,$018007d7
 dc.l $d201fffe,$018007f7
 dc.l $d301fffe,$018007f7
 dc.l $d401fffe,$018007d7
 dc.l $d501fffe,$018006b6
 dc.l $d601fffe,$01800595
 dc.l $d701fffe,$01800474
 dc.l $d801fffe,$01800353
 dc.l $d901fffe,$01800232
 dc.l $da01fffe,$01800121
 dc.l $dB01fffe,$01800000
 dc.l $fffffffe


*-------------*
* SUBROUTINES *
*-------------*
RC:
;	move.w	#$a00,$180(a6)
	move.l	$4(a6),d1
	lsr.l	d1
	lsr.w	#7,d1
	cmpi.w	d0,d1
	bne.B	RC
;	clr.w	$180(a6)
	rts

BLTW:	btst	#14,$2(a6)
	bne.B	BLTW
	rts

fill:	clr.l	(a0)+
	clr.l	(a0)+
	subq.l	#8,d0
	bpl.B	fill
	rts

copins	move.l	a1,d1
	swap	d1
	move.w	d1,2(a0)
	move.w	a1,6(a0)
	adda.w	d2,a1
	addq.l	#8,a0
	subq.w	#1,d7
	bne.S	copins
	rts


*-------------*
* BUILD LOOPS *

buildloops:
	lea	kodeloop,a0
	lea	loop_ptrs(pc),a5
	move.w	#159,d7
	move.l	#3200,d4
	move.l	#-32000,d5
.loop1	move.l	a0,(a5)+
	sub.l	a4,a4

	move.l	d5,d0
	divs	#200,d0
	addi.w	#160,d0
	move.w	d0,lastcalc

	move.l	d5,d0
	moveq	#19,d6
.loop2	add.l	d4,d0

	movem.l	d0-d5,-(sp)
	move.w	#$3018,(a0)+		;MOVE.W	(A0)+,D0
	divs	#200,d0
	addi.w	#160,d0
	move.w	d0,d1
	move.w	d0,d2
	lea	zoomarea,a1
	move.w	lastcalc(pc),d0
	andi.w	#$f,d0
	mulu	#fontw*4*16,d0
	adda.l	d0,a1
	sub.w	lastcalc(pc),d1
	beq.S	.noprint
	moveq	#16,d0
	sub.w	d1,d0
	mulu	#fontw*4,d0
	adda.l	d0,a1

	move.w	lastcalc(pc),d0
	move.w	d2,lastcalc
	lsr.w	#4,d0
	lsl.w	#1,d0

	cmpa.l	a1,a4
	beq.S	.thesame
	move.w	#$43f9,(a0)+		;LEA	??,a1
	move.l	a1,(a0)+
	move.l	a1,a4
.thesame
	move.l	#$20310000,(a0)+	;MOVE.L $00(A1,D0.W),D0
	move.w	#$81aa,(a0)+		;OR.L	D0,??(A2)
	move.w	d0,(a0)+
.noprint
	movem.l	(sp)+,d0-d5
	dbf	d6,.loop2

	move.w	#$4e75,(a0)+		:RTS
	subi.l	#20,d4
	addi.l	#200,d5
	dbf	d7,.loop1
	rts

lastcalc:	dc.w 0
loop_ptrs:	ds.l 160


*-----------*
* ZOOM FONT *

zoom:	lea	zoomarea,a0
	move.l	#$10000,d0
	bsr.W	fill

	lea	zoomarea,a1				;zoom fontwords
	move.w	#$FFFF,d0
	moveq	#0,d7
.tabelzoom1
	move.w	#$7FFF,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#15,d6
.tabelzoom2
	add.w	d0,d1
	bcc.S	.nozoomnow1

	movem.l	d0-d3/a0-a1,-(sp)
	lea	fontwords(pc),a0
	cmp.w	#8,d2
	blo.S	.no1
	addq.l	#1,a0
.no1	cmp.w	#8,d3
	blo.S	.no2
	addq.l	#1,a1
.no2
	not.b	d2
	not.b	d3
	moveq	#fontw-1,d0
.zoom	btst	d2,(a0)
	beq.S	.nodot
	bset	d3,(a1)
.nodot	addq.l	#2,a0
	addq.l	#4,a1
	dbf	d0,.zoom
	movem.l	(sp)+,d0-d3/a0-a1
	addq.w	#1,d3
.nozoomnow1
	addq.w	#1,d2
	dbf	d6,.tabelzoom2
	adda.w	#fontw*4,a1
	subi.w	#4096,d0
	addq.w	#1,d7
	cmpi.w	#16,d7
	bne.W	.tabelzoom1

	lea	zoomarea,a0			;copy shift fonts
	move.l	a0,a1
	adda.w	#fontw*4*16,a1
	move.w	#[fontw*16*16]-1,d7
.copy1	move.l	(a0)+,d0
	lsr.l	#1,d0
	move.l	d0,(a1)+
	dbf	d7,.copy1
	rts


fontwords:		; antal = 53
	DC.W	$0000,$001E,$00FC,$0100,$01F8,$0380,$03C0,$03F0
	DC.W	$0780,$07C0,$07E0,$07FE,$0FC0,$0FE0,$0FF0,$1C70
	DC.W	$1EF0,$1F80,$1FF8,$3838,$3C78,$3E7C,$3F00,$783C
	DC.W	$7C3E,$7E00,$7FFE,$E006,$F000,$F00E,$F01E,$F03C
	DC.W	$F03E,$F07C,$F07E,$F0DE,$F0F8,$F0FE,$F11E,$F1F0
	DC.W	$F39E,$F3E0,$F7C0,$F7DE,$F81E,$FC3E,$FE7E,$FF00
	DC.W	$FF80,$FFF8,$FFFA,$FFFC,$FFFE

font:	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$20,$20,$20,$20,$20,$20,$20,$20
	DC.B	$20,$20,$20,$00,$20,$20,$20,$20
	blk.b 10*8,$00
	DC.B	$20,$20,$20,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$2C,$2C,$2C,$2C,$20,$20,$20,$20
	DC.B	$20,$20,$20,$20,$2C,$2C,$2C,$2C
	DC.B	$C0,$C0,$C0,$C0,$20,$20,$20,$20
	DC.B	$20,$20,$20,$20,$C0,$C0,$C0,$C0
	blk.b 5*8,$00
	DC.B	$00,$00,$00,$00,$20,$20,$20,$14
	DC.B	$00,$00,$00,$00,$00,$00,$D0,$D0
	DC.B	$D0,$D0,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$20,$20,$20,$20
	blk.b 22*8,$00
	DC.B	$00,$00,$00,$20,$20,$20,$20,$00
	DC.B	$00,$20,$20,$20,$20,$00,$00,$00
	DC.B	$00,$00,$00,$20,$20,$20,$20,$00
	DC.B	$00,$20,$20,$20,$20,$14,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0
	DC.B	$00,$00,$00,$00,$00,$00,$20,$20
	DC.B	$20,$20,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$00,$00,$00,$00,$00,$00,$00,$00
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$78,$D0,$D0,$D0,$D0,$78,$78,$78
	DC.B	$D0,$D0,$D0,$D0,$80,$80,$80,$CC
	DC.B	$C4,$CC,$80,$80,$80,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$70,$70,$70,$70
	DC.B	$70,$70,$70,$70,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$78,$78,$78,$78,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$70,$70,$C0,$C0
	DC.B	$C0,$C0,$70,$70,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$70,$70,$C0,$C0
	DC.B	$C0,$C0,$70,$70,$70,$70,$70,$70
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$70,$70
	DC.B	$94,$94,$94,$78,$D0,$D0,$D0,$D0
	DC.B	$78,$78,$78,$78,$78,$78,$D0,$D0
	DC.B	$D0,$D0,$78,$78,$78,$78,$78,$78
	DC.B	$68,$68,$68,$68,$18,$18,$18,$18
	DC.B	$18,$18,$18,$18,$68,$68,$68,$68
	DC.B	$04,$04,$04,$04,$04,$04,$04,$04
	DC.B	$78,$78,$78,$78,$D0,$D0,$D0,$D0
	DC.B	$80,$84,$90,$9C,$A4,$A8,$C0,$BC
	DC.B	$BC,$C0,$A8,$A4,$9C,$90,$84,$80
	DC.B	$70,$70,$70,$70,$70,$70,$70,$70
	DC.B	$70,$70,$70,$70,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$A0,$A0,$A0,$A0
	DC.B	$A0,$78,$78,$78,$78,$78,$78,$78
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$78,$78,$78,$78,$78,$78,$78,$78
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$78,$78,$78,$78,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$D0,$D0,$D0,$D0,$70,$70,$70,$70
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$78,$8C,$88,$80,$D0,$CC,$D0,$C8
	DC.B	$D0,$D0,$D0,$D0,$78,$78,$78,$78
	DC.B	$D0,$D0,$C4,$C4,$84,$7C,$78,$78
	DC.B	$D0,$D0,$D0,$D0,$70,$70,$D0,$D0
	DC.B	$D0,$D0,$04,$04,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$20,$20,$20,$20
	DC.B	$20,$20,$20,$20,$20,$20,$20,$20
	DC.B	$78,$78,$78,$78,$78,$78,$78,$78
	DC.B	$78,$78,$78,$78,$D0,$D0,$D0,$D0
	DC.B	$78,$78,$5C,$5C,$4C,$50,$3C,$40
	DC.B	$40,$34,$34,$24,$24,$14,$14,$0C
	DC.B	$78,$78,$78,$78,$78,$78,$98,$A0
	DC.B	$A0,$A0,$AC,$D0,$D0,$B8,$B4,$B0
	DC.B	$74,$B0,$60,$54,$48,$38,$28,$18
	DC.B	$28,$38,$48,$54,$60,$B0,$74,$6C
	DC.B	$78,$78,$78,$78,$78,$78,$D0,$D0
	DC.B	$D0,$D0,$04,$04,$D0,$D0,$D0,$D0
	DC.B	$D0,$D0,$D0,$D0,$08,$10,$1C,$28
	DC.B	$30,$44,$58,$64,$D0,$D0,$D0,$D0

 END
